// python wrapper for vtkBoxMuellerRandomSequence
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkBoxMuellerRandomSequence.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkBoxMuellerRandomSequence(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkBoxMuellerRandomSequence_ClassNew(); }

#ifndef DECLARED_PyvtkGaussianRandomSequence_ClassNew
extern "C" { PyObject *PyvtkGaussianRandomSequence_ClassNew(); }
#define DECLARED_PyvtkGaussianRandomSequence_ClassNew
#endif

static const char **PyvtkBoxMuellerRandomSequence_Doc();


static PyObject *
PyvtkBoxMuellerRandomSequence_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkBoxMuellerRandomSequence *op = static_cast<vtkBoxMuellerRandomSequence *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkBoxMuellerRandomSequence::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkBoxMuellerRandomSequence_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkBoxMuellerRandomSequence *op = static_cast<vtkBoxMuellerRandomSequence *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkBoxMuellerRandomSequence::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkBoxMuellerRandomSequence_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkBoxMuellerRandomSequence *op = static_cast<vtkBoxMuellerRandomSequence *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkBoxMuellerRandomSequence *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkBoxMuellerRandomSequence::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkBoxMuellerRandomSequence_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkBoxMuellerRandomSequence *tempr = vtkBoxMuellerRandomSequence::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkBoxMuellerRandomSequence_GetValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkBoxMuellerRandomSequence *op = static_cast<vtkBoxMuellerRandomSequence *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetValue() :
      op->vtkBoxMuellerRandomSequence::GetValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkBoxMuellerRandomSequence_Next(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Next");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkBoxMuellerRandomSequence *op = static_cast<vtkBoxMuellerRandomSequence *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Next();
    }
    else
    {
      op->vtkBoxMuellerRandomSequence::Next();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkBoxMuellerRandomSequence_GetUniformSequence(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetUniformSequence");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkBoxMuellerRandomSequence *op = static_cast<vtkBoxMuellerRandomSequence *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkRandomSequence *tempr = (ap.IsBound() ?
      op->GetUniformSequence() :
      op->vtkBoxMuellerRandomSequence::GetUniformSequence());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkBoxMuellerRandomSequence_SetUniformSequence(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUniformSequence");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkBoxMuellerRandomSequence *op = static_cast<vtkBoxMuellerRandomSequence *>(vp);

  vtkRandomSequence *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkRandomSequence"))
  {
    if (ap.IsBound())
    {
      op->SetUniformSequence(temp0);
    }
    else
    {
      op->vtkBoxMuellerRandomSequence::SetUniformSequence(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkBoxMuellerRandomSequence_Methods[] = {
  {"GetClassName", PyvtkBoxMuellerRandomSequence_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkBoxMuellerRandomSequence_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkBoxMuellerRandomSequence_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkBoxMuellerRandomSequence\nC++: vtkBoxMuellerRandomSequence *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkBoxMuellerRandomSequence_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkBoxMuellerRandomSequence\nC++: vtkBoxMuellerRandomSequence *SafeDownCast(vtkObject* o)\n\n"},
  {"GetValue", PyvtkBoxMuellerRandomSequence_GetValue, METH_VARARGS,
   "V.GetValue() -> float\nC++: double GetValue()\n\nCurrent value.\n"},
  {"Next", PyvtkBoxMuellerRandomSequence_Next, METH_VARARGS,
   "V.Next()\nC++: void Next()\n\nMove to the next number in the random sequence.\n"},
  {"GetUniformSequence", PyvtkBoxMuellerRandomSequence_GetUniformSequence, METH_VARARGS,
   "V.GetUniformSequence() -> vtkRandomSequence\nC++: vtkRandomSequence *GetUniformSequence()\n\nReturn the uniformly distributed sequence of random numbers.\n"},
  {"SetUniformSequence", PyvtkBoxMuellerRandomSequence_SetUniformSequence, METH_VARARGS,
   "V.SetUniformSequence(vtkRandomSequence)\nC++: void SetUniformSequence(vtkRandomSequence *uniformSequence)\n\nSet the uniformly distributed sequence of random numbers. Default\nis a .\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkBoxMuellerRandomSequence_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkCommonCorePython.vtkBoxMuellerRandomSequence", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkBoxMuellerRandomSequence_StaticNew()
{
  return vtkBoxMuellerRandomSequence::New();
}

PyObject *PyvtkBoxMuellerRandomSequence_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkBoxMuellerRandomSequence_Type, PyvtkBoxMuellerRandomSequence_Methods,
    "vtkBoxMuellerRandomSequence",
    PyvtkBoxMuellerRandomSequence_Doc(), &PyvtkBoxMuellerRandomSequence_StaticNew);

  PyTypeObject *pytype = &PyvtkBoxMuellerRandomSequence_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkGaussianRandomSequence_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkBoxMuellerRandomSequence_Doc()
{
  static const char *docstring[] = {
    "vtkBoxMuellerRandomSequence - Gaussian sequence of pseudo random\nnumbers implemented with the Box-Mueller transform\n\n",
    "Superclass: vtkGaussianRandomSequence\n\n",
    "vtkGaussianRandomSequence is a sequence of pseudo random numbers\ndistributed according to the Gaussian/normal distribution (mean=0 and\nstandard deviation=1).\n\nIt based is calculation from a uniformly distributed pseudo random\nsequence. The initial sequence is a vtkMinimalStandardRandomSequence.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkBoxMuellerRandomSequence(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkBoxMuellerRandomSequence_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkBoxMuellerRandomSequence", o) != 0)
  {
    Py_DECREF(o);
  }

}

