// python wrapper for vtkChartXYZ
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkRect.h"
#include "vtkColor.h"
#include "vtkContextMouseEvent.h"
#include "vtkContextKeyEvent.h"
#include "vtkChartXYZ.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkChartXYZ(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkChartXYZ_ClassNew(); }

#ifndef DECLARED_PyvtkContextItem_ClassNew
extern "C" { PyObject *PyvtkContextItem_ClassNew(); }
#define DECLARED_PyvtkContextItem_ClassNew
#endif

static const char **PyvtkChartXYZ_Doc();


static PyObject *
PyvtkChartXYZ_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkChartXYZ *op = static_cast<vtkChartXYZ *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkChartXYZ::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkChartXYZ_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkChartXYZ *op = static_cast<vtkChartXYZ *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkChartXYZ::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkChartXYZ_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkChartXYZ *op = static_cast<vtkChartXYZ *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkChartXYZ *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkChartXYZ::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkChartXYZ_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkChartXYZ *tempr = vtkChartXYZ::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkChartXYZ_SetGeometry(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetGeometry");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkChartXYZ *op = static_cast<vtkChartXYZ *>(vp);

  vtkRectf *temp0 = NULL;
  PyObject *pobj0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkRectf"))
  {
    if (ap.IsBound())
    {
      op->SetGeometry(*temp0);
    }
    else
    {
      op->vtkChartXYZ::SetGeometry(*temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkChartXYZ_SetAngle(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAngle");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkChartXYZ *op = static_cast<vtkChartXYZ *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetAngle(temp0);
    }
    else
    {
      op->vtkChartXYZ::SetAngle(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkChartXYZ_SetAroundX(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAroundX");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkChartXYZ *op = static_cast<vtkChartXYZ *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetAroundX(temp0);
    }
    else
    {
      op->vtkChartXYZ::SetAroundX(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkChartXYZ_SetAnnotationLink(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAnnotationLink");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkChartXYZ *op = static_cast<vtkChartXYZ *>(vp);

  vtkAnnotationLink *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkAnnotationLink"))
  {
    if (ap.IsBound())
    {
      op->SetAnnotationLink(temp0);
    }
    else
    {
      op->vtkChartXYZ::SetAnnotationLink(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkChartXYZ_GetAxis(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAxis");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkChartXYZ *op = static_cast<vtkChartXYZ *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkAxis *tempr = (ap.IsBound() ?
      op->GetAxis(temp0) :
      op->vtkChartXYZ::GetAxis(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkChartXYZ_SetAxisColor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAxisColor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkChartXYZ *op = static_cast<vtkChartXYZ *>(vp);

  vtkColor4ub *temp0 = NULL;
  PyObject *pobj0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkColor4ub"))
  {
    if (ap.IsBound())
    {
      op->SetAxisColor(*temp0);
    }
    else
    {
      op->vtkChartXYZ::SetAxisColor(*temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkChartXYZ_GetAxisColor(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAxisColor");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkChartXYZ *op = static_cast<vtkChartXYZ *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkColor4ub tempr = (ap.IsBound() ?
      op->GetAxisColor() :
      op->vtkChartXYZ::GetAxisColor());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildSpecialObject(&tempr, "vtkColor4ub");
    }
  }

  return result;
}


static PyObject *
PyvtkChartXYZ_SetAutoRotate(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAutoRotate");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkChartXYZ *op = static_cast<vtkChartXYZ *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetAutoRotate(temp0);
    }
    else
    {
      op->vtkChartXYZ::SetAutoRotate(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkChartXYZ_SetDecorateAxes(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDecorateAxes");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkChartXYZ *op = static_cast<vtkChartXYZ *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetDecorateAxes(temp0);
    }
    else
    {
      op->vtkChartXYZ::SetDecorateAxes(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkChartXYZ_SetFitToScene(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFitToScene");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkChartXYZ *op = static_cast<vtkChartXYZ *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetFitToScene(temp0);
    }
    else
    {
      op->vtkChartXYZ::SetFitToScene(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkChartXYZ_Update(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Update");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkChartXYZ *op = static_cast<vtkChartXYZ *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Update();
    }
    else
    {
      op->vtkChartXYZ::Update();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkChartXYZ_Paint(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Paint");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkChartXYZ *op = static_cast<vtkChartXYZ *>(vp);

  vtkContext2D *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkContext2D"))
  {
    bool tempr = (ap.IsBound() ?
      op->Paint(temp0) :
      op->vtkChartXYZ::Paint(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkChartXYZ_AddPlot(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddPlot");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkChartXYZ *op = static_cast<vtkChartXYZ *>(vp);

  vtkPlot3D *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkPlot3D"))
  {
    vtkIdType tempr = (ap.IsBound() ?
      op->AddPlot(temp0) :
      op->vtkChartXYZ::AddPlot(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkChartXYZ_ClearPlots(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ClearPlots");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkChartXYZ *op = static_cast<vtkChartXYZ *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ClearPlots();
    }
    else
    {
      op->vtkChartXYZ::ClearPlots();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkChartXYZ_RecalculateBounds(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RecalculateBounds");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkChartXYZ *op = static_cast<vtkChartXYZ *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->RecalculateBounds();
    }
    else
    {
      op->vtkChartXYZ::RecalculateBounds();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkChartXYZ_RecalculateTransform(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RecalculateTransform");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkChartXYZ *op = static_cast<vtkChartXYZ *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->RecalculateTransform();
    }
    else
    {
      op->vtkChartXYZ::RecalculateTransform();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkChartXYZ_Hit(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Hit");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkChartXYZ *op = static_cast<vtkChartXYZ *>(vp);

  vtkContextMouseEvent *temp0 = NULL;
  PyObject *pobj0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkContextMouseEvent"))
  {
    bool tempr = (ap.IsBound() ?
      op->Hit(*temp0) :
      op->vtkChartXYZ::Hit(*temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkChartXYZ_MouseButtonPressEvent(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "MouseButtonPressEvent");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkChartXYZ *op = static_cast<vtkChartXYZ *>(vp);

  vtkContextMouseEvent *temp0 = NULL;
  PyObject *pobj0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkContextMouseEvent"))
  {
    bool tempr = (ap.IsBound() ?
      op->MouseButtonPressEvent(*temp0) :
      op->vtkChartXYZ::MouseButtonPressEvent(*temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkChartXYZ_MouseMoveEvent(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "MouseMoveEvent");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkChartXYZ *op = static_cast<vtkChartXYZ *>(vp);

  vtkContextMouseEvent *temp0 = NULL;
  PyObject *pobj0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkContextMouseEvent"))
  {
    bool tempr = (ap.IsBound() ?
      op->MouseMoveEvent(*temp0) :
      op->vtkChartXYZ::MouseMoveEvent(*temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkChartXYZ_MouseWheelEvent(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "MouseWheelEvent");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkChartXYZ *op = static_cast<vtkChartXYZ *>(vp);

  vtkContextMouseEvent *temp0 = NULL;
  PyObject *pobj0 = NULL;
  int temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkContextMouseEvent") &&
      ap.GetValue(temp1))
  {
    bool tempr = (ap.IsBound() ?
      op->MouseWheelEvent(*temp0, temp1) :
      op->vtkChartXYZ::MouseWheelEvent(*temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkChartXYZ_KeyPressEvent(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "KeyPressEvent");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkChartXYZ *op = static_cast<vtkChartXYZ *>(vp);

  vtkContextKeyEvent *temp0 = NULL;
  PyObject *pobj0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkContextKeyEvent"))
  {
    bool tempr = (ap.IsBound() ?
      op->KeyPressEvent(*temp0) :
      op->vtkChartXYZ::KeyPressEvent(*temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyMethodDef PyvtkChartXYZ_Methods[] = {
  {"GetClassName", PyvtkChartXYZ_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkChartXYZ_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkChartXYZ_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkChartXYZ\nC++: vtkChartXYZ *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkChartXYZ_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkChartXYZ\nC++: vtkChartXYZ *SafeDownCast(vtkObject* o)\n\n"},
  {"SetGeometry", PyvtkChartXYZ_SetGeometry, METH_VARARGS,
   "V.SetGeometry(vtkRectf)\nC++: void SetGeometry(const vtkRectf &bounds)\n\nSet the geometry in pixel coordinates (origin and width/height).\nThis method also sets up the end points of the axes of the chart.\nFor this reason, if you call SetAroundX(), you should call\nSetGeometry() afterwards.\n"},
  {"SetAngle", PyvtkChartXYZ_SetAngle, METH_VARARGS,
   "V.SetAngle(float)\nC++: void SetAngle(double angle)\n\nSet the rotation angle for the chart (AutoRotate mode only).\n"},
  {"SetAroundX", PyvtkChartXYZ_SetAroundX, METH_VARARGS,
   "V.SetAroundX(bool)\nC++: void SetAroundX(bool isX)\n\nSet whether or not we're rotating about the X axis.\n"},
  {"SetAnnotationLink", PyvtkChartXYZ_SetAnnotationLink, METH_VARARGS,
   "V.SetAnnotationLink(vtkAnnotationLink)\nC++: virtual void SetAnnotationLink(vtkAnnotationLink *link)\n\nSet the vtkAnnotationLink for the chart.\n"},
  {"GetAxis", PyvtkChartXYZ_GetAxis, METH_VARARGS,
   "V.GetAxis(int) -> vtkAxis\nC++: vtkAxis *GetAxis(int axis)\n\nGet the x (0), y (1) or z (2) axis.\n"},
  {"SetAxisColor", PyvtkChartXYZ_SetAxisColor, METH_VARARGS,
   "V.SetAxisColor(vtkColor4ub)\nC++: void SetAxisColor(const vtkColor4ub &color)\n\nSet the color for the axes.\n"},
  {"GetAxisColor", PyvtkChartXYZ_GetAxisColor, METH_VARARGS,
   "V.GetAxisColor() -> vtkColor4ub\nC++: vtkColor4ub GetAxisColor()\n\nSet the color for the axes.\n"},
  {"SetAutoRotate", PyvtkChartXYZ_SetAutoRotate, METH_VARARGS,
   "V.SetAutoRotate(bool)\nC++: void SetAutoRotate(bool b)\n\nSet whether or not we're using this chart to rotate on a timer.\nDefault value is false.\n"},
  {"SetDecorateAxes", PyvtkChartXYZ_SetDecorateAxes, METH_VARARGS,
   "V.SetDecorateAxes(bool)\nC++: void SetDecorateAxes(bool b)\n\nSet whether or not axes labels & tick marks should be drawn.\nDefault value is true.\n"},
  {"SetFitToScene", PyvtkChartXYZ_SetFitToScene, METH_VARARGS,
   "V.SetFitToScene(bool)\nC++: void SetFitToScene(bool b)\n\nSet whether or not the chart should automatically resize itself\nto fill the scene.  Default value is true.\n"},
  {"Update", PyvtkChartXYZ_Update, METH_VARARGS,
   "V.Update()\nC++: virtual void Update()\n\nPerform any updates to the item that may be necessary before\nrendering.\n"},
  {"Paint", PyvtkChartXYZ_Paint, METH_VARARGS,
   "V.Paint(vtkContext2D) -> bool\nC++: virtual bool Paint(vtkContext2D *painter)\n\nPaint event for the chart, called whenever the chart needs to be\ndrawn.\n"},
  {"AddPlot", PyvtkChartXYZ_AddPlot, METH_VARARGS,
   "V.AddPlot(vtkPlot3D) -> int\nC++: virtual vtkIdType AddPlot(vtkPlot3D *plot)\n\nAdds a plot to the chart.\n"},
  {"ClearPlots", PyvtkChartXYZ_ClearPlots, METH_VARARGS,
   "V.ClearPlots()\nC++: void ClearPlots()\n\nRemove all the plots from this chart.\n"},
  {"RecalculateBounds", PyvtkChartXYZ_RecalculateBounds, METH_VARARGS,
   "V.RecalculateBounds()\nC++: void RecalculateBounds()\n\nDetermine the XYZ bounds of the plots within this chart. This\ninformation is then used to set the range of the axes.\n"},
  {"RecalculateTransform", PyvtkChartXYZ_RecalculateTransform, METH_VARARGS,
   "V.RecalculateTransform()\nC++: void RecalculateTransform()\n\nUse this chart's Geometry to set the endpoints of its axes. This\nmethod also sets up a transformation that is used to properly\nrender the data within the chart.\n"},
  {"Hit", PyvtkChartXYZ_Hit, METH_VARARGS,
   "V.Hit(vtkContextMouseEvent) -> bool\nC++: virtual bool Hit(const vtkContextMouseEvent &mouse)\n\nReturns true if the transform is interactive, false otherwise.\n"},
  {"MouseButtonPressEvent", PyvtkChartXYZ_MouseButtonPressEvent, METH_VARARGS,
   "V.MouseButtonPressEvent(vtkContextMouseEvent) -> bool\nC++: virtual bool MouseButtonPressEvent(\n    const vtkContextMouseEvent &mouse)\n\nMouse press event. Keep track of zoom anchor position.\n"},
  {"MouseMoveEvent", PyvtkChartXYZ_MouseMoveEvent, METH_VARARGS,
   "V.MouseMoveEvent(vtkContextMouseEvent) -> bool\nC++: virtual bool MouseMoveEvent(\n    const vtkContextMouseEvent &mouse)\n\nMouse move event. Perform pan or zoom as specified by the mouse\nbindings.\n"},
  {"MouseWheelEvent", PyvtkChartXYZ_MouseWheelEvent, METH_VARARGS,
   "V.MouseWheelEvent(vtkContextMouseEvent, int) -> bool\nC++: virtual bool MouseWheelEvent(\n    const vtkContextMouseEvent &mouse, int delta)\n\nMouse wheel event.  Zooms in or out.\n"},
  {"KeyPressEvent", PyvtkChartXYZ_KeyPressEvent, METH_VARARGS,
   "V.KeyPressEvent(vtkContextKeyEvent) -> bool\nC++: virtual bool KeyPressEvent(const vtkContextKeyEvent &key)\n\nKey press event.  This allows the user to snap the chart to one\nof three different 2D views.  \"x\" changes the view so we're\nlooking down the X axis. Similar behavior occurs for \"y\" or \"z\".\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkChartXYZ_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkChartsCorePython.vtkChartXYZ", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkChartXYZ_StaticNew()
{
  return vtkChartXYZ::New();
}

PyObject *PyvtkChartXYZ_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkChartXYZ_Type, PyvtkChartXYZ_Methods,
    "vtkChartXYZ",
    PyvtkChartXYZ_Doc(), &PyvtkChartXYZ_StaticNew);

  PyTypeObject *pytype = &PyvtkChartXYZ_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkContextItem_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkChartXYZ_Doc()
{
  static const char *docstring[] = {
    "vtkChartXYZ - Factory class for drawing 3D XYZ charts.\n\n",
    "Superclass: vtkContextItem\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkChartXYZ(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkChartXYZ_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkChartXYZ", o) != 0)
  {
    Py_DECREF(o);
  }

}

