// python wrapper for vtkInteractorStyleRubberBandPick
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkInteractorStyleRubberBandPick.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkInteractorStyleRubberBandPick(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkInteractorStyleRubberBandPick_ClassNew(); }

#ifndef DECLARED_PyvtkInteractorStyleTrackballCamera_ClassNew
extern "C" { PyObject *PyvtkInteractorStyleTrackballCamera_ClassNew(); }
#define DECLARED_PyvtkInteractorStyleTrackballCamera_ClassNew
#endif

static const char **PyvtkInteractorStyleRubberBandPick_Doc();


static PyObject *
PyvtkInteractorStyleRubberBandPick_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkInteractorStyleRubberBandPick *op = static_cast<vtkInteractorStyleRubberBandPick *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkInteractorStyleRubberBandPick::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkInteractorStyleRubberBandPick_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkInteractorStyleRubberBandPick *op = static_cast<vtkInteractorStyleRubberBandPick *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkInteractorStyleRubberBandPick::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkInteractorStyleRubberBandPick_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkInteractorStyleRubberBandPick *op = static_cast<vtkInteractorStyleRubberBandPick *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkInteractorStyleRubberBandPick *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkInteractorStyleRubberBandPick::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkInteractorStyleRubberBandPick_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkInteractorStyleRubberBandPick *tempr = vtkInteractorStyleRubberBandPick::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkInteractorStyleRubberBandPick_StartSelect(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "StartSelect");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkInteractorStyleRubberBandPick *op = static_cast<vtkInteractorStyleRubberBandPick *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->StartSelect();
    }
    else
    {
      op->vtkInteractorStyleRubberBandPick::StartSelect();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkInteractorStyleRubberBandPick_OnMouseMove(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "OnMouseMove");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkInteractorStyleRubberBandPick *op = static_cast<vtkInteractorStyleRubberBandPick *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->OnMouseMove();
    }
    else
    {
      op->vtkInteractorStyleRubberBandPick::OnMouseMove();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkInteractorStyleRubberBandPick_OnLeftButtonDown(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "OnLeftButtonDown");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkInteractorStyleRubberBandPick *op = static_cast<vtkInteractorStyleRubberBandPick *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->OnLeftButtonDown();
    }
    else
    {
      op->vtkInteractorStyleRubberBandPick::OnLeftButtonDown();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkInteractorStyleRubberBandPick_OnLeftButtonUp(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "OnLeftButtonUp");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkInteractorStyleRubberBandPick *op = static_cast<vtkInteractorStyleRubberBandPick *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->OnLeftButtonUp();
    }
    else
    {
      op->vtkInteractorStyleRubberBandPick::OnLeftButtonUp();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkInteractorStyleRubberBandPick_OnChar(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "OnChar");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkInteractorStyleRubberBandPick *op = static_cast<vtkInteractorStyleRubberBandPick *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->OnChar();
    }
    else
    {
      op->vtkInteractorStyleRubberBandPick::OnChar();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkInteractorStyleRubberBandPick_Methods[] = {
  {"GetClassName", PyvtkInteractorStyleRubberBandPick_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkInteractorStyleRubberBandPick_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkInteractorStyleRubberBandPick_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkInteractorStyleRubberBandPick\nC++: vtkInteractorStyleRubberBandPick *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkInteractorStyleRubberBandPick_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkInteractorStyleRubberBandPick\nC++: vtkInteractorStyleRubberBandPick *SafeDownCast(vtkObject* o)\n\n"},
  {"StartSelect", PyvtkInteractorStyleRubberBandPick_StartSelect, METH_VARARGS,
   "V.StartSelect()\nC++: void StartSelect()\n\n"},
  {"OnMouseMove", PyvtkInteractorStyleRubberBandPick_OnMouseMove, METH_VARARGS,
   "V.OnMouseMove()\nC++: virtual void OnMouseMove()\n\nEvent bindings\n"},
  {"OnLeftButtonDown", PyvtkInteractorStyleRubberBandPick_OnLeftButtonDown, METH_VARARGS,
   "V.OnLeftButtonDown()\nC++: virtual void OnLeftButtonDown()\n\nEvent bindings\n"},
  {"OnLeftButtonUp", PyvtkInteractorStyleRubberBandPick_OnLeftButtonUp, METH_VARARGS,
   "V.OnLeftButtonUp()\nC++: virtual void OnLeftButtonUp()\n\nEvent bindings\n"},
  {"OnChar", PyvtkInteractorStyleRubberBandPick_OnChar, METH_VARARGS,
   "V.OnChar()\nC++: virtual void OnChar()\n\nEvent bindings\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkInteractorStyleRubberBandPick_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkInteractionStylePython.vtkInteractorStyleRubberBandPick", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkInteractorStyleRubberBandPick_StaticNew()
{
  return vtkInteractorStyleRubberBandPick::New();
}

PyObject *PyvtkInteractorStyleRubberBandPick_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkInteractorStyleRubberBandPick_Type, PyvtkInteractorStyleRubberBandPick_Methods,
    "vtkInteractorStyleRubberBandPick",
    PyvtkInteractorStyleRubberBandPick_Doc(), &PyvtkInteractorStyleRubberBandPick_StaticNew);

  PyTypeObject *pytype = &PyvtkInteractorStyleRubberBandPick_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkInteractorStyleTrackballCamera_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkInteractorStyleRubberBandPick_Doc()
{
  static const char *docstring[] = {
    "vtkInteractorStyleRubberBandPick - Like TrackBallCamera, but this can\npick props underneath a rubber band selection rectangle.\n\n",
    "Superclass: vtkInteractorStyleTrackballCamera\n\n",
    "This interactor style allows the user to draw a rectangle in the\nrender window by hitting 'r' and then using the left mouse button.\nWhen the mouse button is released, the attached picker operates on\nthe pixel in the center of the selection rectangle. If the picker\nhappens to be a vtkAreaPicker it will operate on the entire selection\nrectangle. When the 'p' key is hit the above pick operation occur",
    "s on\na 1x1 rectangle. In other respects it behaves the same as its parent\nclass.\n\n@sa\nvtkAreaPicker\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkInteractorStyleRubberBandPick(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkInteractorStyleRubberBandPick_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkInteractorStyleRubberBandPick", o) != 0)
  {
    Py_DECREF(o);
  }

}

