// python wrapper for vtkPDataSetGhostGenerator
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkPDataSetGhostGenerator.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPDataSetGhostGenerator(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkPDataSetGhostGenerator_ClassNew(); }

#ifndef DECLARED_PyvtkDataSetGhostGenerator_ClassNew
extern "C" { PyObject *PyvtkDataSetGhostGenerator_ClassNew(); }
#define DECLARED_PyvtkDataSetGhostGenerator_ClassNew
#endif

static const char **PyvtkPDataSetGhostGenerator_Doc();


static PyObject *
PyvtkPDataSetGhostGenerator_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPDataSetGhostGenerator *op = static_cast<vtkPDataSetGhostGenerator *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkPDataSetGhostGenerator::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPDataSetGhostGenerator_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPDataSetGhostGenerator *op = static_cast<vtkPDataSetGhostGenerator *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkPDataSetGhostGenerator::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPDataSetGhostGenerator_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPDataSetGhostGenerator *op = static_cast<vtkPDataSetGhostGenerator *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkPDataSetGhostGenerator *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkPDataSetGhostGenerator::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkPDataSetGhostGenerator_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkPDataSetGhostGenerator *tempr = vtkPDataSetGhostGenerator::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPDataSetGhostGenerator_SetController(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetController");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPDataSetGhostGenerator *op = static_cast<vtkPDataSetGhostGenerator *>(vp);

  vtkMultiProcessController *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMultiProcessController"))
  {
    if (ap.IsBound())
    {
      op->SetController(temp0);
    }
    else
    {
      op->vtkPDataSetGhostGenerator::SetController(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPDataSetGhostGenerator_GetController(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetController");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPDataSetGhostGenerator *op = static_cast<vtkPDataSetGhostGenerator *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkMultiProcessController *tempr = (ap.IsBound() ?
      op->GetController() :
      op->vtkPDataSetGhostGenerator::GetController());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPDataSetGhostGenerator_Initialize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Initialize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPDataSetGhostGenerator *op = static_cast<vtkPDataSetGhostGenerator *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Initialize();
    }
    else
    {
      op->vtkPDataSetGhostGenerator::Initialize();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPDataSetGhostGenerator_Barrier(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Barrier");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPDataSetGhostGenerator *op = static_cast<vtkPDataSetGhostGenerator *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Barrier();
    }
    else
    {
      op->vtkPDataSetGhostGenerator::Barrier();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkPDataSetGhostGenerator_Methods[] = {
  {"GetClassName", PyvtkPDataSetGhostGenerator_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkPDataSetGhostGenerator_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkPDataSetGhostGenerator_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkPDataSetGhostGenerator\nC++: vtkPDataSetGhostGenerator *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkPDataSetGhostGenerator_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkPDataSetGhostGenerator\nC++: vtkPDataSetGhostGenerator *SafeDownCast(vtkObject* o)\n\n"},
  {"SetController", PyvtkPDataSetGhostGenerator_SetController, METH_VARARGS,
   "V.SetController(vtkMultiProcessController)\nC++: void SetController(vtkMultiProcessController *a)\n\nGet/Set macro for the multi-process controller. If a controller\nis not supplied, then, the global controller is assumed.\n"},
  {"GetController", PyvtkPDataSetGhostGenerator_GetController, METH_VARARGS,
   "V.GetController() -> vtkMultiProcessController\nC++: vtkMultiProcessController *GetController()\n\nGet/Set macro for the multi-process controller. If a controller\nis not supplied, then, the global controller is assumed.\n"},
  {"Initialize", PyvtkPDataSetGhostGenerator_Initialize, METH_VARARGS,
   "V.Initialize()\nC++: void Initialize()\n\nInitializes\n"},
  {"Barrier", PyvtkPDataSetGhostGenerator_Barrier, METH_VARARGS,
   "V.Barrier()\nC++: void Barrier()\n\nBarrier synchronization\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkPDataSetGhostGenerator_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersParallelGeometryPython.vtkPDataSetGhostGenerator", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

PyObject *PyvtkPDataSetGhostGenerator_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkPDataSetGhostGenerator_Type, PyvtkPDataSetGhostGenerator_Methods,
    "vtkPDataSetGhostGenerator",
    PyvtkPDataSetGhostGenerator_Doc(), NULL);

  PyTypeObject *pytype = &PyvtkPDataSetGhostGenerator_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkDataSetGhostGenerator_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkPDataSetGhostGenerator_Doc()
{
  static const char *docstring[] = {
    "vtkPDataSetGhostGenerator -  An abstract class that provides common\nfunctionality and implements an\n interface for all parallel ghost data generators.\n\n",
    "Superclass: vtkDataSetGhostGenerator\n\n",
    "@sa\nvtkDataSetGhostGenerator, vtkPUniformGridGhostDataGenerator,\nvtkPStructuredGridGhostDataGenerator,\nvtkPRectilinearGridGhostDataGenerator\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkPDataSetGhostGenerator(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPDataSetGhostGenerator_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkPDataSetGhostGenerator", o) != 0)
  {
    Py_DECREF(o);
  }

}

