// python wrapper for vtkPStructuredGridConnectivity
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkPStructuredGridConnectivity.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPStructuredGridConnectivity(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkPStructuredGridConnectivity_ClassNew(); }

#ifndef DECLARED_PyvtkStructuredGridConnectivity_ClassNew
extern "C" { PyObject *PyvtkStructuredGridConnectivity_ClassNew(); }
#define DECLARED_PyvtkStructuredGridConnectivity_ClassNew
#endif

static const char **PyvtkPStructuredGridConnectivity_Doc();


static PyObject *
PyvtkPStructuredGridConnectivity_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPStructuredGridConnectivity *op = static_cast<vtkPStructuredGridConnectivity *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkPStructuredGridConnectivity::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPStructuredGridConnectivity_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPStructuredGridConnectivity *op = static_cast<vtkPStructuredGridConnectivity *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkPStructuredGridConnectivity::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPStructuredGridConnectivity_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPStructuredGridConnectivity *op = static_cast<vtkPStructuredGridConnectivity *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkPStructuredGridConnectivity *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkPStructuredGridConnectivity::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkPStructuredGridConnectivity_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkPStructuredGridConnectivity *tempr = vtkPStructuredGridConnectivity::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPStructuredGridConnectivity_SetController(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetController");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPStructuredGridConnectivity *op = static_cast<vtkPStructuredGridConnectivity *>(vp);

  vtkMultiProcessController *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMultiProcessController"))
  {
    if (ap.IsBound())
    {
      op->SetController(temp0);
    }
    else
    {
      op->vtkPStructuredGridConnectivity::SetController(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPStructuredGridConnectivity_GetController(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetController");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPStructuredGridConnectivity *op = static_cast<vtkPStructuredGridConnectivity *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkMultiProcessController *tempr = (ap.IsBound() ?
      op->GetController() :
      op->vtkPStructuredGridConnectivity::GetController());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPStructuredGridConnectivity_SetNumberOfGrids(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNumberOfGrids");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPStructuredGridConnectivity *op = static_cast<vtkPStructuredGridConnectivity *>(vp);

  unsigned int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetNumberOfGrids(temp0);
    }
    else
    {
      op->vtkPStructuredGridConnectivity::SetNumberOfGrids(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPStructuredGridConnectivity_RegisterGrid(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RegisterGrid");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPStructuredGridConnectivity *op = static_cast<vtkPStructuredGridConnectivity *>(vp);

  int temp0;
  const int size1 = 6;
  int temp1[6];
  int save1[6];
  vtkUnsignedCharArray *temp2 = NULL;
  vtkUnsignedCharArray *temp3 = NULL;
  vtkPointData *temp4 = NULL;
  vtkCellData *temp5 = NULL;
  vtkPoints *temp6 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(7) &&
      ap.GetValue(temp0) &&
      ap.GetArray(temp1, size1) &&
      ap.GetVTKObject(temp2, "vtkUnsignedCharArray") &&
      ap.GetVTKObject(temp3, "vtkUnsignedCharArray") &&
      ap.GetVTKObject(temp4, "vtkPointData") &&
      ap.GetVTKObject(temp5, "vtkCellData") &&
      ap.GetVTKObject(temp6, "vtkPoints"))
  {
    ap.SaveArray(temp1, save1, size1);

    if (ap.IsBound())
    {
      op->RegisterGrid(temp0, temp1, temp2, temp3, temp4, temp5, temp6);
    }
    else
    {
      op->vtkPStructuredGridConnectivity::RegisterGrid(temp0, temp1, temp2, temp3, temp4, temp5, temp6);
    }

    if (ap.ArrayHasChanged(temp1, save1, size1) &&
        !ap.ErrorOccurred())
    {
      ap.SetArray(1, temp1, size1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPStructuredGridConnectivity_GetNumberOfLocalGrids(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfLocalGrids");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPStructuredGridConnectivity *op = static_cast<vtkPStructuredGridConnectivity *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfLocalGrids() :
      op->vtkPStructuredGridConnectivity::GetNumberOfLocalGrids());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPStructuredGridConnectivity_GetGridRank(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetGridRank");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPStructuredGridConnectivity *op = static_cast<vtkPStructuredGridConnectivity *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetGridRank(temp0) :
      op->vtkPStructuredGridConnectivity::GetGridRank(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPStructuredGridConnectivity_IsGridRemote(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsGridRemote");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPStructuredGridConnectivity *op = static_cast<vtkPStructuredGridConnectivity *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    bool tempr = (ap.IsBound() ?
      op->IsGridRemote(temp0) :
      op->vtkPStructuredGridConnectivity::IsGridRemote(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPStructuredGridConnectivity_IsGridLocal(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsGridLocal");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPStructuredGridConnectivity *op = static_cast<vtkPStructuredGridConnectivity *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    bool tempr = (ap.IsBound() ?
      op->IsGridLocal(temp0) :
      op->vtkPStructuredGridConnectivity::IsGridLocal(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPStructuredGridConnectivity_Initialize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Initialize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPStructuredGridConnectivity *op = static_cast<vtkPStructuredGridConnectivity *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Initialize();
    }
    else
    {
      op->vtkPStructuredGridConnectivity::Initialize();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPStructuredGridConnectivity_ComputeNeighbors(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ComputeNeighbors");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPStructuredGridConnectivity *op = static_cast<vtkPStructuredGridConnectivity *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->ComputeNeighbors();
    }
    else
    {
      op->vtkPStructuredGridConnectivity::ComputeNeighbors();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPStructuredGridConnectivity_CreateGhostLayers(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CreateGhostLayers");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPStructuredGridConnectivity *op = static_cast<vtkPStructuredGridConnectivity *>(vp);

  int temp0 = 1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0, 1) &&
      (ap.NoArgsLeft() || ap.GetValue(temp0)))
  {
    if (ap.IsBound())
    {
      op->CreateGhostLayers(temp0);
    }
    else
    {
      op->vtkPStructuredGridConnectivity::CreateGhostLayers(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkPStructuredGridConnectivity_Methods[] = {
  {"GetClassName", PyvtkPStructuredGridConnectivity_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkPStructuredGridConnectivity_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkPStructuredGridConnectivity_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkPStructuredGridConnectivity\nC++: vtkPStructuredGridConnectivity *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkPStructuredGridConnectivity_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkPStructuredGridConnectivity\nC++: vtkPStructuredGridConnectivity *SafeDownCast(vtkObject* o)\n\n"},
  {"SetController", PyvtkPStructuredGridConnectivity_SetController, METH_VARARGS,
   "V.SetController(vtkMultiProcessController)\nC++: void SetController(vtkMultiProcessController *a)\n\nSet & Get the process controller\n"},
  {"GetController", PyvtkPStructuredGridConnectivity_GetController, METH_VARARGS,
   "V.GetController() -> vtkMultiProcessController\nC++: vtkMultiProcessController *GetController()\n\nSet & Get the process controller\n"},
  {"SetNumberOfGrids", PyvtkPStructuredGridConnectivity_SetNumberOfGrids, METH_VARARGS,
   "V.SetNumberOfGrids(int)\nC++: void SetNumberOfGrids(const unsigned int N)\n\nSets the total number of domains distributed among processors\n"},
  {"RegisterGrid", PyvtkPStructuredGridConnectivity_RegisterGrid, METH_VARARGS,
   "V.RegisterGrid(int, [int, int, int, int, int, int],\n    vtkUnsignedCharArray, vtkUnsignedCharArray, vtkPointData,\n    vtkCellData, vtkPoints)\nC++: void RegisterGrid(const int gridID, int extents[6],\n    vtkUnsignedCharArray *nodesGhostArray,\n    vtkUnsignedCharArray *cellGhostArray, vtkPointData *pointData,\n     vtkCellData *cellData, vtkPoints *gridNodes)\n\nSee vtkStructuredGridConnectivity::RegisterGrid\n"},
  {"GetNumberOfLocalGrids", PyvtkPStructuredGridConnectivity_GetNumberOfLocalGrids, METH_VARARGS,
   "V.GetNumberOfLocalGrids() -> int\nC++: int GetNumberOfLocalGrids()\n\nReturns the number of local grids registers by the process that\nowns the current vtkPStructuredGridConnectivity instance\n"},
  {"GetGridRank", PyvtkPStructuredGridConnectivity_GetGridRank, METH_VARARGS,
   "V.GetGridRank(int) -> int\nC++: int GetGridRank(const int gridID)\n\nReturns the rank of the given gridID. A nominal value of -1 for\nthe return value of this method indicates that possibly\nComputeNeighbors has not been called and consequently the\nGridRanks vector has not been populated yet.\n"},
  {"IsGridRemote", PyvtkPStructuredGridConnectivity_IsGridRemote, METH_VARARGS,
   "V.IsGridRemote(int) -> bool\nC++: bool IsGridRemote(const int gridID)\n\nReturns true iff the grid is remote, otherwise false.\n"},
  {"IsGridLocal", PyvtkPStructuredGridConnectivity_IsGridLocal, METH_VARARGS,
   "V.IsGridLocal(int) -> bool\nC++: bool IsGridLocal(const int gridID)\n\nReturns true iff the grid corresponding to the given gridID is\nlocal.\n"},
  {"Initialize", PyvtkPStructuredGridConnectivity_Initialize, METH_VARARGS,
   "V.Initialize()\nC++: void Initialize()\n\nInitializes this instance of vtkPStructuredGridConnectivity,\nessentially, the acquires the local process ID from the\nregistered controller. If a controller is not registered, the\nglobal controller is set.\n"},
  {"ComputeNeighbors", PyvtkPStructuredGridConnectivity_ComputeNeighbors, METH_VARARGS,
   "V.ComputeNeighbors()\nC++: void ComputeNeighbors()\n\nComputes the neighboring topology of a distributed structured\ngrid data-set. See\nvtkStructuredGridConnectivity::ComputeNeighbors\n"},
  {"CreateGhostLayers", PyvtkPStructuredGridConnectivity_CreateGhostLayers, METH_VARARGS,
   "V.CreateGhostLayers(int)\nC++: virtual void CreateGhostLayers(const int N=1)\n\nCreates ghost layers on the grids owned by this process using\ndata from both local and remote block neighbors.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkPStructuredGridConnectivity_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersParallelGeometryPython.vtkPStructuredGridConnectivity", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkPStructuredGridConnectivity_StaticNew()
{
  return vtkPStructuredGridConnectivity::New();
}

PyObject *PyvtkPStructuredGridConnectivity_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkPStructuredGridConnectivity_Type, PyvtkPStructuredGridConnectivity_Methods,
    "vtkPStructuredGridConnectivity",
    PyvtkPStructuredGridConnectivity_Doc(), &PyvtkPStructuredGridConnectivity_StaticNew);

  PyTypeObject *pytype = &PyvtkPStructuredGridConnectivity_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkStructuredGridConnectivity_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkPStructuredGridConnectivity_Doc()
{
  static const char *docstring[] = {
    "vtkPStructuredGridConnectivity -  vtkPStructuredGridConnectivity\ninherits from vtkStructuredGridConnectivity\n and implements functionality to compute the neighboring topology\nwithin a\n single, partitioned and distributed structured grid dataset.\n\n",
    "Superclass: vtkStructuredGridConnectivity\n\n",
    "@warning\n Initialize(), ComputeNeighbors() and CreateGhostLayers() are\ncollective\n operations, every process must call that method.\n\n@sa\n vtkStructuredGridConnectivity vtkGhostArray\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkPStructuredGridConnectivity(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPStructuredGridConnectivity_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkPStructuredGridConnectivity", o) != 0)
  {
    Py_DECREF(o);
  }

}

