// python wrapper for vtkPUnstructuredGridGhostDataGenerator
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkPUnstructuredGridGhostDataGenerator.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPUnstructuredGridGhostDataGenerator(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkPUnstructuredGridGhostDataGenerator_ClassNew(); }

#ifndef DECLARED_PyvtkUnstructuredGridAlgorithm_ClassNew
extern "C" { PyObject *PyvtkUnstructuredGridAlgorithm_ClassNew(); }
#define DECLARED_PyvtkUnstructuredGridAlgorithm_ClassNew
#endif

static const char **PyvtkPUnstructuredGridGhostDataGenerator_Doc();


static PyObject *
PyvtkPUnstructuredGridGhostDataGenerator_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPUnstructuredGridGhostDataGenerator *op = static_cast<vtkPUnstructuredGridGhostDataGenerator *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkPUnstructuredGridGhostDataGenerator::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPUnstructuredGridGhostDataGenerator_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPUnstructuredGridGhostDataGenerator *op = static_cast<vtkPUnstructuredGridGhostDataGenerator *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkPUnstructuredGridGhostDataGenerator::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPUnstructuredGridGhostDataGenerator_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPUnstructuredGridGhostDataGenerator *op = static_cast<vtkPUnstructuredGridGhostDataGenerator *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkPUnstructuredGridGhostDataGenerator *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkPUnstructuredGridGhostDataGenerator::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkPUnstructuredGridGhostDataGenerator_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkPUnstructuredGridGhostDataGenerator *tempr = vtkPUnstructuredGridGhostDataGenerator::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkPUnstructuredGridGhostDataGenerator_Methods[] = {
  {"GetClassName", PyvtkPUnstructuredGridGhostDataGenerator_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkPUnstructuredGridGhostDataGenerator_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkPUnstructuredGridGhostDataGenerator_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkPUnstructuredGridGhostDataGenerator\nC++: vtkPUnstructuredGridGhostDataGenerator *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkPUnstructuredGridGhostDataGenerator_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject)\n    -> vtkPUnstructuredGridGhostDataGenerator\nC++: vtkPUnstructuredGridGhostDataGenerator *SafeDownCast(\n    vtkObject* o)\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkPUnstructuredGridGhostDataGenerator_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersParallelGeometryPython.vtkPUnstructuredGridGhostDataGenerator", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkPUnstructuredGridGhostDataGenerator_StaticNew()
{
  return vtkPUnstructuredGridGhostDataGenerator::New();
}

PyObject *PyvtkPUnstructuredGridGhostDataGenerator_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkPUnstructuredGridGhostDataGenerator_Type, PyvtkPUnstructuredGridGhostDataGenerator_Methods,
    "vtkPUnstructuredGridGhostDataGenerator",
    PyvtkPUnstructuredGridGhostDataGenerator_Doc(), &PyvtkPUnstructuredGridGhostDataGenerator_StaticNew);

  PyTypeObject *pytype = &PyvtkPUnstructuredGridGhostDataGenerator_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkUnstructuredGridAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkPUnstructuredGridGhostDataGenerator_Doc()
{
  static const char *docstring[] = {
    "vtkPUnstructuredGridGhostDataGenerator -  distributed unstructured\ngrid dataset.\n\n",
    "Superclass: vtkUnstructuredGridAlgorithm\n\n",
    "This filter uses internally the vtkPUnstructuredGridConnectivity\nhelper\n class to construct ghost zones for a distributed unstructured\ngrid.@deprecated Not maintained as of VTK 7.0 and will be removed\neventually. Use vtkPUnstructuredGridGhostCellsGenerator instead.\n\n@warning\n \n   The code currently assumes one grid per rank. \n   GlobalID information must be provided as a PointData array\n        wi",
    "th the name, \"GlobalID\" \n   The grid must be globally conforming, i.e., no hanging nodes. \n   Only topologically face-adjacent ghost cells are considered. \n   PointData and CellData must match across partitions/processes. \n \n\n@sa\n vtkPUnstructuredGridConnectivity\nvtkPUnstructuredGridGhostCellsGenerator\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkPUnstructuredGridGhostDataGenerator(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPUnstructuredGridGhostDataGenerator_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkPUnstructuredGridGhostDataGenerator", o) != 0)
  {
    Py_DECREF(o);
  }

}

