// python wrapper for vtkRadiusOutlierRemoval
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkRadiusOutlierRemoval.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkRadiusOutlierRemoval(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkRadiusOutlierRemoval_ClassNew(); }

#ifndef DECLARED_PyvtkPointCloudFilter_ClassNew
extern "C" { PyObject *PyvtkPointCloudFilter_ClassNew(); }
#define DECLARED_PyvtkPointCloudFilter_ClassNew
#endif

static const char **PyvtkRadiusOutlierRemoval_Doc();


static PyObject *
PyvtkRadiusOutlierRemoval_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRadiusOutlierRemoval *op = static_cast<vtkRadiusOutlierRemoval *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkRadiusOutlierRemoval::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRadiusOutlierRemoval_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRadiusOutlierRemoval *op = static_cast<vtkRadiusOutlierRemoval *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkRadiusOutlierRemoval::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRadiusOutlierRemoval_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRadiusOutlierRemoval *op = static_cast<vtkRadiusOutlierRemoval *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkRadiusOutlierRemoval *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkRadiusOutlierRemoval::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkRadiusOutlierRemoval_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkRadiusOutlierRemoval *tempr = vtkRadiusOutlierRemoval::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRadiusOutlierRemoval_SetRadius(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetRadius");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRadiusOutlierRemoval *op = static_cast<vtkRadiusOutlierRemoval *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetRadius(temp0);
    }
    else
    {
      op->vtkRadiusOutlierRemoval::SetRadius(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkRadiusOutlierRemoval_GetRadiusMinValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRadiusMinValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRadiusOutlierRemoval *op = static_cast<vtkRadiusOutlierRemoval *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetRadiusMinValue() :
      op->vtkRadiusOutlierRemoval::GetRadiusMinValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRadiusOutlierRemoval_GetRadiusMaxValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRadiusMaxValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRadiusOutlierRemoval *op = static_cast<vtkRadiusOutlierRemoval *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetRadiusMaxValue() :
      op->vtkRadiusOutlierRemoval::GetRadiusMaxValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRadiusOutlierRemoval_GetRadius(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRadius");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRadiusOutlierRemoval *op = static_cast<vtkRadiusOutlierRemoval *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetRadius() :
      op->vtkRadiusOutlierRemoval::GetRadius());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRadiusOutlierRemoval_SetNumberOfNeighbors(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNumberOfNeighbors");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRadiusOutlierRemoval *op = static_cast<vtkRadiusOutlierRemoval *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetNumberOfNeighbors(temp0);
    }
    else
    {
      op->vtkRadiusOutlierRemoval::SetNumberOfNeighbors(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkRadiusOutlierRemoval_GetNumberOfNeighborsMinValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfNeighborsMinValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRadiusOutlierRemoval *op = static_cast<vtkRadiusOutlierRemoval *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfNeighborsMinValue() :
      op->vtkRadiusOutlierRemoval::GetNumberOfNeighborsMinValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRadiusOutlierRemoval_GetNumberOfNeighborsMaxValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfNeighborsMaxValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRadiusOutlierRemoval *op = static_cast<vtkRadiusOutlierRemoval *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfNeighborsMaxValue() :
      op->vtkRadiusOutlierRemoval::GetNumberOfNeighborsMaxValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRadiusOutlierRemoval_GetNumberOfNeighbors(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfNeighbors");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRadiusOutlierRemoval *op = static_cast<vtkRadiusOutlierRemoval *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfNeighbors() :
      op->vtkRadiusOutlierRemoval::GetNumberOfNeighbors());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkRadiusOutlierRemoval_SetLocator(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLocator");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRadiusOutlierRemoval *op = static_cast<vtkRadiusOutlierRemoval *>(vp);

  vtkAbstractPointLocator *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkAbstractPointLocator"))
  {
    if (ap.IsBound())
    {
      op->SetLocator(temp0);
    }
    else
    {
      op->vtkRadiusOutlierRemoval::SetLocator(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkRadiusOutlierRemoval_GetLocator(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLocator");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkRadiusOutlierRemoval *op = static_cast<vtkRadiusOutlierRemoval *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkAbstractPointLocator *tempr = (ap.IsBound() ?
      op->GetLocator() :
      op->vtkRadiusOutlierRemoval::GetLocator());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkRadiusOutlierRemoval_Methods[] = {
  {"GetClassName", PyvtkRadiusOutlierRemoval_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\nStandard methods for instantiating, obtaining type information,\nand printing information.\n"},
  {"IsA", PyvtkRadiusOutlierRemoval_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\nStandard methods for instantiating, obtaining type information,\nand printing information.\n"},
  {"NewInstance", PyvtkRadiusOutlierRemoval_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkRadiusOutlierRemoval\nC++: vtkRadiusOutlierRemoval *NewInstance()\n\nStandard methods for instantiating, obtaining type information,\nand printing information.\n"},
  {"SafeDownCast", PyvtkRadiusOutlierRemoval_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkRadiusOutlierRemoval\nC++: vtkRadiusOutlierRemoval *SafeDownCast(vtkObject* o)\n\nStandard methods for instantiating, obtaining type information,\nand printing information.\n"},
  {"SetRadius", PyvtkRadiusOutlierRemoval_SetRadius, METH_VARARGS,
   "V.SetRadius(float)\nC++: void SetRadius(double)\n\nSpecify the local search radius.\n"},
  {"GetRadiusMinValue", PyvtkRadiusOutlierRemoval_GetRadiusMinValue, METH_VARARGS,
   "V.GetRadiusMinValue() -> float\nC++: double GetRadiusMinValue()\n\nSpecify the local search radius.\n"},
  {"GetRadiusMaxValue", PyvtkRadiusOutlierRemoval_GetRadiusMaxValue, METH_VARARGS,
   "V.GetRadiusMaxValue() -> float\nC++: double GetRadiusMaxValue()\n\nSpecify the local search radius.\n"},
  {"GetRadius", PyvtkRadiusOutlierRemoval_GetRadius, METH_VARARGS,
   "V.GetRadius() -> float\nC++: double GetRadius()\n\nSpecify the local search radius.\n"},
  {"SetNumberOfNeighbors", PyvtkRadiusOutlierRemoval_SetNumberOfNeighbors, METH_VARARGS,
   "V.SetNumberOfNeighbors(int)\nC++: void SetNumberOfNeighbors(int)\n\nSpecify the number of neighbors that a point must have, within\nthe specified radius, for the point to not be considered\nisolated.\n"},
  {"GetNumberOfNeighborsMinValue", PyvtkRadiusOutlierRemoval_GetNumberOfNeighborsMinValue, METH_VARARGS,
   "V.GetNumberOfNeighborsMinValue() -> int\nC++: int GetNumberOfNeighborsMinValue()\n\nSpecify the number of neighbors that a point must have, within\nthe specified radius, for the point to not be considered\nisolated.\n"},
  {"GetNumberOfNeighborsMaxValue", PyvtkRadiusOutlierRemoval_GetNumberOfNeighborsMaxValue, METH_VARARGS,
   "V.GetNumberOfNeighborsMaxValue() -> int\nC++: int GetNumberOfNeighborsMaxValue()\n\nSpecify the number of neighbors that a point must have, within\nthe specified radius, for the point to not be considered\nisolated.\n"},
  {"GetNumberOfNeighbors", PyvtkRadiusOutlierRemoval_GetNumberOfNeighbors, METH_VARARGS,
   "V.GetNumberOfNeighbors() -> int\nC++: int GetNumberOfNeighbors()\n\nSpecify the number of neighbors that a point must have, within\nthe specified radius, for the point to not be considered\nisolated.\n"},
  {"SetLocator", PyvtkRadiusOutlierRemoval_SetLocator, METH_VARARGS,
   "V.SetLocator(vtkAbstractPointLocator)\nC++: void SetLocator(vtkAbstractPointLocator *locator)\n\nSpecify a point locator. By default a vtkStaticPointLocator is\nused. The locator performs efficient searches to locate near a\nspecified interpolation position.\n"},
  {"GetLocator", PyvtkRadiusOutlierRemoval_GetLocator, METH_VARARGS,
   "V.GetLocator() -> vtkAbstractPointLocator\nC++: vtkAbstractPointLocator *GetLocator()\n\nSpecify a point locator. By default a vtkStaticPointLocator is\nused. The locator performs efficient searches to locate near a\nspecified interpolation position.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkRadiusOutlierRemoval_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersPointsPython.vtkRadiusOutlierRemoval", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkRadiusOutlierRemoval_StaticNew()
{
  return vtkRadiusOutlierRemoval::New();
}

PyObject *PyvtkRadiusOutlierRemoval_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkRadiusOutlierRemoval_Type, PyvtkRadiusOutlierRemoval_Methods,
    "vtkRadiusOutlierRemoval",
    PyvtkRadiusOutlierRemoval_Doc(), &PyvtkRadiusOutlierRemoval_StaticNew);

  PyTypeObject *pytype = &PyvtkRadiusOutlierRemoval_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkPointCloudFilter_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkRadiusOutlierRemoval_Doc()
{
  static const char *docstring[] = {
    "vtkRadiusOutlierRemoval - remove isolated points\n\n",
    "Superclass: vtkPointCloudFilter\n\n",
    "vtkRadiusOutlierRemoval removes isolated points; i.e., those points\nthat have few neighbors within a specified radius. The user must\nspecify the radius defining the local region, as well as the\nisolation threshold (i.e., number of neighboring points required for\nthe point to be considered isolated). Optionally, users can specify a\npoint locator to accelerate local neighborhood search operations. (",
    "By\ndefault a vtkStaticPointLocator will be created.)\n\nNote that while any vtkPointSet type can be provided as input, the\noutput is represented by an explicit representation of points via a\nvtkPolyData. This output polydata will populate its instance of\nvtkPoints, but no cells will be defined (i.e., no vtkVertex or\nvtkPolyVertex are contained in the output). Also, after filter\nexecution, the user c",
    "an request a vtkIdType* map which indicates how\nthe input points were mapped to the output. A value of map[i] (where\ni is the ith input point) less than 0 means that the ith input point\nwas removed. (See also the superclass documentation for accessing the\nremoved points through the filter's second output.)\n\n@warning\nThis class has been threaded with vtkSMPTools. Using TBB or other\nnon-sequential t",
    "ype (set in the CMake variable\nVTK_SMP_IMPLEMENTATION_TYPE) may improve performance significantly.\n\n@sa\nvtkPointCloudFilter vtkStatisticalOutlierRemoval vtkExtractPoints\nvtkThresholdPoints vtkImplicitFunction\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkRadiusOutlierRemoval(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkRadiusOutlierRemoval_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkRadiusOutlierRemoval", o) != 0)
  {
    Py_DECREF(o);
  }

}

