// python wrapper for vtkSMPContourGridManyPieces
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkSMPContourGridManyPieces.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkSMPContourGridManyPieces(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkSMPContourGridManyPieces_ClassNew(); }

#ifndef DECLARED_PyvtkContourGrid_ClassNew
extern "C" { PyObject *PyvtkContourGrid_ClassNew(); }
#define DECLARED_PyvtkContourGrid_ClassNew
#endif

static const char **PyvtkSMPContourGridManyPieces_Doc();


static PyObject *
PyvtkSMPContourGridManyPieces_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMPContourGridManyPieces *op = static_cast<vtkSMPContourGridManyPieces *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkSMPContourGridManyPieces::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMPContourGridManyPieces_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMPContourGridManyPieces *op = static_cast<vtkSMPContourGridManyPieces *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkSMPContourGridManyPieces::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSMPContourGridManyPieces_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSMPContourGridManyPieces *op = static_cast<vtkSMPContourGridManyPieces *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkSMPContourGridManyPieces *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkSMPContourGridManyPieces::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkSMPContourGridManyPieces_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkSMPContourGridManyPieces *tempr = vtkSMPContourGridManyPieces::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkSMPContourGridManyPieces_Methods[] = {
  {"GetClassName", PyvtkSMPContourGridManyPieces_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkSMPContourGridManyPieces_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkSMPContourGridManyPieces_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkSMPContourGridManyPieces\nC++: vtkSMPContourGridManyPieces *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkSMPContourGridManyPieces_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkSMPContourGridManyPieces\nC++: vtkSMPContourGridManyPieces *SafeDownCast(vtkObject* o)\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkSMPContourGridManyPieces_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersSMPPython.vtkSMPContourGridManyPieces", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkSMPContourGridManyPieces_StaticNew()
{
  return vtkSMPContourGridManyPieces::New();
}

PyObject *PyvtkSMPContourGridManyPieces_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkSMPContourGridManyPieces_Type, PyvtkSMPContourGridManyPieces_Methods,
    "vtkSMPContourGridManyPieces",
    PyvtkSMPContourGridManyPieces_Doc(), &PyvtkSMPContourGridManyPieces_StaticNew);

  PyTypeObject *pytype = &PyvtkSMPContourGridManyPieces_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkContourGrid_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkSMPContourGridManyPieces_Doc()
{
  static const char *docstring[] = {
    "vtkSMPContourGridManyPieces - a subclass of vtkContourGrid that works\nin parallel vtkSMPContourGridManyPieces performs the same\nfunctionaliy as vtkContourGrid but does it using multiple threads.\n\n",
    "Superclass: vtkContourGrid\n\n",
    "This filter generates a multi-block of vtkPolyData. It will generate\na relatively large number of pieces - the number is dependent on the\ninput size and number of threads available. See vtkSMPContourGrid is\nyou are interested in a filter that merges the piece. This will\nprobably be merged with vtkContourGrid in the future.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkSMPContourGridManyPieces(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkSMPContourGridManyPieces_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkSMPContourGridManyPieces", o) != 0)
  {
    Py_DECREF(o);
  }

}

