// python wrapper for vtkSQLDatabaseSchema
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkSQLDatabaseSchema.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkSQLDatabaseSchema(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkSQLDatabaseSchema_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkSQLDatabaseSchema_Doc();

static PyTypeObject PyvtkSQLDatabaseSchema_DatabaseColumnType_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkIOSQLPython.vtkSQLDatabaseSchema.DatabaseColumnType", // tp_name
  sizeof(PyIntObject), // tp_basicsize
  0, // tp_itemsize
  0, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  0, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  0, // tp_str
  0, // tp_getattro
  0, // tp_setattro
  0, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  0, // tp_doc
  0, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  0, // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  0, // tp_getset
  &PyInt_Type, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  0, // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  0, // tp_new
  PyObject_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

PyObject *PyvtkSQLDatabaseSchema_DatabaseColumnType_FromEnum(int val)
{
#ifdef VTK_PY3K
  PyObject *args = Py_BuildValue("(i)", val);
  PyObject *obj = PyLong_Type.tp_new(&PyvtkSQLDatabaseSchema_DatabaseColumnType_Type, args, NULL);
  Py_DECREF(args);
  return obj;
#else
  PyIntObject *self = PyObject_New(PyIntObject,
    &PyvtkSQLDatabaseSchema_DatabaseColumnType_Type);
  self->ob_ival = val;
  return (PyObject *)self;
#endif
}

static PyTypeObject PyvtkSQLDatabaseSchema_DatabaseIndexType_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkIOSQLPython.vtkSQLDatabaseSchema.DatabaseIndexType", // tp_name
  sizeof(PyIntObject), // tp_basicsize
  0, // tp_itemsize
  0, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  0, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  0, // tp_str
  0, // tp_getattro
  0, // tp_setattro
  0, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  0, // tp_doc
  0, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  0, // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  0, // tp_getset
  &PyInt_Type, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  0, // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  0, // tp_new
  PyObject_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

PyObject *PyvtkSQLDatabaseSchema_DatabaseIndexType_FromEnum(int val)
{
#ifdef VTK_PY3K
  PyObject *args = Py_BuildValue("(i)", val);
  PyObject *obj = PyLong_Type.tp_new(&PyvtkSQLDatabaseSchema_DatabaseIndexType_Type, args, NULL);
  Py_DECREF(args);
  return obj;
#else
  PyIntObject *self = PyObject_New(PyIntObject,
    &PyvtkSQLDatabaseSchema_DatabaseIndexType_Type);
  self->ob_ival = val;
  return (PyObject *)self;
#endif
}

static PyTypeObject PyvtkSQLDatabaseSchema_DatabaseTriggerType_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkIOSQLPython.vtkSQLDatabaseSchema.DatabaseTriggerType", // tp_name
  sizeof(PyIntObject), // tp_basicsize
  0, // tp_itemsize
  0, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  0, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  0, // tp_str
  0, // tp_getattro
  0, // tp_setattro
  0, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  0, // tp_doc
  0, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  0, // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  0, // tp_getset
  &PyInt_Type, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  0, // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  0, // tp_new
  PyObject_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

PyObject *PyvtkSQLDatabaseSchema_DatabaseTriggerType_FromEnum(int val)
{
#ifdef VTK_PY3K
  PyObject *args = Py_BuildValue("(i)", val);
  PyObject *obj = PyLong_Type.tp_new(&PyvtkSQLDatabaseSchema_DatabaseTriggerType_Type, args, NULL);
  Py_DECREF(args);
  return obj;
#else
  PyIntObject *self = PyObject_New(PyIntObject,
    &PyvtkSQLDatabaseSchema_DatabaseTriggerType_Type);
  self->ob_ival = val;
  return (PyObject *)self;
#endif
}

static PyTypeObject PyvtkSQLDatabaseSchema_VarargTokens_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkIOSQLPython.vtkSQLDatabaseSchema.VarargTokens", // tp_name
  sizeof(PyIntObject), // tp_basicsize
  0, // tp_itemsize
  0, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  0, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  0, // tp_str
  0, // tp_getattro
  0, // tp_setattro
  0, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  0, // tp_doc
  0, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  0, // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  0, // tp_getset
  &PyInt_Type, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  0, // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  0, // tp_new
  PyObject_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

PyObject *PyvtkSQLDatabaseSchema_VarargTokens_FromEnum(int val)
{
#ifdef VTK_PY3K
  PyObject *args = Py_BuildValue("(i)", val);
  PyObject *obj = PyLong_Type.tp_new(&PyvtkSQLDatabaseSchema_VarargTokens_Type, args, NULL);
  Py_DECREF(args);
  return obj;
#else
  PyIntObject *self = PyObject_New(PyIntObject,
    &PyvtkSQLDatabaseSchema_VarargTokens_Type);
  self->ob_ival = val;
  return (PyObject *)self;
#endif
}


static PyObject *
PyvtkSQLDatabaseSchema_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseSchema *op = static_cast<vtkSQLDatabaseSchema *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkSQLDatabaseSchema::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseSchema_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseSchema *op = static_cast<vtkSQLDatabaseSchema *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkSQLDatabaseSchema::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseSchema_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseSchema *op = static_cast<vtkSQLDatabaseSchema *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkSQLDatabaseSchema *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkSQLDatabaseSchema::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseSchema_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkSQLDatabaseSchema *tempr = vtkSQLDatabaseSchema::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseSchema_AddPreamble(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddPreamble");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseSchema *op = static_cast<vtkSQLDatabaseSchema *>(vp);

  char *temp0 = NULL;
  char *temp1 = NULL;
  const char *temp2 = VTK_SQL_ALLBACKENDS;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2, 3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      (ap.NoArgsLeft() || ap.GetValue(temp2)))
  {
    int tempr = (ap.IsBound() ?
      op->AddPreamble(temp0, temp1, temp2) :
      op->vtkSQLDatabaseSchema::AddPreamble(temp0, temp1, temp2));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseSchema_AddTable(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddTable");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseSchema *op = static_cast<vtkSQLDatabaseSchema *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->AddTable(temp0) :
      op->vtkSQLDatabaseSchema::AddTable(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseSchema_AddColumnToTable_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddColumnToTable");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseSchema *op = static_cast<vtkSQLDatabaseSchema *>(vp);

  int temp0;
  int temp1;
  char *temp2 = NULL;
  int temp3;
  char *temp4 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(5) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3) &&
      ap.GetValue(temp4))
  {
    int tempr = (ap.IsBound() ?
      op->AddColumnToTable(temp0, temp1, temp2, temp3, temp4) :
      op->vtkSQLDatabaseSchema::AddColumnToTable(temp0, temp1, temp2, temp3, temp4));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkSQLDatabaseSchema_AddColumnToTable_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddColumnToTable");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseSchema *op = static_cast<vtkSQLDatabaseSchema *>(vp);

  char *temp0 = NULL;
  int temp1;
  char *temp2 = NULL;
  int temp3;
  char *temp4 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(5) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3) &&
      ap.GetValue(temp4))
  {
    int tempr = (ap.IsBound() ?
      op->AddColumnToTable(temp0, temp1, temp2, temp3, temp4) :
      op->vtkSQLDatabaseSchema::AddColumnToTable(temp0, temp1, temp2, temp3, temp4));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkSQLDatabaseSchema_AddColumnToTable_Methods[] = {
  {NULL, PyvtkSQLDatabaseSchema_AddColumnToTable_s1, METH_VARARGS,
   "@iiziz"},
  {NULL, PyvtkSQLDatabaseSchema_AddColumnToTable_s2, METH_VARARGS,
   "@ziziz"},
  {NULL, NULL, 0, NULL}
};

static PyObject *
PyvtkSQLDatabaseSchema_AddColumnToTable(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkSQLDatabaseSchema_AddColumnToTable_Methods;
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 5:
      return vtkPythonOverload::CallMethod(methods, self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "AddColumnToTable");
  return NULL;
}



static PyObject *
PyvtkSQLDatabaseSchema_AddIndexToTable_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddIndexToTable");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseSchema *op = static_cast<vtkSQLDatabaseSchema *>(vp);

  int temp0;
  int temp1;
  char *temp2 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
  {
    int tempr = (ap.IsBound() ?
      op->AddIndexToTable(temp0, temp1, temp2) :
      op->vtkSQLDatabaseSchema::AddIndexToTable(temp0, temp1, temp2));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkSQLDatabaseSchema_AddIndexToTable_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddIndexToTable");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseSchema *op = static_cast<vtkSQLDatabaseSchema *>(vp);

  char *temp0 = NULL;
  int temp1;
  char *temp2 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
  {
    int tempr = (ap.IsBound() ?
      op->AddIndexToTable(temp0, temp1, temp2) :
      op->vtkSQLDatabaseSchema::AddIndexToTable(temp0, temp1, temp2));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkSQLDatabaseSchema_AddIndexToTable_Methods[] = {
  {NULL, PyvtkSQLDatabaseSchema_AddIndexToTable_s1, METH_VARARGS,
   "@iiz"},
  {NULL, PyvtkSQLDatabaseSchema_AddIndexToTable_s2, METH_VARARGS,
   "@ziz"},
  {NULL, NULL, 0, NULL}
};

static PyObject *
PyvtkSQLDatabaseSchema_AddIndexToTable(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkSQLDatabaseSchema_AddIndexToTable_Methods;
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 3:
      return vtkPythonOverload::CallMethod(methods, self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "AddIndexToTable");
  return NULL;
}



static PyObject *
PyvtkSQLDatabaseSchema_AddColumnToIndex_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddColumnToIndex");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseSchema *op = static_cast<vtkSQLDatabaseSchema *>(vp);

  int temp0;
  int temp1;
  int temp2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
  {
    int tempr = (ap.IsBound() ?
      op->AddColumnToIndex(temp0, temp1, temp2) :
      op->vtkSQLDatabaseSchema::AddColumnToIndex(temp0, temp1, temp2));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkSQLDatabaseSchema_AddColumnToIndex_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddColumnToIndex");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseSchema *op = static_cast<vtkSQLDatabaseSchema *>(vp);

  char *temp0 = NULL;
  char *temp1 = NULL;
  char *temp2 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
  {
    int tempr = (ap.IsBound() ?
      op->AddColumnToIndex(temp0, temp1, temp2) :
      op->vtkSQLDatabaseSchema::AddColumnToIndex(temp0, temp1, temp2));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkSQLDatabaseSchema_AddColumnToIndex_Methods[] = {
  {NULL, PyvtkSQLDatabaseSchema_AddColumnToIndex_s1, METH_VARARGS,
   "@iii"},
  {NULL, PyvtkSQLDatabaseSchema_AddColumnToIndex_s2, METH_VARARGS,
   "@zzz"},
  {NULL, NULL, 0, NULL}
};

static PyObject *
PyvtkSQLDatabaseSchema_AddColumnToIndex(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkSQLDatabaseSchema_AddColumnToIndex_Methods;
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 3:
      return vtkPythonOverload::CallMethod(methods, self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "AddColumnToIndex");
  return NULL;
}



static PyObject *
PyvtkSQLDatabaseSchema_AddTriggerToTable_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddTriggerToTable");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseSchema *op = static_cast<vtkSQLDatabaseSchema *>(vp);

  int temp0;
  int temp1;
  char *temp2 = NULL;
  char *temp3 = NULL;
  const char *temp4 = VTK_SQL_ALLBACKENDS;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(4, 5) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3) &&
      (ap.NoArgsLeft() || ap.GetValue(temp4)))
  {
    int tempr = (ap.IsBound() ?
      op->AddTriggerToTable(temp0, temp1, temp2, temp3, temp4) :
      op->vtkSQLDatabaseSchema::AddTriggerToTable(temp0, temp1, temp2, temp3, temp4));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkSQLDatabaseSchema_AddTriggerToTable_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddTriggerToTable");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseSchema *op = static_cast<vtkSQLDatabaseSchema *>(vp);

  char *temp0 = NULL;
  int temp1;
  char *temp2 = NULL;
  char *temp3 = NULL;
  const char *temp4 = VTK_SQL_ALLBACKENDS;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(4, 5) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2) &&
      ap.GetValue(temp3) &&
      (ap.NoArgsLeft() || ap.GetValue(temp4)))
  {
    int tempr = (ap.IsBound() ?
      op->AddTriggerToTable(temp0, temp1, temp2, temp3, temp4) :
      op->vtkSQLDatabaseSchema::AddTriggerToTable(temp0, temp1, temp2, temp3, temp4));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkSQLDatabaseSchema_AddTriggerToTable_Methods[] = {
  {NULL, PyvtkSQLDatabaseSchema_AddTriggerToTable_s1, METH_VARARGS,
   "@iizz|z"},
  {NULL, PyvtkSQLDatabaseSchema_AddTriggerToTable_s2, METH_VARARGS,
   "@zizz|z"},
  {NULL, NULL, 0, NULL}
};

static PyObject *
PyvtkSQLDatabaseSchema_AddTriggerToTable(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkSQLDatabaseSchema_AddTriggerToTable_Methods;
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 4:
    case 5:
      return vtkPythonOverload::CallMethod(methods, self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "AddTriggerToTable");
  return NULL;
}



static PyObject *
PyvtkSQLDatabaseSchema_AddOptionToTable_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddOptionToTable");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseSchema *op = static_cast<vtkSQLDatabaseSchema *>(vp);

  int temp0;
  char *temp1 = NULL;
  const char *temp2 = VTK_SQL_ALLBACKENDS;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2, 3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      (ap.NoArgsLeft() || ap.GetValue(temp2)))
  {
    int tempr = (ap.IsBound() ?
      op->AddOptionToTable(temp0, temp1, temp2) :
      op->vtkSQLDatabaseSchema::AddOptionToTable(temp0, temp1, temp2));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyObject *
PyvtkSQLDatabaseSchema_AddOptionToTable_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddOptionToTable");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseSchema *op = static_cast<vtkSQLDatabaseSchema *>(vp);

  char *temp0 = NULL;
  char *temp1 = NULL;
  const char *temp2 = VTK_SQL_ALLBACKENDS;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2, 3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      (ap.NoArgsLeft() || ap.GetValue(temp2)))
  {
    int tempr = (ap.IsBound() ?
      op->AddOptionToTable(temp0, temp1, temp2) :
      op->vtkSQLDatabaseSchema::AddOptionToTable(temp0, temp1, temp2));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkSQLDatabaseSchema_AddOptionToTable_Methods[] = {
  {NULL, PyvtkSQLDatabaseSchema_AddOptionToTable_s1, METH_VARARGS,
   "@iz|z"},
  {NULL, PyvtkSQLDatabaseSchema_AddOptionToTable_s2, METH_VARARGS,
   "@zz|z"},
  {NULL, NULL, 0, NULL}
};

static PyObject *
PyvtkSQLDatabaseSchema_AddOptionToTable(PyObject *self, PyObject *args)
{
  PyMethodDef *methods = PyvtkSQLDatabaseSchema_AddOptionToTable_Methods;
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 2:
    case 3:
      return vtkPythonOverload::CallMethod(methods, self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "AddOptionToTable");
  return NULL;
}



static PyObject *
PyvtkSQLDatabaseSchema_GetPreambleHandleFromName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPreambleHandleFromName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseSchema *op = static_cast<vtkSQLDatabaseSchema *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetPreambleHandleFromName(temp0) :
      op->vtkSQLDatabaseSchema::GetPreambleHandleFromName(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseSchema_GetPreambleNameFromHandle(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPreambleNameFromHandle");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseSchema *op = static_cast<vtkSQLDatabaseSchema *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetPreambleNameFromHandle(temp0) :
      op->vtkSQLDatabaseSchema::GetPreambleNameFromHandle(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseSchema_GetPreambleActionFromHandle(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPreambleActionFromHandle");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseSchema *op = static_cast<vtkSQLDatabaseSchema *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetPreambleActionFromHandle(temp0) :
      op->vtkSQLDatabaseSchema::GetPreambleActionFromHandle(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseSchema_GetPreambleBackendFromHandle(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPreambleBackendFromHandle");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseSchema *op = static_cast<vtkSQLDatabaseSchema *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetPreambleBackendFromHandle(temp0) :
      op->vtkSQLDatabaseSchema::GetPreambleBackendFromHandle(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseSchema_GetTableHandleFromName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTableHandleFromName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseSchema *op = static_cast<vtkSQLDatabaseSchema *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetTableHandleFromName(temp0) :
      op->vtkSQLDatabaseSchema::GetTableHandleFromName(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseSchema_GetTableNameFromHandle(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTableNameFromHandle");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseSchema *op = static_cast<vtkSQLDatabaseSchema *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetTableNameFromHandle(temp0) :
      op->vtkSQLDatabaseSchema::GetTableNameFromHandle(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseSchema_GetIndexHandleFromName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetIndexHandleFromName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseSchema *op = static_cast<vtkSQLDatabaseSchema *>(vp);

  char *temp0 = NULL;
  char *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    int tempr = (ap.IsBound() ?
      op->GetIndexHandleFromName(temp0, temp1) :
      op->vtkSQLDatabaseSchema::GetIndexHandleFromName(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseSchema_GetIndexNameFromHandle(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetIndexNameFromHandle");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseSchema *op = static_cast<vtkSQLDatabaseSchema *>(vp);

  int temp0;
  int temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetIndexNameFromHandle(temp0, temp1) :
      op->vtkSQLDatabaseSchema::GetIndexNameFromHandle(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseSchema_GetIndexTypeFromHandle(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetIndexTypeFromHandle");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseSchema *op = static_cast<vtkSQLDatabaseSchema *>(vp);

  int temp0;
  int temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    int tempr = (ap.IsBound() ?
      op->GetIndexTypeFromHandle(temp0, temp1) :
      op->vtkSQLDatabaseSchema::GetIndexTypeFromHandle(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseSchema_GetIndexColumnNameFromHandle(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetIndexColumnNameFromHandle");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseSchema *op = static_cast<vtkSQLDatabaseSchema *>(vp);

  int temp0;
  int temp1;
  int temp2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetIndexColumnNameFromHandle(temp0, temp1, temp2) :
      op->vtkSQLDatabaseSchema::GetIndexColumnNameFromHandle(temp0, temp1, temp2));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseSchema_GetColumnHandleFromName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetColumnHandleFromName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseSchema *op = static_cast<vtkSQLDatabaseSchema *>(vp);

  char *temp0 = NULL;
  char *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    int tempr = (ap.IsBound() ?
      op->GetColumnHandleFromName(temp0, temp1) :
      op->vtkSQLDatabaseSchema::GetColumnHandleFromName(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseSchema_GetColumnNameFromHandle(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetColumnNameFromHandle");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseSchema *op = static_cast<vtkSQLDatabaseSchema *>(vp);

  int temp0;
  int temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetColumnNameFromHandle(temp0, temp1) :
      op->vtkSQLDatabaseSchema::GetColumnNameFromHandle(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseSchema_GetColumnTypeFromHandle(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetColumnTypeFromHandle");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseSchema *op = static_cast<vtkSQLDatabaseSchema *>(vp);

  int temp0;
  int temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    int tempr = (ap.IsBound() ?
      op->GetColumnTypeFromHandle(temp0, temp1) :
      op->vtkSQLDatabaseSchema::GetColumnTypeFromHandle(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseSchema_GetColumnSizeFromHandle(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetColumnSizeFromHandle");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseSchema *op = static_cast<vtkSQLDatabaseSchema *>(vp);

  int temp0;
  int temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    int tempr = (ap.IsBound() ?
      op->GetColumnSizeFromHandle(temp0, temp1) :
      op->vtkSQLDatabaseSchema::GetColumnSizeFromHandle(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseSchema_GetColumnAttributesFromHandle(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetColumnAttributesFromHandle");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseSchema *op = static_cast<vtkSQLDatabaseSchema *>(vp);

  int temp0;
  int temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetColumnAttributesFromHandle(temp0, temp1) :
      op->vtkSQLDatabaseSchema::GetColumnAttributesFromHandle(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseSchema_GetTriggerHandleFromName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTriggerHandleFromName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseSchema *op = static_cast<vtkSQLDatabaseSchema *>(vp);

  char *temp0 = NULL;
  char *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    int tempr = (ap.IsBound() ?
      op->GetTriggerHandleFromName(temp0, temp1) :
      op->vtkSQLDatabaseSchema::GetTriggerHandleFromName(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseSchema_GetTriggerNameFromHandle(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTriggerNameFromHandle");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseSchema *op = static_cast<vtkSQLDatabaseSchema *>(vp);

  int temp0;
  int temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetTriggerNameFromHandle(temp0, temp1) :
      op->vtkSQLDatabaseSchema::GetTriggerNameFromHandle(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseSchema_GetTriggerTypeFromHandle(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTriggerTypeFromHandle");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseSchema *op = static_cast<vtkSQLDatabaseSchema *>(vp);

  int temp0;
  int temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    int tempr = (ap.IsBound() ?
      op->GetTriggerTypeFromHandle(temp0, temp1) :
      op->vtkSQLDatabaseSchema::GetTriggerTypeFromHandle(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseSchema_GetTriggerActionFromHandle(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTriggerActionFromHandle");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseSchema *op = static_cast<vtkSQLDatabaseSchema *>(vp);

  int temp0;
  int temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetTriggerActionFromHandle(temp0, temp1) :
      op->vtkSQLDatabaseSchema::GetTriggerActionFromHandle(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseSchema_GetTriggerBackendFromHandle(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTriggerBackendFromHandle");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseSchema *op = static_cast<vtkSQLDatabaseSchema *>(vp);

  int temp0;
  int temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetTriggerBackendFromHandle(temp0, temp1) :
      op->vtkSQLDatabaseSchema::GetTriggerBackendFromHandle(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseSchema_GetOptionTextFromHandle(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOptionTextFromHandle");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseSchema *op = static_cast<vtkSQLDatabaseSchema *>(vp);

  int temp0;
  int temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetOptionTextFromHandle(temp0, temp1) :
      op->vtkSQLDatabaseSchema::GetOptionTextFromHandle(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseSchema_GetOptionBackendFromHandle(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOptionBackendFromHandle");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseSchema *op = static_cast<vtkSQLDatabaseSchema *>(vp);

  int temp0;
  int temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetOptionBackendFromHandle(temp0, temp1) :
      op->vtkSQLDatabaseSchema::GetOptionBackendFromHandle(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseSchema_Reset(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Reset");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseSchema *op = static_cast<vtkSQLDatabaseSchema *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->Reset();
    }
    else
    {
      op->vtkSQLDatabaseSchema::Reset();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseSchema_GetNumberOfPreambles(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfPreambles");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseSchema *op = static_cast<vtkSQLDatabaseSchema *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfPreambles() :
      op->vtkSQLDatabaseSchema::GetNumberOfPreambles());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseSchema_GetNumberOfTables(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfTables");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseSchema *op = static_cast<vtkSQLDatabaseSchema *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfTables() :
      op->vtkSQLDatabaseSchema::GetNumberOfTables());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseSchema_GetNumberOfColumnsInTable(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfColumnsInTable");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseSchema *op = static_cast<vtkSQLDatabaseSchema *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfColumnsInTable(temp0) :
      op->vtkSQLDatabaseSchema::GetNumberOfColumnsInTable(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseSchema_GetNumberOfIndicesInTable(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfIndicesInTable");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseSchema *op = static_cast<vtkSQLDatabaseSchema *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfIndicesInTable(temp0) :
      op->vtkSQLDatabaseSchema::GetNumberOfIndicesInTable(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseSchema_GetNumberOfColumnNamesInIndex(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfColumnNamesInIndex");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseSchema *op = static_cast<vtkSQLDatabaseSchema *>(vp);

  int temp0;
  int temp1;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfColumnNamesInIndex(temp0, temp1) :
      op->vtkSQLDatabaseSchema::GetNumberOfColumnNamesInIndex(temp0, temp1));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseSchema_GetNumberOfTriggersInTable(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfTriggersInTable");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseSchema *op = static_cast<vtkSQLDatabaseSchema *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfTriggersInTable(temp0) :
      op->vtkSQLDatabaseSchema::GetNumberOfTriggersInTable(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseSchema_GetNumberOfOptionsInTable(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfOptionsInTable");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseSchema *op = static_cast<vtkSQLDatabaseSchema *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->GetNumberOfOptionsInTable(temp0) :
      op->vtkSQLDatabaseSchema::GetNumberOfOptionsInTable(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseSchema_SetName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseSchema *op = static_cast<vtkSQLDatabaseSchema *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetName(temp0);
    }
    else
    {
      op->vtkSQLDatabaseSchema::SetName(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseSchema_GetName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseSchema *op = static_cast<vtkSQLDatabaseSchema *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetName() :
      op->vtkSQLDatabaseSchema::GetName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkSQLDatabaseSchema_AddTableMultipleArguments(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "AddTableMultipleArguments");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkSQLDatabaseSchema *op = static_cast<vtkSQLDatabaseSchema *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->AddTableMultipleArguments(temp0) :
      op->vtkSQLDatabaseSchema::AddTableMultipleArguments(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkSQLDatabaseSchema_Methods[] = {
  {"GetClassName", PyvtkSQLDatabaseSchema_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkSQLDatabaseSchema_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkSQLDatabaseSchema_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkSQLDatabaseSchema\nC++: vtkSQLDatabaseSchema *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkSQLDatabaseSchema_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkSQLDatabaseSchema\nC++: vtkSQLDatabaseSchema *SafeDownCast(vtkObject* o)\n\n"},
  {"AddPreamble", PyvtkSQLDatabaseSchema_AddPreamble, METH_VARARGS,
   "V.AddPreamble(string, string, string) -> int\nC++: virtual int AddPreamble(const char *preName,\n    const char *preAction,\n    const char *preBackend=VTK_SQL_ALLBACKENDS)\n\nAdd a preamble to the schema This can be used, in particular, to\ncreate functions and/or load languages in a backend-specific\nmanner. Example usage: vtkSQLDatabaseSchema* schema =\nvtkSQLDatabaseSchema::New(); schema->SetName( \"Example\" );\nschema->AddPreamble( \"dropPLPGSQL\", \"DROP LANGUAGE IF EXISTS PLPGSQL\nCASCADE\", VTK_SQL_POSTGRESQL ); schema->AddPreamble(\n\"loadPLPGSQL\", \"CREATE LANGUAGE PLPGSQL\", VTK_SQL_POSTGRESQL );\nschema->AddPreamble( \"createsomefunction\", \"CREATE OR REPLACE FUNCTION somefunction() RETURNS TRIGGER AS $btable$\n\" \"BEGIN \" \"INSERT INTO btable (somevalue) VALUES (NEW.somenmbr);\n\" \"RETURN NEW; \" \"END; $btable$ LANGUAGE PLPGSQL\",\nVTK_SQL_POSTGRESQL );\n"},
  {"AddTable", PyvtkSQLDatabaseSchema_AddTable, METH_VARARGS,
   "V.AddTable(string) -> int\nC++: virtual int AddTable(const char *tblName)\n\nAdd a table to the schema\n"},
  {"AddColumnToTable", PyvtkSQLDatabaseSchema_AddColumnToTable, METH_VARARGS,
   "V.AddColumnToTable(int, int, string, int, string) -> int\nC++: virtual int AddColumnToTable(int tblHandle, int colType,\n    const char *colName, int colSize, const char *colAttribs)\nV.AddColumnToTable(string, int, string, int, string) -> int\nC++: virtual int AddColumnToTable(const char *tblName,\n    int colType, const char *colName, int colSize,\n    const char *colAttribs)\n\nAdd a column to table.\n\n* The returned value is a column handle or -1 if an error\n  occurred.\n"},
  {"AddIndexToTable", PyvtkSQLDatabaseSchema_AddIndexToTable, METH_VARARGS,
   "V.AddIndexToTable(int, int, string) -> int\nC++: virtual int AddIndexToTable(int tblHandle, int idxType,\n    const char *idxName)\nV.AddIndexToTable(string, int, string) -> int\nC++: virtual int AddIndexToTable(const char *tblName, int idxType,\n     const char *idxName)\n\nAdd an index to table.\n\n* The returned value is an index handle or -1 if an error\n  occurred.\n"},
  {"AddColumnToIndex", PyvtkSQLDatabaseSchema_AddColumnToIndex, METH_VARARGS,
   "V.AddColumnToIndex(int, int, int) -> int\nC++: virtual int AddColumnToIndex(int tblHandle, int idxHandle,\n    int colHandle)\nV.AddColumnToIndex(string, string, string) -> int\nC++: virtual int AddColumnToIndex(const char *tblName,\n    const char *idxName, const char *colName)\n\nAdd a column to a table index.\n\n* The returned value is an index-column handle or -1 if an error\n  occurred.\n"},
  {"AddTriggerToTable", PyvtkSQLDatabaseSchema_AddTriggerToTable, METH_VARARGS,
   "V.AddTriggerToTable(int, int, string, string, string) -> int\nC++: virtual int AddTriggerToTable(int tblHandle, int trgType,\n    const char *trgName, const char *trgAction,\n    const char *trgBackend=VTK_SQL_ALLBACKENDS)\nV.AddTriggerToTable(string, int, string, string, string) -> int\nC++: virtual int AddTriggerToTable(const char *tblName,\n    int trgType, const char *trgName, const char *trgAction,\n    const char *trgBackend=VTK_SQL_ALLBACKENDS)\n\nAdd a (possibly backend-specific) trigger action to a table.\n\n* Triggers must be given unique, non-NULL names as some database\n  backends require them.\n* The returned value is a trigger handle or -1 if an error\n  occurred.\n"},
  {"AddOptionToTable", PyvtkSQLDatabaseSchema_AddOptionToTable, METH_VARARGS,
   "V.AddOptionToTable(int, string, string) -> int\nC++: virtual int AddOptionToTable(int tblHandle,\n    const char *optStr,\n    const char *optBackend=VTK_SQL_ALLBACKENDS)\nV.AddOptionToTable(string, string, string) -> int\nC++: virtual int AddOptionToTable(const char *tblName,\n    const char *optStr,\n    const char *optBackend=VTK_SQL_ALLBACKENDS)\n\nAdd (possibly backend-specific) text to the end of a CREATE TABLE\n(...) statement.\n\n* This is most useful for specifying storage semantics of tables\n* that are specific to the backend. For example, table options\n* can be used to specify the TABLESPACE of a PostgreSQL table or\n* the ENGINE of a MySQL table.\n\n* The returned value is an option handle or -1 if an error\n  occurred.\n"},
  {"GetPreambleHandleFromName", PyvtkSQLDatabaseSchema_GetPreambleHandleFromName, METH_VARARGS,
   "V.GetPreambleHandleFromName(string) -> int\nC++: int GetPreambleHandleFromName(const char *preName)\n\nGiven a preamble name, get its handle.\n"},
  {"GetPreambleNameFromHandle", PyvtkSQLDatabaseSchema_GetPreambleNameFromHandle, METH_VARARGS,
   "V.GetPreambleNameFromHandle(int) -> string\nC++: const char *GetPreambleNameFromHandle(int preHandle)\n\nGiven a preamble handle, get its name.\n"},
  {"GetPreambleActionFromHandle", PyvtkSQLDatabaseSchema_GetPreambleActionFromHandle, METH_VARARGS,
   "V.GetPreambleActionFromHandle(int) -> string\nC++: const char *GetPreambleActionFromHandle(int preHandle)\n\nGiven a preamble handle, get its action.\n"},
  {"GetPreambleBackendFromHandle", PyvtkSQLDatabaseSchema_GetPreambleBackendFromHandle, METH_VARARGS,
   "V.GetPreambleBackendFromHandle(int) -> string\nC++: const char *GetPreambleBackendFromHandle(int preHandle)\n\nGiven a preamble handle, get its backend.\n"},
  {"GetTableHandleFromName", PyvtkSQLDatabaseSchema_GetTableHandleFromName, METH_VARARGS,
   "V.GetTableHandleFromName(string) -> int\nC++: int GetTableHandleFromName(const char *tblName)\n\nGiven a table name, get its handle.\n"},
  {"GetTableNameFromHandle", PyvtkSQLDatabaseSchema_GetTableNameFromHandle, METH_VARARGS,
   "V.GetTableNameFromHandle(int) -> string\nC++: const char *GetTableNameFromHandle(int tblHandle)\n\nGiven a table hanlde, get its name.\n"},
  {"GetIndexHandleFromName", PyvtkSQLDatabaseSchema_GetIndexHandleFromName, METH_VARARGS,
   "V.GetIndexHandleFromName(string, string) -> int\nC++: int GetIndexHandleFromName(const char *tblName,\n    const char *idxName)\n\nGiven the names of a table and an index, get the handle of the\nindex in this table.\n"},
  {"GetIndexNameFromHandle", PyvtkSQLDatabaseSchema_GetIndexNameFromHandle, METH_VARARGS,
   "V.GetIndexNameFromHandle(int, int) -> string\nC++: const char *GetIndexNameFromHandle(int tblHandle,\n    int idxHandle)\n\nGiven the handles of a table and an index, get the name of the\nindex.\n"},
  {"GetIndexTypeFromHandle", PyvtkSQLDatabaseSchema_GetIndexTypeFromHandle, METH_VARARGS,
   "V.GetIndexTypeFromHandle(int, int) -> int\nC++: int GetIndexTypeFromHandle(int tblHandle, int idxHandle)\n\nGiven the handles of a table and an index, get the type of the\nindex.\n"},
  {"GetIndexColumnNameFromHandle", PyvtkSQLDatabaseSchema_GetIndexColumnNameFromHandle, METH_VARARGS,
   "V.GetIndexColumnNameFromHandle(int, int, int) -> string\nC++: const char *GetIndexColumnNameFromHandle(int tblHandle,\n    int idxHandle, int cnmHandle)\n\nGiven the handles of a table, an index, and a column name, get\nthe column name.\n"},
  {"GetColumnHandleFromName", PyvtkSQLDatabaseSchema_GetColumnHandleFromName, METH_VARARGS,
   "V.GetColumnHandleFromName(string, string) -> int\nC++: int GetColumnHandleFromName(const char *tblName,\n    const char *colName)\n\nGiven the names of a table and a column, get the handle of the\ncolumn in this table.\n"},
  {"GetColumnNameFromHandle", PyvtkSQLDatabaseSchema_GetColumnNameFromHandle, METH_VARARGS,
   "V.GetColumnNameFromHandle(int, int) -> string\nC++: const char *GetColumnNameFromHandle(int tblHandle,\n    int colHandle)\n\nGiven the handles of a table and a column, get the name of the\ncolumn.\n"},
  {"GetColumnTypeFromHandle", PyvtkSQLDatabaseSchema_GetColumnTypeFromHandle, METH_VARARGS,
   "V.GetColumnTypeFromHandle(int, int) -> int\nC++: int GetColumnTypeFromHandle(int tblHandle, int colHandle)\n\nGiven the handles of a table and a column, get the type of the\ncolumn.\n"},
  {"GetColumnSizeFromHandle", PyvtkSQLDatabaseSchema_GetColumnSizeFromHandle, METH_VARARGS,
   "V.GetColumnSizeFromHandle(int, int) -> int\nC++: int GetColumnSizeFromHandle(int tblHandle, int colHandle)\n\nGiven the handles of a table and a column, get the size of the\ncolumn.\n"},
  {"GetColumnAttributesFromHandle", PyvtkSQLDatabaseSchema_GetColumnAttributesFromHandle, METH_VARARGS,
   "V.GetColumnAttributesFromHandle(int, int) -> string\nC++: const char *GetColumnAttributesFromHandle(int tblHandle,\n    int colHandle)\n\nGiven the handles of a table and a column, get the attributes of\nthe column.\n"},
  {"GetTriggerHandleFromName", PyvtkSQLDatabaseSchema_GetTriggerHandleFromName, METH_VARARGS,
   "V.GetTriggerHandleFromName(string, string) -> int\nC++: int GetTriggerHandleFromName(const char *tblName,\n    const char *trgName)\n\nGiven the names of a trigger and a table, get the handle of the\ntrigger in this table.\n"},
  {"GetTriggerNameFromHandle", PyvtkSQLDatabaseSchema_GetTriggerNameFromHandle, METH_VARARGS,
   "V.GetTriggerNameFromHandle(int, int) -> string\nC++: const char *GetTriggerNameFromHandle(int tblHandle,\n    int trgHandle)\n\nGiven the handles of a table and a trigger, get the name of the\ntrigger.\n"},
  {"GetTriggerTypeFromHandle", PyvtkSQLDatabaseSchema_GetTriggerTypeFromHandle, METH_VARARGS,
   "V.GetTriggerTypeFromHandle(int, int) -> int\nC++: int GetTriggerTypeFromHandle(int tblHandle, int trgHandle)\n\nGiven the handles of a table and a trigger, get the type of the\ntrigger.\n"},
  {"GetTriggerActionFromHandle", PyvtkSQLDatabaseSchema_GetTriggerActionFromHandle, METH_VARARGS,
   "V.GetTriggerActionFromHandle(int, int) -> string\nC++: const char *GetTriggerActionFromHandle(int tblHandle,\n    int trgHandle)\n\nGiven the handles of a table and a trigger, get the action of the\ntrigger.\n"},
  {"GetTriggerBackendFromHandle", PyvtkSQLDatabaseSchema_GetTriggerBackendFromHandle, METH_VARARGS,
   "V.GetTriggerBackendFromHandle(int, int) -> string\nC++: const char *GetTriggerBackendFromHandle(int tblHandle,\n    int trgHandle)\n\nGiven the handles of a table and a trigger, get the backend of\nthe trigger.\n"},
  {"GetOptionTextFromHandle", PyvtkSQLDatabaseSchema_GetOptionTextFromHandle, METH_VARARGS,
   "V.GetOptionTextFromHandle(int, int) -> string\nC++: const char *GetOptionTextFromHandle(int tblHandle,\n    int optHandle)\n\nGiven the handles of a table and one of its options, return the\ntext of the option.\n"},
  {"GetOptionBackendFromHandle", PyvtkSQLDatabaseSchema_GetOptionBackendFromHandle, METH_VARARGS,
   "V.GetOptionBackendFromHandle(int, int) -> string\nC++: const char *GetOptionBackendFromHandle(int tblHandle,\n    int trgHandle)\n\nGiven the handles of a table and one of its options, get the\nbackend of the option.\n"},
  {"Reset", PyvtkSQLDatabaseSchema_Reset, METH_VARARGS,
   "V.Reset()\nC++: void Reset()\n\nReset the schema to its initial, empty state.\n"},
  {"GetNumberOfPreambles", PyvtkSQLDatabaseSchema_GetNumberOfPreambles, METH_VARARGS,
   "V.GetNumberOfPreambles() -> int\nC++: int GetNumberOfPreambles()\n\nGet the number of preambles.\n"},
  {"GetNumberOfTables", PyvtkSQLDatabaseSchema_GetNumberOfTables, METH_VARARGS,
   "V.GetNumberOfTables() -> int\nC++: int GetNumberOfTables()\n\nGet the number of tables.\n"},
  {"GetNumberOfColumnsInTable", PyvtkSQLDatabaseSchema_GetNumberOfColumnsInTable, METH_VARARGS,
   "V.GetNumberOfColumnsInTable(int) -> int\nC++: int GetNumberOfColumnsInTable(int tblHandle)\n\nGet the number of columns in a particular table .\n"},
  {"GetNumberOfIndicesInTable", PyvtkSQLDatabaseSchema_GetNumberOfIndicesInTable, METH_VARARGS,
   "V.GetNumberOfIndicesInTable(int) -> int\nC++: int GetNumberOfIndicesInTable(int tblHandle)\n\nGet the number of indices in a particular table .\n"},
  {"GetNumberOfColumnNamesInIndex", PyvtkSQLDatabaseSchema_GetNumberOfColumnNamesInIndex, METH_VARARGS,
   "V.GetNumberOfColumnNamesInIndex(int, int) -> int\nC++: int GetNumberOfColumnNamesInIndex(int tblHandle,\n    int idxHandle)\n\nGet the number of column names associated to a particular index\nin a particular table .\n"},
  {"GetNumberOfTriggersInTable", PyvtkSQLDatabaseSchema_GetNumberOfTriggersInTable, METH_VARARGS,
   "V.GetNumberOfTriggersInTable(int) -> int\nC++: int GetNumberOfTriggersInTable(int tblHandle)\n\nGet the number of triggers defined for a particular table.\n"},
  {"GetNumberOfOptionsInTable", PyvtkSQLDatabaseSchema_GetNumberOfOptionsInTable, METH_VARARGS,
   "V.GetNumberOfOptionsInTable(int) -> int\nC++: int GetNumberOfOptionsInTable(int tblHandle)\n\nGet the number of options associated with a particular table.\n"},
  {"SetName", PyvtkSQLDatabaseSchema_SetName, METH_VARARGS,
   "V.SetName(string)\nC++: void SetName(char *)\n\nSet/Get the name of the schema.\n"},
  {"GetName", PyvtkSQLDatabaseSchema_GetName, METH_VARARGS,
   "V.GetName() -> string\nC++: char *GetName()\n\nSet/Get the name of the schema.\n"},
  {"AddTableMultipleArguments", PyvtkSQLDatabaseSchema_AddTableMultipleArguments, METH_VARARGS,
   "V.AddTableMultipleArguments(string) -> int\nC++: int AddTableMultipleArguments(const char *tblName, ...)\n\nAn unwrappable but useful routine to construct built-in schema.\nExample usage: int main() { vtkSQLDatabaseSchema* schema =\nvtkSQLDatabaseSchema::New(); schema->SetName( \"Example\" );\nschema->AddTableMultipleArguments( \"atable\",\nvtkSQLDatabaseSchema::COLUMN_TOKEN,\nvtkSQLDatabaseSchema::INTEGER, \"tablekey\",  0, \"\",\nvtkSQLDatabaseSchema::COLUMN_TOKEN,\nvtkSQLDatabaseSchema::VARCHAR, \"somename\", 11, \"NOT NULL\",\nvtkSQLDatabaseSchema::COLUMN_TOKEN, vtkSQLDatabaseSchema::BIGINT,\n \"somenmbr\", 17, \"DEFAULT 0\", vtkSQLDatabaseSchema::INDEX_TOKEN,\nvtkSQLDatabaseSchema::PRIMARY_KEY, \"bigkey\",\nvtkSQLDatabaseSchema::INDEX_COLUMN_TOKEN, \"tablekey\",\nvtkSQLDatabaseSchema::END_INDEX_TOKEN,\nvtkSQLDatabaseSchema::INDEX_TOKEN,  vtkSQLDatabaseSchema::UNIQUE,\n\"reverselookup\", vtkSQLDatabaseSchema::INDEX_COLUMN_TOKEN,\n\"somename\", vtkSQLDatabaseSchema::INDEX_COLUMN_TOKEN, \"somenmbr\",\nvtkSQLDatabaseSchema::END_INDEX_TOKEN,\nvtkSQLDatabaseSchema::TRIGGER_TOKEN, \nvtkSQLDatabaseSchema::AFTER_INSERT, \"InsertTrigger\", \"DO\nNOTHING\", VTK_SQL_SQLITE, vtkSQLDatabaseSchema::TRIGGER_TOKEN, \nvtkSQLDatabaseSchema::AFTER_INSERT, \"InsertTrigger\", \"FOR EACH ROW EXECUTE PROCEDURE somefunction\n()\", VTK_SQL_POSTGRESQL, vtkSQLDatabaseSchema::TRIGGER_TOKEN, \nvtkSQLDatabaseSchema::AFTER_INSERT, \"InsertTrigger\", \"FOR EACH ROW INSERT INTO btable SET SomeValue =\nNEW.SomeNmbr\", VTK_SQL_MYSQL,\nvtkSQLDatabaseSchema::END_TABLE_TOKEN ); return 0; }\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkSQLDatabaseSchema_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkIOSQLPython.vtkSQLDatabaseSchema", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkSQLDatabaseSchema_StaticNew()
{
  return vtkSQLDatabaseSchema::New();
}

PyObject *PyvtkSQLDatabaseSchema_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkSQLDatabaseSchema_Type, PyvtkSQLDatabaseSchema_Methods,
    "vtkSQLDatabaseSchema",
    PyvtkSQLDatabaseSchema_Doc(), &PyvtkSQLDatabaseSchema_StaticNew);

  PyTypeObject *pytype = &PyvtkSQLDatabaseSchema_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyObject *d = pytype->tp_dict;
  PyObject *o;

  PyType_Ready(&PyvtkSQLDatabaseSchema_DatabaseColumnType_Type);
  PyvtkSQLDatabaseSchema_DatabaseColumnType_Type.tp_new = NULL;
  vtkPythonUtil::AddEnumToMap(&PyvtkSQLDatabaseSchema_DatabaseColumnType_Type);

  o = (PyObject *)&PyvtkSQLDatabaseSchema_DatabaseColumnType_Type;
  if (PyDict_SetItemString(d, "DatabaseColumnType", o) != 0)
  {
    Py_DECREF(o);
  }

  PyType_Ready(&PyvtkSQLDatabaseSchema_DatabaseIndexType_Type);
  PyvtkSQLDatabaseSchema_DatabaseIndexType_Type.tp_new = NULL;
  vtkPythonUtil::AddEnumToMap(&PyvtkSQLDatabaseSchema_DatabaseIndexType_Type);

  o = (PyObject *)&PyvtkSQLDatabaseSchema_DatabaseIndexType_Type;
  if (PyDict_SetItemString(d, "DatabaseIndexType", o) != 0)
  {
    Py_DECREF(o);
  }

  PyType_Ready(&PyvtkSQLDatabaseSchema_DatabaseTriggerType_Type);
  PyvtkSQLDatabaseSchema_DatabaseTriggerType_Type.tp_new = NULL;
  vtkPythonUtil::AddEnumToMap(&PyvtkSQLDatabaseSchema_DatabaseTriggerType_Type);

  o = (PyObject *)&PyvtkSQLDatabaseSchema_DatabaseTriggerType_Type;
  if (PyDict_SetItemString(d, "DatabaseTriggerType", o) != 0)
  {
    Py_DECREF(o);
  }

  PyType_Ready(&PyvtkSQLDatabaseSchema_VarargTokens_Type);
  PyvtkSQLDatabaseSchema_VarargTokens_Type.tp_new = NULL;
  vtkPythonUtil::AddEnumToMap(&PyvtkSQLDatabaseSchema_VarargTokens_Type);

  o = (PyObject *)&PyvtkSQLDatabaseSchema_VarargTokens_Type;
  if (PyDict_SetItemString(d, "VarargTokens", o) != 0)
  {
    Py_DECREF(o);
  }

  for (int c = 0; c < 12; c++)
  {
    typedef vtkSQLDatabaseSchema::DatabaseColumnType cxx_enum_type;

    static const struct { const char *name; cxx_enum_type value; }
      constants[12] = {
        { "SERIAL", vtkSQLDatabaseSchema::SERIAL },
        { "SMALLINT", vtkSQLDatabaseSchema::SMALLINT },
        { "INTEGER", vtkSQLDatabaseSchema::INTEGER },
        { "BIGINT", vtkSQLDatabaseSchema::BIGINT },
        { "VARCHAR", vtkSQLDatabaseSchema::VARCHAR },
        { "TEXT", vtkSQLDatabaseSchema::TEXT },
        { "REAL", vtkSQLDatabaseSchema::REAL },
        { "DOUBLE", vtkSQLDatabaseSchema::DOUBLE },
        { "BLOB", vtkSQLDatabaseSchema::BLOB },
        { "TIME", vtkSQLDatabaseSchema::TIME },
        { "DATE", vtkSQLDatabaseSchema::DATE },
        { "TIMESTAMP", vtkSQLDatabaseSchema::TIMESTAMP },
      };

    o = PyvtkSQLDatabaseSchema_DatabaseColumnType_FromEnum(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  for (int c = 0; c < 3; c++)
  {
    typedef vtkSQLDatabaseSchema::DatabaseIndexType cxx_enum_type;

    static const struct { const char *name; cxx_enum_type value; }
      constants[3] = {
        { "INDEX", vtkSQLDatabaseSchema::INDEX },
        { "UNIQUE", vtkSQLDatabaseSchema::UNIQUE },
        { "PRIMARY_KEY", vtkSQLDatabaseSchema::PRIMARY_KEY },
      };

    o = PyvtkSQLDatabaseSchema_DatabaseIndexType_FromEnum(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  for (int c = 0; c < 6; c++)
  {
    typedef vtkSQLDatabaseSchema::DatabaseTriggerType cxx_enum_type;

    static const struct { const char *name; cxx_enum_type value; }
      constants[6] = {
        { "BEFORE_INSERT", vtkSQLDatabaseSchema::BEFORE_INSERT },
        { "AFTER_INSERT", vtkSQLDatabaseSchema::AFTER_INSERT },
        { "BEFORE_UPDATE", vtkSQLDatabaseSchema::BEFORE_UPDATE },
        { "AFTER_UPDATE", vtkSQLDatabaseSchema::AFTER_UPDATE },
        { "BEFORE_DELETE", vtkSQLDatabaseSchema::BEFORE_DELETE },
        { "AFTER_DELETE", vtkSQLDatabaseSchema::AFTER_DELETE },
      };

    o = PyvtkSQLDatabaseSchema_DatabaseTriggerType_FromEnum(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  for (int c = 0; c < 7; c++)
  {
    typedef vtkSQLDatabaseSchema::VarargTokens cxx_enum_type;

    static const struct { const char *name; cxx_enum_type value; }
      constants[7] = {
        { "COLUMN_TOKEN", vtkSQLDatabaseSchema::COLUMN_TOKEN },
        { "INDEX_TOKEN", vtkSQLDatabaseSchema::INDEX_TOKEN },
        { "INDEX_COLUMN_TOKEN", vtkSQLDatabaseSchema::INDEX_COLUMN_TOKEN },
        { "END_INDEX_TOKEN", vtkSQLDatabaseSchema::END_INDEX_TOKEN },
        { "TRIGGER_TOKEN", vtkSQLDatabaseSchema::TRIGGER_TOKEN },
        { "OPTION_TOKEN", vtkSQLDatabaseSchema::OPTION_TOKEN },
        { "END_TABLE_TOKEN", vtkSQLDatabaseSchema::END_TABLE_TOKEN },
      };

    o = PyvtkSQLDatabaseSchema_VarargTokens_FromEnum(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkSQLDatabaseSchema_Doc()
{
  static const char *docstring[] = {
    "vtkSQLDatabaseSchema - represent an SQL database schema\n\n",
    "Superclass: vtkObject\n\n",
    "This class stores the information required to create an SQL database\nfrom scratch. Information on each table's columns, indices, and\ntriggers is stored. You may also store an arbitrary number of\npreamble statements, intended to be executed before any tables are\ncreated; this provides a way to create procedures or functions that\nmay be invoked as part of a trigger action. Triggers and table\noptions",
    " may be specified differently for each backend database type\nyou wish to support.\n\n@par Thanks: Thanks to Philippe Pebay and David Thompson from Sandia\nNational Laboratories for implementing this class.\n\n@sa\nvtkSQLDatabase\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkSQLDatabaseSchema(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkSQLDatabaseSchema_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkSQLDatabaseSchema", o) != 0)
  {
    Py_DECREF(o);
  }

  o = PyString_FromString((char *)("*"));
  if (o)
  {
    PyDict_SetItemString(dict, "VTK_SQL_ALLBACKENDS", o);
    Py_DECREF(o);
  }
  o = PyString_FromString((char *)("vtkMySQLDatabase"));
  if (o)
  {
    PyDict_SetItemString(dict, "VTK_SQL_MYSQL", o);
    Py_DECREF(o);
  }
  o = PyString_FromString((char *)("vtkPostgreSQLDatabase"));
  if (o)
  {
    PyDict_SetItemString(dict, "VTK_SQL_POSTGRESQL", o);
    Py_DECREF(o);
  }
  o = PyString_FromString((char *)("vtkSQLiteDatabase"));
  if (o)
  {
    PyDict_SetItemString(dict, "VTK_SQL_SQLITE", o);
    Py_DECREF(o);
  }
}

