// python wrapper for vtkTriangularTCoords
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkTriangularTCoords.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkTriangularTCoords(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkTriangularTCoords_ClassNew(); }

#ifndef DECLARED_PyvtkPolyDataAlgorithm_ClassNew
extern "C" { PyObject *PyvtkPolyDataAlgorithm_ClassNew(); }
#define DECLARED_PyvtkPolyDataAlgorithm_ClassNew
#endif

static const char **PyvtkTriangularTCoords_Doc();


static PyObject *
PyvtkTriangularTCoords_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTriangularTCoords *op = static_cast<vtkTriangularTCoords *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkTriangularTCoords::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTriangularTCoords_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTriangularTCoords *op = static_cast<vtkTriangularTCoords *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkTriangularTCoords::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTriangularTCoords_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTriangularTCoords *op = static_cast<vtkTriangularTCoords *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkTriangularTCoords *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkTriangularTCoords::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkTriangularTCoords_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkTriangularTCoords *tempr = vtkTriangularTCoords::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkTriangularTCoords_Methods[] = {
  {"GetClassName", PyvtkTriangularTCoords_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkTriangularTCoords_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkTriangularTCoords_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkTriangularTCoords\nC++: vtkTriangularTCoords *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkTriangularTCoords_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkTriangularTCoords\nC++: vtkTriangularTCoords *SafeDownCast(vtkObject* o)\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkTriangularTCoords_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersTexturePython.vtkTriangularTCoords", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkTriangularTCoords_StaticNew()
{
  return vtkTriangularTCoords::New();
}

PyObject *PyvtkTriangularTCoords_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkTriangularTCoords_Type, PyvtkTriangularTCoords_Methods,
    "vtkTriangularTCoords",
    PyvtkTriangularTCoords_Doc(), &PyvtkTriangularTCoords_StaticNew);

  PyTypeObject *pytype = &PyvtkTriangularTCoords_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkPolyDataAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkTriangularTCoords_Doc()
{
  static const char *docstring[] = {
    "vtkTriangularTCoords - 2D texture coordinates based for triangles.\n\n",
    "Superclass: vtkPolyDataAlgorithm\n\n",
    "vtkTriangularTCoords is a filter that generates texture coordinates\nfor triangles. Texture coordinates for each triangle are: (0,0),\n(1,0) and (.5,sqrt(3)/2). This filter assumes that the triangle\ntexture map is symmetric about the center of the triangle. Thus the\norder Of the texture coordinates is not important. The procedural\ntexture in vtkTriangularTexture is designed with this symmetry. For\nm",
    "ore information see the paper \"Opacity-modulating Triangular\nTextures for Irregular Surfaces,\"  by Penny Rheingans, IEEE\nVisualization '96, pp. 219-225.\n@sa\nvtkTriangularTexture vtkThresholdPoints vtkTextureMapToPlane\nvtkTextureMapToSphere vtkTextureMapToCylinder\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkTriangularTCoords(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkTriangularTCoords_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkTriangularTCoords", o) != 0)
  {
    Py_DECREF(o);
  }

}

