// python wrapper for vtkVolumeRayCastCompositeFunction
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkVolumeRayCastCompositeFunction.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkVolumeRayCastCompositeFunction(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkVolumeRayCastCompositeFunction_ClassNew(); }

#ifndef DECLARED_PyvtkVolumeRayCastFunction_ClassNew
extern "C" { PyObject *PyvtkVolumeRayCastFunction_ClassNew(); }
#define DECLARED_PyvtkVolumeRayCastFunction_ClassNew
#endif

static const char **PyvtkVolumeRayCastCompositeFunction_Doc();


static PyObject *
PyvtkVolumeRayCastCompositeFunction_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeRayCastCompositeFunction *op = static_cast<vtkVolumeRayCastCompositeFunction *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkVolumeRayCastCompositeFunction::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeRayCastCompositeFunction_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeRayCastCompositeFunction *op = static_cast<vtkVolumeRayCastCompositeFunction *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkVolumeRayCastCompositeFunction::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeRayCastCompositeFunction_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeRayCastCompositeFunction *op = static_cast<vtkVolumeRayCastCompositeFunction *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkVolumeRayCastCompositeFunction *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkVolumeRayCastCompositeFunction::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeRayCastCompositeFunction_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkVolumeRayCastCompositeFunction *tempr = vtkVolumeRayCastCompositeFunction::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeRayCastCompositeFunction_SetCompositeMethod(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCompositeMethod");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeRayCastCompositeFunction *op = static_cast<vtkVolumeRayCastCompositeFunction *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetCompositeMethod(temp0);
    }
    else
    {
      op->vtkVolumeRayCastCompositeFunction::SetCompositeMethod(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeRayCastCompositeFunction_GetCompositeMethodMinValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCompositeMethodMinValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeRayCastCompositeFunction *op = static_cast<vtkVolumeRayCastCompositeFunction *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetCompositeMethodMinValue() :
      op->vtkVolumeRayCastCompositeFunction::GetCompositeMethodMinValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeRayCastCompositeFunction_GetCompositeMethodMaxValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCompositeMethodMaxValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeRayCastCompositeFunction *op = static_cast<vtkVolumeRayCastCompositeFunction *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetCompositeMethodMaxValue() :
      op->vtkVolumeRayCastCompositeFunction::GetCompositeMethodMaxValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeRayCastCompositeFunction_GetCompositeMethod(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCompositeMethod");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeRayCastCompositeFunction *op = static_cast<vtkVolumeRayCastCompositeFunction *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetCompositeMethod() :
      op->vtkVolumeRayCastCompositeFunction::GetCompositeMethod());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeRayCastCompositeFunction_SetCompositeMethodToInterpolateFirst(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCompositeMethodToInterpolateFirst");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeRayCastCompositeFunction *op = static_cast<vtkVolumeRayCastCompositeFunction *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetCompositeMethodToInterpolateFirst();
    }
    else
    {
      op->vtkVolumeRayCastCompositeFunction::SetCompositeMethodToInterpolateFirst();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeRayCastCompositeFunction_SetCompositeMethodToClassifyFirst(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCompositeMethodToClassifyFirst");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeRayCastCompositeFunction *op = static_cast<vtkVolumeRayCastCompositeFunction *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->SetCompositeMethodToClassifyFirst();
    }
    else
    {
      op->vtkVolumeRayCastCompositeFunction::SetCompositeMethodToClassifyFirst();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeRayCastCompositeFunction_GetCompositeMethodAsString(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCompositeMethodAsString");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeRayCastCompositeFunction *op = static_cast<vtkVolumeRayCastCompositeFunction *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetCompositeMethodAsString() :
      op->vtkVolumeRayCastCompositeFunction::GetCompositeMethodAsString());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeRayCastCompositeFunction_CastRay(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CastRay");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeRayCastCompositeFunction *op = static_cast<vtkVolumeRayCastCompositeFunction *>(vp);

  vtkVolumeRayCastDynamicInfo *temp0 = NULL;
  vtkVolumeRayCastStaticInfo *temp1 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(2) &&
      ap.GetVTKObject(temp0, "vtkVolumeRayCastDynamicInfo") &&
      ap.GetVTKObject(temp1, "vtkVolumeRayCastStaticInfo"))
  {
    if (ap.IsBound())
    {
      op->CastRay(temp0, temp1);
    }
    else
    {
      op->vtkVolumeRayCastCompositeFunction::CastRay(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeRayCastCompositeFunction_GetZeroOpacityThreshold(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetZeroOpacityThreshold");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeRayCastCompositeFunction *op = static_cast<vtkVolumeRayCastCompositeFunction *>(vp);

  vtkVolume *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkVolume"))
  {
    float tempr = (ap.IsBound() ?
      op->GetZeroOpacityThreshold(temp0) :
      op->vtkVolumeRayCastCompositeFunction::GetZeroOpacityThreshold(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkVolumeRayCastCompositeFunction_Methods[] = {
  {"GetClassName", PyvtkVolumeRayCastCompositeFunction_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkVolumeRayCastCompositeFunction_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkVolumeRayCastCompositeFunction_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkVolumeRayCastCompositeFunction\nC++: vtkVolumeRayCastCompositeFunction *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkVolumeRayCastCompositeFunction_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkVolumeRayCastCompositeFunction\nC++: vtkVolumeRayCastCompositeFunction *SafeDownCast(vtkObject* o)\n\n"},
  {"SetCompositeMethod", PyvtkVolumeRayCastCompositeFunction_SetCompositeMethod, METH_VARARGS,
   "V.SetCompositeMethod(int)\nC++: void SetCompositeMethod(int)\n\nSet the CompositeMethod to either Classify First or Interpolate\nFirst\n"},
  {"GetCompositeMethodMinValue", PyvtkVolumeRayCastCompositeFunction_GetCompositeMethodMinValue, METH_VARARGS,
   "V.GetCompositeMethodMinValue() -> int\nC++: int GetCompositeMethodMinValue()\n\nSet the CompositeMethod to either Classify First or Interpolate\nFirst\n"},
  {"GetCompositeMethodMaxValue", PyvtkVolumeRayCastCompositeFunction_GetCompositeMethodMaxValue, METH_VARARGS,
   "V.GetCompositeMethodMaxValue() -> int\nC++: int GetCompositeMethodMaxValue()\n\nSet the CompositeMethod to either Classify First or Interpolate\nFirst\n"},
  {"GetCompositeMethod", PyvtkVolumeRayCastCompositeFunction_GetCompositeMethod, METH_VARARGS,
   "V.GetCompositeMethod() -> int\nC++: int GetCompositeMethod()\n\nSet the CompositeMethod to either Classify First or Interpolate\nFirst\n"},
  {"SetCompositeMethodToInterpolateFirst", PyvtkVolumeRayCastCompositeFunction_SetCompositeMethodToInterpolateFirst, METH_VARARGS,
   "V.SetCompositeMethodToInterpolateFirst()\nC++: void SetCompositeMethodToInterpolateFirst()\n\nSet the CompositeMethod to either Classify First or Interpolate\nFirst\n"},
  {"SetCompositeMethodToClassifyFirst", PyvtkVolumeRayCastCompositeFunction_SetCompositeMethodToClassifyFirst, METH_VARARGS,
   "V.SetCompositeMethodToClassifyFirst()\nC++: void SetCompositeMethodToClassifyFirst()\n\nSet the CompositeMethod to either Classify First or Interpolate\nFirst\n"},
  {"GetCompositeMethodAsString", PyvtkVolumeRayCastCompositeFunction_GetCompositeMethodAsString, METH_VARARGS,
   "V.GetCompositeMethodAsString() -> string\nC++: const char *GetCompositeMethodAsString(void)\n\nSet the CompositeMethod to either Classify First or Interpolate\nFirst\n"},
  {"CastRay", PyvtkVolumeRayCastCompositeFunction_CastRay, METH_VARARGS,
   "V.CastRay(vtkVolumeRayCastDynamicInfo, vtkVolumeRayCastStaticInfo)\nC++: void CastRay(vtkVolumeRayCastDynamicInfo *dynamicInfo,\n    vtkVolumeRayCastStaticInfo *staticInfo)\n\n"},
  {"GetZeroOpacityThreshold", PyvtkVolumeRayCastCompositeFunction_GetZeroOpacityThreshold, METH_VARARGS,
   "V.GetZeroOpacityThreshold(vtkVolume) -> float\nC++: float GetZeroOpacityThreshold(vtkVolume *vol)\n\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkVolumeRayCastCompositeFunction_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkRenderingVolumePython.vtkVolumeRayCastCompositeFunction", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkVolumeRayCastCompositeFunction_StaticNew()
{
  return vtkVolumeRayCastCompositeFunction::New();
}

PyObject *PyvtkVolumeRayCastCompositeFunction_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkVolumeRayCastCompositeFunction_Type, PyvtkVolumeRayCastCompositeFunction_Methods,
    "vtkVolumeRayCastCompositeFunction",
    PyvtkVolumeRayCastCompositeFunction_Doc(), &PyvtkVolumeRayCastCompositeFunction_StaticNew);

  PyTypeObject *pytype = &PyvtkVolumeRayCastCompositeFunction_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkVolumeRayCastFunction_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkVolumeRayCastCompositeFunction_Doc()
{
  static const char *docstring[] = {
    "vtkVolumeRayCastCompositeFunction - a ray function for compositing\n\n",
    "Superclass: vtkVolumeRayCastFunction\n\n",
    "vtkVolumeRayCastCompositeFunction is a ray function that can be used\nwithin a vtkVolumeRayCastMapper. This function performs compositing\nalong the ray according to the properties stored in the\nvtkVolumeProperty for the volume.\n\n@sa\nvtkVolumeRayCastMapper vtkVolumeProperty vtkVolume@deprecated\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkVolumeRayCastCompositeFunction(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkVolumeRayCastCompositeFunction_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkVolumeRayCastCompositeFunction", o) != 0)
  {
    Py_DECREF(o);
  }

  for (int c = 0; c < 2; c++)
  {
    static const struct { const char *name; int value; }
      constants[2] = {
        { "VTK_COMPOSITE_CLASSIFY_FIRST", 0 },
        { "VTK_COMPOSITE_INTERPOLATE_FIRST", 1 },
      };

    o = PyInt_FromLong(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(dict, constants[c].name, o);
      Py_DECREF(o);
    }
  }

}

