#include "vtkTclUtil.h"
#include "vtkVersion.h"
#define VTK_TCL_TO_STRING(x) VTK_TCL_TO_STRING0(x)
#define VTK_TCL_TO_STRING0(x) #x
extern "C"
{
#if (TCL_MAJOR_VERSION == 8) && (TCL_MINOR_VERSION >= 4)
  typedef int (*vtkTclCommandType)(ClientData, Tcl_Interp *,int, CONST84 char *[]);
#else
  typedef int (*vtkTclCommandType)(ClientData, Tcl_Interp *,int, char *[]);
#endif
}

int vtkAppendFilter_TclCreate(Tcl_Interp *interp);
int vtkAppendPolyData_TclCreate(Tcl_Interp *interp);
int vtkAppendSelection_TclCreate(Tcl_Interp *interp);
int vtkArrayCalculator_TclCreate(Tcl_Interp *interp);
int vtkAssignAttribute_TclCreate(Tcl_Interp *interp);
int vtkAttributeDataToFieldDataFilter_TclCreate(Tcl_Interp *interp);
int vtkBinCellDataFilter_TclCreate(Tcl_Interp *interp);
int vtkCellDataToPointData_TclCreate(Tcl_Interp *interp);
int vtkCleanPolyData_TclCreate(Tcl_Interp *interp);
int vtkClipPolyData_TclCreate(Tcl_Interp *interp);
int vtkCompositeDataProbeFilter_TclCreate(Tcl_Interp *interp);
int vtkConnectivityFilter_TclCreate(Tcl_Interp *interp);
int vtkContourFilter_TclCreate(Tcl_Interp *interp);
int vtkContourGrid_TclCreate(Tcl_Interp *interp);
int vtkDataObjectGenerator_TclCreate(Tcl_Interp *interp);
int vtkDataObjectToDataSetFilter_TclCreate(Tcl_Interp *interp);
int vtkDataSetEdgeSubdivisionCriterion_TclCreate(Tcl_Interp *interp);
int vtkDataSetToDataObjectFilter_TclCreate(Tcl_Interp *interp);
int vtkDecimatePolylineFilter_TclCreate(Tcl_Interp *interp);
int vtkDecimatePro_TclCreate(Tcl_Interp *interp);
int vtkDelaunay2D_TclCreate(Tcl_Interp *interp);
int vtkDelaunay3D_TclCreate(Tcl_Interp *interp);
int vtkElevationFilter_TclCreate(Tcl_Interp *interp);
int vtkExecutionTimer_TclCreate(Tcl_Interp *interp);
int vtkFeatureEdges_TclCreate(Tcl_Interp *interp);
int vtkFieldDataToAttributeDataFilter_TclCreate(Tcl_Interp *interp);
int vtkFlyingEdges2D_TclCreate(Tcl_Interp *interp);
int vtkFlyingEdges3D_TclCreate(Tcl_Interp *interp);
int vtkFlyingEdgesPlaneCutter_TclCreate(Tcl_Interp *interp);
int vtkGlyph2D_TclCreate(Tcl_Interp *interp);
int vtkGlyph3D_TclCreate(Tcl_Interp *interp);
int vtkHedgeHog_TclCreate(Tcl_Interp *interp);
int vtkHull_TclCreate(Tcl_Interp *interp);
int vtkIdFilter_TclCreate(Tcl_Interp *interp);
int vtkMarchingCubes_TclCreate(Tcl_Interp *interp);
int vtkMarchingSquares_TclCreate(Tcl_Interp *interp);
int vtkMaskFields_TclCreate(Tcl_Interp *interp);
int vtkMaskPoints_TclCreate(Tcl_Interp *interp);
int vtkMaskPolyData_TclCreate(Tcl_Interp *interp);
int vtkMassProperties_TclCreate(Tcl_Interp *interp);
int vtkMergeDataObjectFilter_TclCreate(Tcl_Interp *interp);
int vtkMergeFields_TclCreate(Tcl_Interp *interp);
int vtkMergeFilter_TclCreate(Tcl_Interp *interp);
int vtkPointDataToCellData_TclCreate(Tcl_Interp *interp);
int vtkPolyDataConnectivityFilter_TclCreate(Tcl_Interp *interp);
int vtkPolyDataNormals_TclCreate(Tcl_Interp *interp);
int vtkProbeFilter_TclCreate(Tcl_Interp *interp);
int vtkQuadricClustering_TclCreate(Tcl_Interp *interp);
int vtkQuadricDecimation_TclCreate(Tcl_Interp *interp);
int vtkRearrangeFields_TclCreate(Tcl_Interp *interp);
int vtkResampleToImage_TclCreate(Tcl_Interp *interp);
int vtkResampleWithDataSet_TclCreate(Tcl_Interp *interp);
int vtkReverseSense_TclCreate(Tcl_Interp *interp);
int vtkSimpleElevationFilter_TclCreate(Tcl_Interp *interp);
int vtkSmoothPolyDataFilter_TclCreate(Tcl_Interp *interp);
int vtkStripper_TclCreate(Tcl_Interp *interp);
int vtkStructuredGridOutlineFilter_TclCreate(Tcl_Interp *interp);
int vtkSynchronizedTemplates2D_TclCreate(Tcl_Interp *interp);
int vtkSynchronizedTemplates3D_TclCreate(Tcl_Interp *interp);
int vtkSynchronizedTemplatesCutter3D_TclCreate(Tcl_Interp *interp);
int vtkTensorGlyph_TclCreate(Tcl_Interp *interp);
int vtkThreshold_TclCreate(Tcl_Interp *interp);
int vtkThresholdPoints_TclCreate(Tcl_Interp *interp);
int vtkTransposeTable_TclCreate(Tcl_Interp *interp);
int vtkTriangleFilter_TclCreate(Tcl_Interp *interp);
int vtkTubeFilter_TclCreate(Tcl_Interp *interp);
int vtkUnstructuredGridQuadricDecimation_TclCreate(Tcl_Interp *interp);
int vtkVectorDot_TclCreate(Tcl_Interp *interp);
int vtkVectorNorm_TclCreate(Tcl_Interp *interp);
int vtkWindowedSincPolyDataFilter_TclCreate(Tcl_Interp *interp);
int vtkCutter_TclCreate(Tcl_Interp *interp);
int vtkCompositeCutter_TclCreate(Tcl_Interp *interp);
int vtkGridSynchronizedTemplates3D_TclCreate(Tcl_Interp *interp);
int vtkRectilinearSynchronizedTemplates_TclCreate(Tcl_Interp *interp);
int vtkEdgeSubdivisionCriterion_TclCreate(Tcl_Interp *interp);
int vtkStreamingTessellator_TclCreate(Tcl_Interp *interp);
int vtkImplicitPolyDataDistance_TclCreate(Tcl_Interp *interp);
int vtkStreamerBase_TclCreate(Tcl_Interp *interp);
int vtkCenterOfMass_TclCreate(Tcl_Interp *interp);
int vtkImageAppend_TclCreate(Tcl_Interp *interp);
int vtkStructuredGridAppend_TclCreate(Tcl_Interp *interp);
int vtkAppendCompositeDataLeaves_TclCreate(Tcl_Interp *interp);

extern Tcl_HashTable vtkInstanceLookup;
extern Tcl_HashTable vtkPointerLookup;
extern Tcl_HashTable vtkCommandLookup;
extern void vtkTclDeleteObjectFromHash(void *);
extern void vtkTclListInstances(Tcl_Interp *interp, ClientData arg);


extern "C" {int VTK_EXPORT Vtkfilterscoretcl_SafeInit(Tcl_Interp *interp);}

extern "C" {int VTK_EXPORT Vtkfilterscoretcl_Init(Tcl_Interp *interp);}

extern void vtkTclGenericDeleteObject(ClientData cd);


int VTK_EXPORT Vtkfilterscoretcl_SafeInit(Tcl_Interp *interp)
{
  return Vtkfilterscoretcl_Init(interp);
}


int VTK_EXPORT Vtkfilterscoretcl_Init(Tcl_Interp *interp)
{

  vtkAppendFilter_TclCreate(interp);
  vtkAppendPolyData_TclCreate(interp);
  vtkAppendSelection_TclCreate(interp);
  vtkArrayCalculator_TclCreate(interp);
  vtkAssignAttribute_TclCreate(interp);
  vtkAttributeDataToFieldDataFilter_TclCreate(interp);
  vtkBinCellDataFilter_TclCreate(interp);
  vtkCellDataToPointData_TclCreate(interp);
  vtkCleanPolyData_TclCreate(interp);
  vtkClipPolyData_TclCreate(interp);
  vtkCompositeDataProbeFilter_TclCreate(interp);
  vtkConnectivityFilter_TclCreate(interp);
  vtkContourFilter_TclCreate(interp);
  vtkContourGrid_TclCreate(interp);
  vtkDataObjectGenerator_TclCreate(interp);
  vtkDataObjectToDataSetFilter_TclCreate(interp);
  vtkDataSetEdgeSubdivisionCriterion_TclCreate(interp);
  vtkDataSetToDataObjectFilter_TclCreate(interp);
  vtkDecimatePolylineFilter_TclCreate(interp);
  vtkDecimatePro_TclCreate(interp);
  vtkDelaunay2D_TclCreate(interp);
  vtkDelaunay3D_TclCreate(interp);
  vtkElevationFilter_TclCreate(interp);
  vtkExecutionTimer_TclCreate(interp);
  vtkFeatureEdges_TclCreate(interp);
  vtkFieldDataToAttributeDataFilter_TclCreate(interp);
  vtkFlyingEdges2D_TclCreate(interp);
  vtkFlyingEdges3D_TclCreate(interp);
  vtkFlyingEdgesPlaneCutter_TclCreate(interp);
  vtkGlyph2D_TclCreate(interp);
  vtkGlyph3D_TclCreate(interp);
  vtkHedgeHog_TclCreate(interp);
  vtkHull_TclCreate(interp);
  vtkIdFilter_TclCreate(interp);
  vtkMarchingCubes_TclCreate(interp);
  vtkMarchingSquares_TclCreate(interp);
  vtkMaskFields_TclCreate(interp);
  vtkMaskPoints_TclCreate(interp);
  vtkMaskPolyData_TclCreate(interp);
  vtkMassProperties_TclCreate(interp);
  vtkMergeDataObjectFilter_TclCreate(interp);
  vtkMergeFields_TclCreate(interp);
  vtkMergeFilter_TclCreate(interp);
  vtkPointDataToCellData_TclCreate(interp);
  vtkPolyDataConnectivityFilter_TclCreate(interp);
  vtkPolyDataNormals_TclCreate(interp);
  vtkProbeFilter_TclCreate(interp);
  vtkQuadricClustering_TclCreate(interp);
  vtkQuadricDecimation_TclCreate(interp);
  vtkRearrangeFields_TclCreate(interp);
  vtkResampleToImage_TclCreate(interp);
  vtkResampleWithDataSet_TclCreate(interp);
  vtkReverseSense_TclCreate(interp);
  vtkSimpleElevationFilter_TclCreate(interp);
  vtkSmoothPolyDataFilter_TclCreate(interp);
  vtkStripper_TclCreate(interp);
  vtkStructuredGridOutlineFilter_TclCreate(interp);
  vtkSynchronizedTemplates2D_TclCreate(interp);
  vtkSynchronizedTemplates3D_TclCreate(interp);
  vtkSynchronizedTemplatesCutter3D_TclCreate(interp);
  vtkTensorGlyph_TclCreate(interp);
  vtkThreshold_TclCreate(interp);
  vtkThresholdPoints_TclCreate(interp);
  vtkTransposeTable_TclCreate(interp);
  vtkTriangleFilter_TclCreate(interp);
  vtkTubeFilter_TclCreate(interp);
  vtkUnstructuredGridQuadricDecimation_TclCreate(interp);
  vtkVectorDot_TclCreate(interp);
  vtkVectorNorm_TclCreate(interp);
  vtkWindowedSincPolyDataFilter_TclCreate(interp);
  vtkCutter_TclCreate(interp);
  vtkCompositeCutter_TclCreate(interp);
  vtkGridSynchronizedTemplates3D_TclCreate(interp);
  vtkRectilinearSynchronizedTemplates_TclCreate(interp);
  vtkEdgeSubdivisionCriterion_TclCreate(interp);
  vtkStreamingTessellator_TclCreate(interp);
  vtkImplicitPolyDataDistance_TclCreate(interp);
  vtkStreamerBase_TclCreate(interp);
  vtkCenterOfMass_TclCreate(interp);
  vtkImageAppend_TclCreate(interp);
  vtkStructuredGridAppend_TclCreate(interp);
  vtkAppendCompositeDataLeaves_TclCreate(interp);
  char pkgName[]="vtkFiltersCoreTCL";
  char pkgVers[]=VTK_TCL_TO_STRING(VTK_MAJOR_VERSION) "." VTK_TCL_TO_STRING(VTK_MINOR_VERSION);
  Tcl_PkgProvide(interp, pkgName, pkgVers);
  return TCL_OK;
}
