#include "vtkTclUtil.h"
#include "vtkVersion.h"
#define VTK_TCL_TO_STRING(x) VTK_TCL_TO_STRING0(x)
#define VTK_TCL_TO_STRING0(x) #x
extern "C"
{
#if (TCL_MAJOR_VERSION == 8) && (TCL_MINOR_VERSION >= 4)
  typedef int (*vtkTclCommandType)(ClientData, Tcl_Interp *,int, CONST84 char *[]);
#else
  typedef int (*vtkTclCommandType)(ClientData, Tcl_Interp *,int, char *[]);
#endif
}

int vtkAnnotationLink_TclCreate(Tcl_Interp *interp);
int vtkAppendPoints_TclCreate(Tcl_Interp *interp);
int vtkApproximatingSubdivisionFilter_TclCreate(Tcl_Interp *interp);
int vtkAreaContourSpectrumFilter_TclCreate(Tcl_Interp *interp);
int vtkAxes_TclCreate(Tcl_Interp *interp);
int vtkBlankStructuredGrid_TclCreate(Tcl_Interp *interp);
int vtkBlankStructuredGridWithImage_TclCreate(Tcl_Interp *interp);
int vtkBlockIdScalars_TclCreate(Tcl_Interp *interp);
int vtkBoxClipDataSet_TclCreate(Tcl_Interp *interp);
int vtkBrownianPoints_TclCreate(Tcl_Interp *interp);
int vtkCellCenters_TclCreate(Tcl_Interp *interp);
int vtkCellDerivatives_TclCreate(Tcl_Interp *interp);
int vtkClipClosedSurface_TclCreate(Tcl_Interp *interp);
int vtkClipConvexPolyData_TclCreate(Tcl_Interp *interp);
int vtkClipDataSet_TclCreate(Tcl_Interp *interp);
int vtkClipVolume_TclCreate(Tcl_Interp *interp);
int vtkCoincidentPoints_TclCreate(Tcl_Interp *interp);
int vtkContourTriangulator_TclCreate(Tcl_Interp *interp);
int vtkCountFaces_TclCreate(Tcl_Interp *interp);
int vtkCountVertices_TclCreate(Tcl_Interp *interp);
int vtkCursor2D_TclCreate(Tcl_Interp *interp);
int vtkCursor3D_TclCreate(Tcl_Interp *interp);
int vtkCurvatures_TclCreate(Tcl_Interp *interp);
int vtkDataSetGradient_TclCreate(Tcl_Interp *interp);
int vtkDataSetGradientPrecompute_TclCreate(Tcl_Interp *interp);
int vtkDataSetTriangleFilter_TclCreate(Tcl_Interp *interp);
int vtkDeformPointSet_TclCreate(Tcl_Interp *interp);
int vtkDensifyPolyData_TclCreate(Tcl_Interp *interp);
int vtkDicer_TclCreate(Tcl_Interp *interp);
int vtkDiscreteMarchingCubes_TclCreate(Tcl_Interp *interp);
int vtkEdgePoints_TclCreate(Tcl_Interp *interp);
int vtkExtractSelectedFrustum_TclCreate(Tcl_Interp *interp);
int vtkExtractSelectionBase_TclCreate(Tcl_Interp *interp);
int vtkGradientFilter_TclCreate(Tcl_Interp *interp);
int vtkGraphLayoutFilter_TclCreate(Tcl_Interp *interp);
int vtkGraphToPoints_TclCreate(Tcl_Interp *interp);
int vtkHierarchicalDataLevelFilter_TclCreate(Tcl_Interp *interp);
int vtkHyperStreamline_TclCreate(Tcl_Interp *interp);
int vtkIconGlyphFilter_TclCreate(Tcl_Interp *interp);
int vtkImageMarchingCubes_TclCreate(Tcl_Interp *interp);
int vtkInterpolateDataSetAttributes_TclCreate(Tcl_Interp *interp);
int vtkInterpolatingSubdivisionFilter_TclCreate(Tcl_Interp *interp);
int vtkLevelIdScalars_TclCreate(Tcl_Interp *interp);
int vtkLinkEdgels_TclCreate(Tcl_Interp *interp);
int vtkMergeCells_TclCreate(Tcl_Interp *interp);
int vtkMultiBlockDataGroupFilter_TclCreate(Tcl_Interp *interp);
int vtkMultiBlockFromTimeSeriesFilter_TclCreate(Tcl_Interp *interp);
int vtkMultiBlockMergeFilter_TclCreate(Tcl_Interp *interp);
int vtkMultiThreshold_TclCreate(Tcl_Interp *interp);
int vtkOBBDicer_TclCreate(Tcl_Interp *interp);
int vtkOBBTree_TclCreate(Tcl_Interp *interp);
int vtkPassThrough_TclCreate(Tcl_Interp *interp);
int vtkPointConnectivityFilter_TclCreate(Tcl_Interp *interp);
int vtkPolyDataStreamer_TclCreate(Tcl_Interp *interp);
int vtkPolyDataToReebGraphFilter_TclCreate(Tcl_Interp *interp);
int vtkProbePolyhedron_TclCreate(Tcl_Interp *interp);
int vtkQuadraturePointInterpolator_TclCreate(Tcl_Interp *interp);
int vtkQuadraturePointsGenerator_TclCreate(Tcl_Interp *interp);
int vtkQuadratureSchemeDictionaryGenerator_TclCreate(Tcl_Interp *interp);
int vtkQuantizePolyDataPoints_TclCreate(Tcl_Interp *interp);
int vtkRandomAttributeGenerator_TclCreate(Tcl_Interp *interp);
int vtkRectilinearGridClip_TclCreate(Tcl_Interp *interp);
int vtkRectilinearGridToTetrahedra_TclCreate(Tcl_Interp *interp);
int vtkRecursiveDividingCubes_TclCreate(Tcl_Interp *interp);
int vtkReflectionFilter_TclCreate(Tcl_Interp *interp);
int vtkRotationFilter_TclCreate(Tcl_Interp *interp);
int vtkSampleImplicitFunctionFilter_TclCreate(Tcl_Interp *interp);
int vtkShrinkFilter_TclCreate(Tcl_Interp *interp);
int vtkShrinkPolyData_TclCreate(Tcl_Interp *interp);
int vtkSpatialRepresentationFilter_TclCreate(Tcl_Interp *interp);
int vtkSplineFilter_TclCreate(Tcl_Interp *interp);
int vtkSplitField_TclCreate(Tcl_Interp *interp);
int vtkStructuredGridClip_TclCreate(Tcl_Interp *interp);
int vtkSubPixelPositionEdgels_TclCreate(Tcl_Interp *interp);
int vtkTableBasedClipDataSet_TclCreate(Tcl_Interp *interp);
int vtkTableToPolyData_TclCreate(Tcl_Interp *interp);
int vtkTableToStructuredGrid_TclCreate(Tcl_Interp *interp);
int vtkTemporalPathLineFilter_TclCreate(Tcl_Interp *interp);
int vtkTemporalStatistics_TclCreate(Tcl_Interp *interp);
int vtkTessellatorFilter_TclCreate(Tcl_Interp *interp);
int vtkTimeSourceExample_TclCreate(Tcl_Interp *interp);
int vtkTransformFilter_TclCreate(Tcl_Interp *interp);
int vtkTransformPolyDataFilter_TclCreate(Tcl_Interp *interp);
int vtkUncertaintyTubeFilter_TclCreate(Tcl_Interp *interp);
int vtkVertexGlyphFilter_TclCreate(Tcl_Interp *interp);
int vtkVolumeContourSpectrumFilter_TclCreate(Tcl_Interp *interp);
int vtkVoxelContoursToSurfaceFilter_TclCreate(Tcl_Interp *interp);
int vtkWarpLens_TclCreate(Tcl_Interp *interp);
int vtkWarpScalar_TclCreate(Tcl_Interp *interp);
int vtkWarpTo_TclCreate(Tcl_Interp *interp);
int vtkWarpVector_TclCreate(Tcl_Interp *interp);
int vtkYoungsMaterialInterface_TclCreate(Tcl_Interp *interp);
int vtkMarchingContourFilter_TclCreate(Tcl_Interp *interp);
int vtkRectilinearGridToPointSet_TclCreate(Tcl_Interp *interp);
int vtkGraphWeightEuclideanDistanceFilter_TclCreate(Tcl_Interp *interp);
int vtkGraphWeightFilter_TclCreate(Tcl_Interp *interp);
int vtkImageDataToPointSet_TclCreate(Tcl_Interp *interp);
int vtkIntersectionPolyDataFilter_TclCreate(Tcl_Interp *interp);
int vtkBooleanOperationPolyDataFilter_TclCreate(Tcl_Interp *interp);
int vtkDistancePolyDataFilter_TclCreate(Tcl_Interp *interp);
int vtkOverlappingAMRLevelIdScalars_TclCreate(Tcl_Interp *interp);
int vtkExtractArray_TclCreate(Tcl_Interp *interp);
int vtkMatricizeArray_TclCreate(Tcl_Interp *interp);
int vtkNormalizeMatrixVectors_TclCreate(Tcl_Interp *interp);
int vtkPassArrays_TclCreate(Tcl_Interp *interp);
int vtkSplitColumnComponents_TclCreate(Tcl_Interp *interp);
int vtkCellTreeLocator_TclCreate(Tcl_Interp *interp);

extern Tcl_HashTable vtkInstanceLookup;
extern Tcl_HashTable vtkPointerLookup;
extern Tcl_HashTable vtkCommandLookup;
extern void vtkTclDeleteObjectFromHash(void *);
extern void vtkTclListInstances(Tcl_Interp *interp, ClientData arg);


extern "C" {int VTK_EXPORT Vtkfiltersgeneraltcl_SafeInit(Tcl_Interp *interp);}

extern "C" {int VTK_EXPORT Vtkfiltersgeneraltcl_Init(Tcl_Interp *interp);}

extern void vtkTclGenericDeleteObject(ClientData cd);


int VTK_EXPORT Vtkfiltersgeneraltcl_SafeInit(Tcl_Interp *interp)
{
  return Vtkfiltersgeneraltcl_Init(interp);
}


int VTK_EXPORT Vtkfiltersgeneraltcl_Init(Tcl_Interp *interp)
{

  vtkAnnotationLink_TclCreate(interp);
  vtkAppendPoints_TclCreate(interp);
  vtkApproximatingSubdivisionFilter_TclCreate(interp);
  vtkAreaContourSpectrumFilter_TclCreate(interp);
  vtkAxes_TclCreate(interp);
  vtkBlankStructuredGrid_TclCreate(interp);
  vtkBlankStructuredGridWithImage_TclCreate(interp);
  vtkBlockIdScalars_TclCreate(interp);
  vtkBoxClipDataSet_TclCreate(interp);
  vtkBrownianPoints_TclCreate(interp);
  vtkCellCenters_TclCreate(interp);
  vtkCellDerivatives_TclCreate(interp);
  vtkClipClosedSurface_TclCreate(interp);
  vtkClipConvexPolyData_TclCreate(interp);
  vtkClipDataSet_TclCreate(interp);
  vtkClipVolume_TclCreate(interp);
  vtkCoincidentPoints_TclCreate(interp);
  vtkContourTriangulator_TclCreate(interp);
  vtkCountFaces_TclCreate(interp);
  vtkCountVertices_TclCreate(interp);
  vtkCursor2D_TclCreate(interp);
  vtkCursor3D_TclCreate(interp);
  vtkCurvatures_TclCreate(interp);
  vtkDataSetGradient_TclCreate(interp);
  vtkDataSetGradientPrecompute_TclCreate(interp);
  vtkDataSetTriangleFilter_TclCreate(interp);
  vtkDeformPointSet_TclCreate(interp);
  vtkDensifyPolyData_TclCreate(interp);
  vtkDicer_TclCreate(interp);
  vtkDiscreteMarchingCubes_TclCreate(interp);
  vtkEdgePoints_TclCreate(interp);
  vtkExtractSelectedFrustum_TclCreate(interp);
  vtkExtractSelectionBase_TclCreate(interp);
  vtkGradientFilter_TclCreate(interp);
  vtkGraphLayoutFilter_TclCreate(interp);
  vtkGraphToPoints_TclCreate(interp);
  vtkHierarchicalDataLevelFilter_TclCreate(interp);
  vtkHyperStreamline_TclCreate(interp);
  vtkIconGlyphFilter_TclCreate(interp);
  vtkImageMarchingCubes_TclCreate(interp);
  vtkInterpolateDataSetAttributes_TclCreate(interp);
  vtkInterpolatingSubdivisionFilter_TclCreate(interp);
  vtkLevelIdScalars_TclCreate(interp);
  vtkLinkEdgels_TclCreate(interp);
  vtkMergeCells_TclCreate(interp);
  vtkMultiBlockDataGroupFilter_TclCreate(interp);
  vtkMultiBlockFromTimeSeriesFilter_TclCreate(interp);
  vtkMultiBlockMergeFilter_TclCreate(interp);
  vtkMultiThreshold_TclCreate(interp);
  vtkOBBDicer_TclCreate(interp);
  vtkOBBTree_TclCreate(interp);
  vtkPassThrough_TclCreate(interp);
  vtkPointConnectivityFilter_TclCreate(interp);
  vtkPolyDataStreamer_TclCreate(interp);
  vtkPolyDataToReebGraphFilter_TclCreate(interp);
  vtkProbePolyhedron_TclCreate(interp);
  vtkQuadraturePointInterpolator_TclCreate(interp);
  vtkQuadraturePointsGenerator_TclCreate(interp);
  vtkQuadratureSchemeDictionaryGenerator_TclCreate(interp);
  vtkQuantizePolyDataPoints_TclCreate(interp);
  vtkRandomAttributeGenerator_TclCreate(interp);
  vtkRectilinearGridClip_TclCreate(interp);
  vtkRectilinearGridToTetrahedra_TclCreate(interp);
  vtkRecursiveDividingCubes_TclCreate(interp);
  vtkReflectionFilter_TclCreate(interp);
  vtkRotationFilter_TclCreate(interp);
  vtkSampleImplicitFunctionFilter_TclCreate(interp);
  vtkShrinkFilter_TclCreate(interp);
  vtkShrinkPolyData_TclCreate(interp);
  vtkSpatialRepresentationFilter_TclCreate(interp);
  vtkSplineFilter_TclCreate(interp);
  vtkSplitField_TclCreate(interp);
  vtkStructuredGridClip_TclCreate(interp);
  vtkSubPixelPositionEdgels_TclCreate(interp);
  vtkTableBasedClipDataSet_TclCreate(interp);
  vtkTableToPolyData_TclCreate(interp);
  vtkTableToStructuredGrid_TclCreate(interp);
  vtkTemporalPathLineFilter_TclCreate(interp);
  vtkTemporalStatistics_TclCreate(interp);
  vtkTessellatorFilter_TclCreate(interp);
  vtkTimeSourceExample_TclCreate(interp);
  vtkTransformFilter_TclCreate(interp);
  vtkTransformPolyDataFilter_TclCreate(interp);
  vtkUncertaintyTubeFilter_TclCreate(interp);
  vtkVertexGlyphFilter_TclCreate(interp);
  vtkVolumeContourSpectrumFilter_TclCreate(interp);
  vtkVoxelContoursToSurfaceFilter_TclCreate(interp);
  vtkWarpLens_TclCreate(interp);
  vtkWarpScalar_TclCreate(interp);
  vtkWarpTo_TclCreate(interp);
  vtkWarpVector_TclCreate(interp);
  vtkYoungsMaterialInterface_TclCreate(interp);
  vtkMarchingContourFilter_TclCreate(interp);
  vtkRectilinearGridToPointSet_TclCreate(interp);
  vtkGraphWeightEuclideanDistanceFilter_TclCreate(interp);
  vtkGraphWeightFilter_TclCreate(interp);
  vtkImageDataToPointSet_TclCreate(interp);
  vtkIntersectionPolyDataFilter_TclCreate(interp);
  vtkBooleanOperationPolyDataFilter_TclCreate(interp);
  vtkDistancePolyDataFilter_TclCreate(interp);
  vtkOverlappingAMRLevelIdScalars_TclCreate(interp);
  vtkExtractArray_TclCreate(interp);
  vtkMatricizeArray_TclCreate(interp);
  vtkNormalizeMatrixVectors_TclCreate(interp);
  vtkPassArrays_TclCreate(interp);
  vtkSplitColumnComponents_TclCreate(interp);
  vtkCellTreeLocator_TclCreate(interp);
  char pkgName[]="vtkFiltersGeneralTCL";
  char pkgVers[]=VTK_TCL_TO_STRING(VTK_MAJOR_VERSION) "." VTK_TCL_TO_STRING(VTK_MINOR_VERSION);
  Tcl_PkgProvide(interp, pkgName, pkgVers);
  return TCL_OK;
}
