// python wrapper for vtkCPExodusIIInSituReader
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkCPExodusIIInSituReader.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkCPExodusIIInSituReader(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkCPExodusIIInSituReader_ClassNew(); }

#ifndef DECLARED_PyvtkMultiBlockDataSetAlgorithm_ClassNew
extern "C" { PyObject *PyvtkMultiBlockDataSetAlgorithm_ClassNew(); }
#define DECLARED_PyvtkMultiBlockDataSetAlgorithm_ClassNew
#endif

static const char **PyvtkCPExodusIIInSituReader_Doc();


static PyObject *
PyvtkCPExodusIIInSituReader_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCPExodusIIInSituReader *op = static_cast<vtkCPExodusIIInSituReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkCPExodusIIInSituReader::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCPExodusIIInSituReader_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCPExodusIIInSituReader *op = static_cast<vtkCPExodusIIInSituReader *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkCPExodusIIInSituReader::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCPExodusIIInSituReader_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCPExodusIIInSituReader *op = static_cast<vtkCPExodusIIInSituReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkCPExodusIIInSituReader *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkCPExodusIIInSituReader::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkCPExodusIIInSituReader_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkCPExodusIIInSituReader *tempr = vtkCPExodusIIInSituReader::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCPExodusIIInSituReader_SetFileName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFileName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCPExodusIIInSituReader *op = static_cast<vtkCPExodusIIInSituReader *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetFileName(temp0);
    }
    else
    {
      op->vtkCPExodusIIInSituReader::SetFileName(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkCPExodusIIInSituReader_GetFileName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFileName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCPExodusIIInSituReader *op = static_cast<vtkCPExodusIIInSituReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetFileName() :
      op->vtkCPExodusIIInSituReader::GetFileName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCPExodusIIInSituReader_GetCurrentTimeStep(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCurrentTimeStep");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCPExodusIIInSituReader *op = static_cast<vtkCPExodusIIInSituReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetCurrentTimeStep() :
      op->vtkCPExodusIIInSituReader::GetCurrentTimeStep());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkCPExodusIIInSituReader_SetCurrentTimeStep(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCurrentTimeStep");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCPExodusIIInSituReader *op = static_cast<vtkCPExodusIIInSituReader *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetCurrentTimeStep(temp0);
    }
    else
    {
      op->vtkCPExodusIIInSituReader::SetCurrentTimeStep(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkCPExodusIIInSituReader_GetTimeStepRange(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTimeStepRange");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCPExodusIIInSituReader *op = static_cast<vtkCPExodusIIInSituReader *>(vp);

  int sizer = 2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int *tempr = (ap.IsBound() ?
      op->GetTimeStepRange() :
      op->vtkCPExodusIIInSituReader::GetTimeStepRange());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildTuple(tempr, sizer);
    }
  }

  return result;
}


static PyObject *
PyvtkCPExodusIIInSituReader_GetTimeStepValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTimeStepValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkCPExodusIIInSituReader *op = static_cast<vtkCPExodusIIInSituReader *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    double tempr = (ap.IsBound() ?
      op->GetTimeStepValue(temp0) :
      op->vtkCPExodusIIInSituReader::GetTimeStepValue(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkCPExodusIIInSituReader_Methods[] = {
  {"GetClassName", PyvtkCPExodusIIInSituReader_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkCPExodusIIInSituReader_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkCPExodusIIInSituReader_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkCPExodusIIInSituReader\nC++: vtkCPExodusIIInSituReader *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkCPExodusIIInSituReader_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkCPExodusIIInSituReader\nC++: vtkCPExodusIIInSituReader *SafeDownCast(vtkObject* o)\n\n"},
  {"SetFileName", PyvtkCPExodusIIInSituReader_SetFileName, METH_VARARGS,
   "V.SetFileName(string)\nC++: void SetFileName(char *)\n\nGet/Set the name of the Exodus file to read.\n"},
  {"GetFileName", PyvtkCPExodusIIInSituReader_GetFileName, METH_VARARGS,
   "V.GetFileName() -> string\nC++: char *GetFileName()\n\nGet/Set the name of the Exodus file to read.\n"},
  {"GetCurrentTimeStep", PyvtkCPExodusIIInSituReader_GetCurrentTimeStep, METH_VARARGS,
   "V.GetCurrentTimeStep() -> int\nC++: int GetCurrentTimeStep()\n\nGet/Set the current timestep to read as a zero-based index.\n"},
  {"SetCurrentTimeStep", PyvtkCPExodusIIInSituReader_SetCurrentTimeStep, METH_VARARGS,
   "V.SetCurrentTimeStep(int)\nC++: void SetCurrentTimeStep(int a)\n\nGet/Set the current timestep to read as a zero-based index.\n"},
  {"GetTimeStepRange", PyvtkCPExodusIIInSituReader_GetTimeStepRange, METH_VARARGS,
   "V.GetTimeStepRange() -> (int, int)\nC++: int *GetTimeStepRange()\n\n"},
  {"GetTimeStepValue", PyvtkCPExodusIIInSituReader_GetTimeStepValue, METH_VARARGS,
   "V.GetTimeStepValue(int) -> float\nC++: double GetTimeStepValue(int step)\n\nGet the floating point tag associated with the timestep at\n'step'.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkCPExodusIIInSituReader_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkIOExodusPython.vtkCPExodusIIInSituReader", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkCPExodusIIInSituReader_StaticNew()
{
  return vtkCPExodusIIInSituReader::New();
}

PyObject *PyvtkCPExodusIIInSituReader_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkCPExodusIIInSituReader_Type, PyvtkCPExodusIIInSituReader_Methods,
    "vtkCPExodusIIInSituReader",
    PyvtkCPExodusIIInSituReader_Doc(), &PyvtkCPExodusIIInSituReader_StaticNew);

  PyTypeObject *pytype = &PyvtkCPExodusIIInSituReader_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkMultiBlockDataSetAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkCPExodusIIInSituReader_Doc()
{
  static const char *docstring[] = {
    "vtkCPExodusIIInSituReader - Read an Exodus II file into data\nstructures that map the raw arrays returned by the Exodus II library\ninto a multi-block data set containing vtkUnstructuredGridBase\nsubclasses.\n\n",
    "Superclass: vtkMultiBlockDataSetAlgorithm\n\n",
    "This class can be used to import Exodus II files into VTK without\nrepacking the data into the standard VTK memory layout, avoiding the\ncost of a deep copy.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkCPExodusIIInSituReader(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkCPExodusIIInSituReader_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkCPExodusIIInSituReader", o) != 0)
  {
    Py_DECREF(o);
  }

}

