// python wrapper for vtkFixedSizeHandleRepresentation3D
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkFixedSizeHandleRepresentation3D.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkFixedSizeHandleRepresentation3D(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkFixedSizeHandleRepresentation3D_ClassNew(); }

#ifndef DECLARED_PyvtkPolygonalHandleRepresentation3D_ClassNew
extern "C" { PyObject *PyvtkPolygonalHandleRepresentation3D_ClassNew(); }
#define DECLARED_PyvtkPolygonalHandleRepresentation3D_ClassNew
#endif

static const char **PyvtkFixedSizeHandleRepresentation3D_Doc();


static PyObject *
PyvtkFixedSizeHandleRepresentation3D_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkFixedSizeHandleRepresentation3D *op = static_cast<vtkFixedSizeHandleRepresentation3D *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkFixedSizeHandleRepresentation3D::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkFixedSizeHandleRepresentation3D_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkFixedSizeHandleRepresentation3D *op = static_cast<vtkFixedSizeHandleRepresentation3D *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkFixedSizeHandleRepresentation3D::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkFixedSizeHandleRepresentation3D_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkFixedSizeHandleRepresentation3D *op = static_cast<vtkFixedSizeHandleRepresentation3D *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkFixedSizeHandleRepresentation3D *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkFixedSizeHandleRepresentation3D::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkFixedSizeHandleRepresentation3D_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkFixedSizeHandleRepresentation3D *tempr = vtkFixedSizeHandleRepresentation3D::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkFixedSizeHandleRepresentation3D_GetSphereSource(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSphereSource");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkFixedSizeHandleRepresentation3D *op = static_cast<vtkFixedSizeHandleRepresentation3D *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkSphereSource *tempr = (ap.IsBound() ?
      op->GetSphereSource() :
      op->vtkFixedSizeHandleRepresentation3D::GetSphereSource());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkFixedSizeHandleRepresentation3D_SetHandleSizeInPixels(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetHandleSizeInPixels");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkFixedSizeHandleRepresentation3D *op = static_cast<vtkFixedSizeHandleRepresentation3D *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetHandleSizeInPixels(temp0);
    }
    else
    {
      op->vtkFixedSizeHandleRepresentation3D::SetHandleSizeInPixels(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkFixedSizeHandleRepresentation3D_GetHandleSizeInPixels(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetHandleSizeInPixels");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkFixedSizeHandleRepresentation3D *op = static_cast<vtkFixedSizeHandleRepresentation3D *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetHandleSizeInPixels() :
      op->vtkFixedSizeHandleRepresentation3D::GetHandleSizeInPixels());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkFixedSizeHandleRepresentation3D_SetHandleSizeToleranceInPixels(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetHandleSizeToleranceInPixels");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkFixedSizeHandleRepresentation3D *op = static_cast<vtkFixedSizeHandleRepresentation3D *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetHandleSizeToleranceInPixels(temp0);
    }
    else
    {
      op->vtkFixedSizeHandleRepresentation3D::SetHandleSizeToleranceInPixels(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkFixedSizeHandleRepresentation3D_GetHandleSizeToleranceInPixels(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetHandleSizeToleranceInPixels");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkFixedSizeHandleRepresentation3D *op = static_cast<vtkFixedSizeHandleRepresentation3D *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetHandleSizeToleranceInPixels() :
      op->vtkFixedSizeHandleRepresentation3D::GetHandleSizeToleranceInPixels());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkFixedSizeHandleRepresentation3D_Methods[] = {
  {"GetClassName", PyvtkFixedSizeHandleRepresentation3D_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\nStandard vtk methods\n"},
  {"IsA", PyvtkFixedSizeHandleRepresentation3D_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\nStandard vtk methods\n"},
  {"NewInstance", PyvtkFixedSizeHandleRepresentation3D_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkFixedSizeHandleRepresentation3D\nC++: vtkFixedSizeHandleRepresentation3D *NewInstance()\n\nStandard vtk methods\n"},
  {"SafeDownCast", PyvtkFixedSizeHandleRepresentation3D_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkFixedSizeHandleRepresentation3D\nC++: vtkFixedSizeHandleRepresentation3D *SafeDownCast(\n    vtkObject* o)\n\nStandard vtk methods\n"},
  {"GetSphereSource", PyvtkFixedSizeHandleRepresentation3D_GetSphereSource, METH_VARARGS,
   "V.GetSphereSource() -> vtkSphereSource\nC++: vtkSphereSource *GetSphereSource()\n\nGet the object used to render the spherical handle marker\n"},
  {"SetHandleSizeInPixels", PyvtkFixedSizeHandleRepresentation3D_SetHandleSizeInPixels, METH_VARARGS,
   "V.SetHandleSizeInPixels(float)\nC++: void SetHandleSizeInPixels(double a)\n\nSet/Get the required handle size in pixels. Defaults to a width\nof 10 pixels.\n"},
  {"GetHandleSizeInPixels", PyvtkFixedSizeHandleRepresentation3D_GetHandleSizeInPixels, METH_VARARGS,
   "V.GetHandleSizeInPixels() -> float\nC++: double GetHandleSizeInPixels()\n\nSet/Get the required handle size in pixels. Defaults to a width\nof 10 pixels.\n"},
  {"SetHandleSizeToleranceInPixels", PyvtkFixedSizeHandleRepresentation3D_SetHandleSizeToleranceInPixels, METH_VARARGS,
   "V.SetHandleSizeToleranceInPixels(float)\nC++: void SetHandleSizeToleranceInPixels(double a)\n\nSpecify the acceptable handle size tolerance. During each render,\nthe handle 3D source will be updated to automatically match a\ndisplay size as specified by HandleSizeInPixels. This update will\nbe done if the handle size is larger than a tolerance. Default\nvalue of this tolerance is half a pixel.\n"},
  {"GetHandleSizeToleranceInPixels", PyvtkFixedSizeHandleRepresentation3D_GetHandleSizeToleranceInPixels, METH_VARARGS,
   "V.GetHandleSizeToleranceInPixels() -> float\nC++: double GetHandleSizeToleranceInPixels()\n\nSpecify the acceptable handle size tolerance. During each render,\nthe handle 3D source will be updated to automatically match a\ndisplay size as specified by HandleSizeInPixels. This update will\nbe done if the handle size is larger than a tolerance. Default\nvalue of this tolerance is half a pixel.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkFixedSizeHandleRepresentation3D_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkInteractionWidgetsPython.vtkFixedSizeHandleRepresentation3D", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkFixedSizeHandleRepresentation3D_StaticNew()
{
  return vtkFixedSizeHandleRepresentation3D::New();
}

PyObject *PyvtkFixedSizeHandleRepresentation3D_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkFixedSizeHandleRepresentation3D_Type, PyvtkFixedSizeHandleRepresentation3D_Methods,
    "vtkFixedSizeHandleRepresentation3D",
    PyvtkFixedSizeHandleRepresentation3D_Doc(), &PyvtkFixedSizeHandleRepresentation3D_StaticNew);

  PyTypeObject *pytype = &PyvtkFixedSizeHandleRepresentation3D_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkPolygonalHandleRepresentation3D_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkFixedSizeHandleRepresentation3D_Doc()
{
  static const char *docstring[] = {
    "vtkFixedSizeHandleRepresentation3D - no description provided.\n\n",
    "Superclass: vtkPolygonalHandleRepresentation3D\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkFixedSizeHandleRepresentation3D(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkFixedSizeHandleRepresentation3D_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkFixedSizeHandleRepresentation3D", o) != 0)
  {
    Py_DECREF(o);
  }

}

