// python wrapper for vtkMPIMultiBlockPLOT3DReader
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkMPIMultiBlockPLOT3DReader.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkMPIMultiBlockPLOT3DReader(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkMPIMultiBlockPLOT3DReader_ClassNew(); }

#ifndef DECLARED_PyvtkMultiBlockPLOT3DReader_ClassNew
extern "C" { PyObject *PyvtkMultiBlockPLOT3DReader_ClassNew(); }
#define DECLARED_PyvtkMultiBlockPLOT3DReader_ClassNew
#endif

static const char **PyvtkMPIMultiBlockPLOT3DReader_Doc();


static PyObject *
PyvtkMPIMultiBlockPLOT3DReader_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMPIMultiBlockPLOT3DReader *op = static_cast<vtkMPIMultiBlockPLOT3DReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkMPIMultiBlockPLOT3DReader::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMPIMultiBlockPLOT3DReader_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMPIMultiBlockPLOT3DReader *op = static_cast<vtkMPIMultiBlockPLOT3DReader *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkMPIMultiBlockPLOT3DReader::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMPIMultiBlockPLOT3DReader_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMPIMultiBlockPLOT3DReader *op = static_cast<vtkMPIMultiBlockPLOT3DReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkMPIMultiBlockPLOT3DReader *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkMPIMultiBlockPLOT3DReader::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkMPIMultiBlockPLOT3DReader_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkMPIMultiBlockPLOT3DReader *tempr = vtkMPIMultiBlockPLOT3DReader::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMPIMultiBlockPLOT3DReader_SetUseMPIIO(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUseMPIIO");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMPIMultiBlockPLOT3DReader *op = static_cast<vtkMPIMultiBlockPLOT3DReader *>(vp);

  bool temp0 = false;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetUseMPIIO(temp0);
    }
    else
    {
      op->vtkMPIMultiBlockPLOT3DReader::SetUseMPIIO(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMPIMultiBlockPLOT3DReader_GetUseMPIIO(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetUseMPIIO");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMPIMultiBlockPLOT3DReader *op = static_cast<vtkMPIMultiBlockPLOT3DReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetUseMPIIO() :
      op->vtkMPIMultiBlockPLOT3DReader::GetUseMPIIO());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkMPIMultiBlockPLOT3DReader_UseMPIIOOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UseMPIIOOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMPIMultiBlockPLOT3DReader *op = static_cast<vtkMPIMultiBlockPLOT3DReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->UseMPIIOOn();
    }
    else
    {
      op->vtkMPIMultiBlockPLOT3DReader::UseMPIIOOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkMPIMultiBlockPLOT3DReader_UseMPIIOOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UseMPIIOOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkMPIMultiBlockPLOT3DReader *op = static_cast<vtkMPIMultiBlockPLOT3DReader *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->UseMPIIOOff();
    }
    else
    {
      op->vtkMPIMultiBlockPLOT3DReader::UseMPIIOOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkMPIMultiBlockPLOT3DReader_Methods[] = {
  {"GetClassName", PyvtkMPIMultiBlockPLOT3DReader_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkMPIMultiBlockPLOT3DReader_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkMPIMultiBlockPLOT3DReader_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkMPIMultiBlockPLOT3DReader\nC++: vtkMPIMultiBlockPLOT3DReader *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkMPIMultiBlockPLOT3DReader_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkMPIMultiBlockPLOT3DReader\nC++: vtkMPIMultiBlockPLOT3DReader *SafeDownCast(vtkObject* o)\n\n"},
  {"SetUseMPIIO", PyvtkMPIMultiBlockPLOT3DReader_SetUseMPIIO, METH_VARARGS,
   "V.SetUseMPIIO(bool)\nC++: void SetUseMPIIO(bool a)\n\nUse this to override using MPI-IO. When set to false (default is\ntrue), this class will simply forward all method calls to the\nsuperclass.\n"},
  {"GetUseMPIIO", PyvtkMPIMultiBlockPLOT3DReader_GetUseMPIIO, METH_VARARGS,
   "V.GetUseMPIIO() -> bool\nC++: bool GetUseMPIIO()\n\nUse this to override using MPI-IO. When set to false (default is\ntrue), this class will simply forward all method calls to the\nsuperclass.\n"},
  {"UseMPIIOOn", PyvtkMPIMultiBlockPLOT3DReader_UseMPIIOOn, METH_VARARGS,
   "V.UseMPIIOOn()\nC++: void UseMPIIOOn()\n\nUse this to override using MPI-IO. When set to false (default is\ntrue), this class will simply forward all method calls to the\nsuperclass.\n"},
  {"UseMPIIOOff", PyvtkMPIMultiBlockPLOT3DReader_UseMPIIOOff, METH_VARARGS,
   "V.UseMPIIOOff()\nC++: void UseMPIIOOff()\n\nUse this to override using MPI-IO. When set to false (default is\ntrue), this class will simply forward all method calls to the\nsuperclass.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkMPIMultiBlockPLOT3DReader_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkIOMPIParallelPython.vtkMPIMultiBlockPLOT3DReader", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkMPIMultiBlockPLOT3DReader_StaticNew()
{
  return vtkMPIMultiBlockPLOT3DReader::New();
}

PyObject *PyvtkMPIMultiBlockPLOT3DReader_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkMPIMultiBlockPLOT3DReader_Type, PyvtkMPIMultiBlockPLOT3DReader_Methods,
    "vtkMPIMultiBlockPLOT3DReader",
    PyvtkMPIMultiBlockPLOT3DReader_Doc(), &PyvtkMPIMultiBlockPLOT3DReader_StaticNew);

  PyTypeObject *pytype = &PyvtkMPIMultiBlockPLOT3DReader_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkMultiBlockPLOT3DReader_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkMPIMultiBlockPLOT3DReader_Doc()
{
  static const char *docstring[] = {
    "vtkMPIMultiBlockPLOT3DReader - vtkMultiBlockPLOT3DReader subclass\nthat uses MPI-IO to efficiently read binary files for 3D domains in\nparallel using\n\n",
    "Superclass: vtkMultiBlockPLOT3DReader\n\n",
    "MPI-IO.\n\nvtkMPIMultiBlockPLOT3DReader extends vtkMultiBlockPLOT3DReader to use\nMPI-IO instead of POSIX IO to read file in parallel.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkMPIMultiBlockPLOT3DReader(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkMPIMultiBlockPLOT3DReader_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkMPIMultiBlockPLOT3DReader", o) != 0)
  {
    Py_DECREF(o);
  }

}

