// python wrapper for vtkPUnstructuredGridConnectivity
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkPUnstructuredGridConnectivity.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkPUnstructuredGridConnectivity(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkPUnstructuredGridConnectivity_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char **PyvtkPUnstructuredGridConnectivity_Doc();


static PyObject *
PyvtkPUnstructuredGridConnectivity_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPUnstructuredGridConnectivity *op = static_cast<vtkPUnstructuredGridConnectivity *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkPUnstructuredGridConnectivity::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPUnstructuredGridConnectivity_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPUnstructuredGridConnectivity *op = static_cast<vtkPUnstructuredGridConnectivity *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkPUnstructuredGridConnectivity::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPUnstructuredGridConnectivity_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPUnstructuredGridConnectivity *op = static_cast<vtkPUnstructuredGridConnectivity *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkPUnstructuredGridConnectivity *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkPUnstructuredGridConnectivity::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkPUnstructuredGridConnectivity_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkPUnstructuredGridConnectivity *tempr = vtkPUnstructuredGridConnectivity::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPUnstructuredGridConnectivity_SetController(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetController");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPUnstructuredGridConnectivity *op = static_cast<vtkPUnstructuredGridConnectivity *>(vp);

  vtkMPIController *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMPIController"))
  {
    if (ap.IsBound())
    {
      op->SetController(temp0);
    }
    else
    {
      op->vtkPUnstructuredGridConnectivity::SetController(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPUnstructuredGridConnectivity_GetController(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetController");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPUnstructuredGridConnectivity *op = static_cast<vtkPUnstructuredGridConnectivity *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkMPIController *tempr = (ap.IsBound() ?
      op->GetController() :
      op->vtkPUnstructuredGridConnectivity::GetController());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPUnstructuredGridConnectivity_SetGlobalIDFieldName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetGlobalIDFieldName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPUnstructuredGridConnectivity *op = static_cast<vtkPUnstructuredGridConnectivity *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetGlobalIDFieldName(temp0);
    }
    else
    {
      op->vtkPUnstructuredGridConnectivity::SetGlobalIDFieldName(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPUnstructuredGridConnectivity_GetGlobalIDFieldName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetGlobalIDFieldName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPUnstructuredGridConnectivity *op = static_cast<vtkPUnstructuredGridConnectivity *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetGlobalIDFieldName() :
      op->vtkPUnstructuredGridConnectivity::GetGlobalIDFieldName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPUnstructuredGridConnectivity_GetGhostedGrid(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetGhostedGrid");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPUnstructuredGridConnectivity *op = static_cast<vtkPUnstructuredGridConnectivity *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkUnstructuredGrid *tempr = (ap.IsBound() ?
      op->GetGhostedGrid() :
      op->vtkPUnstructuredGridConnectivity::GetGhostedGrid());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkPUnstructuredGridConnectivity_RegisterGrid(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "RegisterGrid");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPUnstructuredGridConnectivity *op = static_cast<vtkPUnstructuredGridConnectivity *>(vp);

  vtkUnstructuredGrid *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkUnstructuredGrid"))
  {
    if (ap.IsBound())
    {
      op->RegisterGrid(temp0);
    }
    else
    {
      op->vtkPUnstructuredGridConnectivity::RegisterGrid(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPUnstructuredGridConnectivity_BuildGhostZoneConnectivity(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "BuildGhostZoneConnectivity");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPUnstructuredGridConnectivity *op = static_cast<vtkPUnstructuredGridConnectivity *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->BuildGhostZoneConnectivity();
    }
    else
    {
      op->vtkPUnstructuredGridConnectivity::BuildGhostZoneConnectivity();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkPUnstructuredGridConnectivity_UpdateGhosts(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UpdateGhosts");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkPUnstructuredGridConnectivity *op = static_cast<vtkPUnstructuredGridConnectivity *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->UpdateGhosts();
    }
    else
    {
      op->vtkPUnstructuredGridConnectivity::UpdateGhosts();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkPUnstructuredGridConnectivity_Methods[] = {
  {"GetClassName", PyvtkPUnstructuredGridConnectivity_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkPUnstructuredGridConnectivity_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkPUnstructuredGridConnectivity_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkPUnstructuredGridConnectivity\nC++: vtkPUnstructuredGridConnectivity *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkPUnstructuredGridConnectivity_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkPUnstructuredGridConnectivity\nC++: vtkPUnstructuredGridConnectivity *SafeDownCast(vtkObject* o)\n\n"},
  {"SetController", PyvtkPUnstructuredGridConnectivity_SetController, METH_VARARGS,
   "V.SetController(vtkMPIController)\nC++: void SetController(vtkMPIController *a)\n\nSet/Get the underlying MPI controller used for communication.\n"},
  {"GetController", PyvtkPUnstructuredGridConnectivity_GetController, METH_VARARGS,
   "V.GetController() -> vtkMPIController\nC++: vtkMPIController *GetController()\n\nSet/Get the underlying MPI controller used for communication.\n"},
  {"SetGlobalIDFieldName", PyvtkPUnstructuredGridConnectivity_SetGlobalIDFieldName, METH_VARARGS,
   "V.SetGlobalIDFieldName(string)\nC++: void SetGlobalIDFieldName(char *)\n\nSet/Get the name of the GlobalID field. By default, \"GlobalID\" is\nassumed.\n"},
  {"GetGlobalIDFieldName", PyvtkPUnstructuredGridConnectivity_GetGlobalIDFieldName, METH_VARARGS,
   "V.GetGlobalIDFieldName() -> string\nC++: char *GetGlobalIDFieldName()\n\nSet/Get the name of the GlobalID field. By default, \"GlobalID\" is\nassumed.\n"},
  {"GetGhostedGrid", PyvtkPUnstructuredGridConnectivity_GetGhostedGrid, METH_VARARGS,
   "V.GetGhostedGrid() -> vtkUnstructuredGrid\nC++: vtkUnstructuredGrid *GetGhostedGrid()\n\nReturns the ghosted grid.\n"},
  {"RegisterGrid", PyvtkPUnstructuredGridConnectivity_RegisterGrid, METH_VARARGS,
   "V.RegisterGrid(vtkUnstructuredGrid)\nC++: void RegisterGrid(vtkUnstructuredGrid *gridPtr)\n\nRegisters the grid in this process\n"},
  {"BuildGhostZoneConnectivity", PyvtkPUnstructuredGridConnectivity_BuildGhostZoneConnectivity, METH_VARARGS,
   "V.BuildGhostZoneConnectivity()\nC++: void BuildGhostZoneConnectivity()\n\nBuilds the ghost-zone connectivity. This method sets up the\nnecessary communication lists for updating the ghost zones. NOTE:\nthe local grid, must be registered, by calling RegisterGrid(),\nprior to calling this method.\n"},
  {"UpdateGhosts", PyvtkPUnstructuredGridConnectivity_UpdateGhosts, METH_VARARGS,
   "V.UpdateGhosts()\nC++: void UpdateGhosts()\n\nExchanges ghost zone data (i.e., node-centered or cell-centered\nfields). NOTE: This method must be called after\nBuildGhostZoneConnectivity.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkPUnstructuredGridConnectivity_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersParallelGeometryPython.vtkPUnstructuredGridConnectivity", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkPUnstructuredGridConnectivity_StaticNew()
{
  return vtkPUnstructuredGridConnectivity::New();
}

PyObject *PyvtkPUnstructuredGridConnectivity_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkPUnstructuredGridConnectivity_Type, PyvtkPUnstructuredGridConnectivity_Methods,
    "vtkPUnstructuredGridConnectivity",
    PyvtkPUnstructuredGridConnectivity_Doc(), &PyvtkPUnstructuredGridConnectivity_StaticNew);

  PyTypeObject *pytype = &PyvtkPUnstructuredGridConnectivity_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkPUnstructuredGridConnectivity_Doc()
{
  static const char *docstring[] = {
    "vtkPUnstructuredGridConnectivity -  vtkPUnstructuredGridConnectivity\nimplements functionality for generating\n ghost zones for a distributed unstructured grid.\n\n",
    "Superclass: vtkObject\n\n",
    "Generating ghost zones is\n implemented in two stages. First, we build the ghost zones, which\namounts\n to building the connectivity of the ghosted grid and communication\nlinks,\n and second, we update the ghost zones by communicating the fields on\nthe\n ghost cells and nodes. The main steps involved in this process are\nas\n follows:\n \n   Each process computes a bounding box of the grid it owns. \n   Th",
    "e bounding boxes are then distributed to all processes by\n        an AllGather collective call. \n   Each process loops through the list of bounding boxes and\n        computes box intersections with its local bounding box. \n   The list of intersecting bounding boxes, yields an abbreviated\nlist\n        of candidate neighbors. \n   Given the local grid, each process then extracts the boundary\ngrid,\n  ",
    "      which consists of nodes/cells on the boundary, global node\nIDs and\n        the local cell IDs w.r.t. the local grid. \n   Boundary grids are then exchanged among candidate neighbors using\n        point-to-point communication. \n   Next, each process constructs the topology of the ghost zones and\n        communication links, using the local boundary grid and the\nlist of\n        remote boundary ",
    "grids. \n   The communication links store a source/target pair for nodes/cells\n        among connected grids and remain persistent in memory. \n   Last, the fields (node- and/or cell-centered) are updated, using\n        point-to-point communication by processing the communication\n        links. \n @deprecated Not maintained as of VTK 7.0 and will be removed\neventually. Use vtkPUnstructuredGridGhostCe",
    "llsGenerator instead.\n\n@warning\n \n   The code currently assumes one grid per rank. \n   GlobalID information must be available. \n   The grid must be globally conforming, i.e., no hanging nodes. \n   Only topologically face-adjacent ghost cells are considered. \n   PointData and CellData must match across partitions/processes. \n \n\n@sa\n vtkPUnstructuredGridGhostDataGenerator\nvtkPUnstructuredGridGhostCe",
    "llsGenerator\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkPUnstructuredGridConnectivity(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkPUnstructuredGridConnectivity_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkPUnstructuredGridConnectivity", o) != 0)
  {
    Py_DECREF(o);
  }

}

