// python wrapper for vtkTanglegramItem
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkContextMouseEvent.h"
#include "vtkTanglegramItem.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkTanglegramItem(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkTanglegramItem_ClassNew(); }

#ifndef DECLARED_PyvtkContextItem_ClassNew
extern "C" { PyObject *PyvtkContextItem_ClassNew(); }
#define DECLARED_PyvtkContextItem_ClassNew
#endif

static const char **PyvtkTanglegramItem_Doc();


static PyObject *
PyvtkTanglegramItem_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTanglegramItem *op = static_cast<vtkTanglegramItem *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkTanglegramItem::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTanglegramItem_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTanglegramItem *op = static_cast<vtkTanglegramItem *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkTanglegramItem::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTanglegramItem_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTanglegramItem *op = static_cast<vtkTanglegramItem *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkTanglegramItem *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkTanglegramItem::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkTanglegramItem_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkTanglegramItem *tempr = vtkTanglegramItem::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTanglegramItem_SetTree1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTree1");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTanglegramItem *op = static_cast<vtkTanglegramItem *>(vp);

  vtkTree *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkTree"))
  {
    if (ap.IsBound())
    {
      op->SetTree1(temp0);
    }
    else
    {
      op->vtkTanglegramItem::SetTree1(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkTanglegramItem_SetTree2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTree2");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTanglegramItem *op = static_cast<vtkTanglegramItem *>(vp);

  vtkTree *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkTree"))
  {
    if (ap.IsBound())
    {
      op->SetTree2(temp0);
    }
    else
    {
      op->vtkTanglegramItem::SetTree2(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkTanglegramItem_GetTable(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTable");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTanglegramItem *op = static_cast<vtkTanglegramItem *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkTable *tempr = (ap.IsBound() ?
      op->GetTable() :
      op->vtkTanglegramItem::GetTable());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTanglegramItem_SetTable(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTable");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTanglegramItem *op = static_cast<vtkTanglegramItem *>(vp);

  vtkTable *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkTable"))
  {
    if (ap.IsBound())
    {
      op->SetTable(temp0);
    }
    else
    {
      op->vtkTanglegramItem::SetTable(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkTanglegramItem_GetTree1Label(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTree1Label");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTanglegramItem *op = static_cast<vtkTanglegramItem *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetTree1Label() :
      op->vtkTanglegramItem::GetTree1Label());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTanglegramItem_SetTree1Label(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTree1Label");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTanglegramItem *op = static_cast<vtkTanglegramItem *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetTree1Label(temp0);
    }
    else
    {
      op->vtkTanglegramItem::SetTree1Label(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkTanglegramItem_GetTree2Label(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTree2Label");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTanglegramItem *op = static_cast<vtkTanglegramItem *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetTree2Label() :
      op->vtkTanglegramItem::GetTree2Label());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTanglegramItem_SetTree2Label(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTree2Label");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTanglegramItem *op = static_cast<vtkTanglegramItem *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetTree2Label(temp0);
    }
    else
    {
      op->vtkTanglegramItem::SetTree2Label(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkTanglegramItem_SetOrientation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetOrientation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTanglegramItem *op = static_cast<vtkTanglegramItem *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetOrientation(temp0);
    }
    else
    {
      op->vtkTanglegramItem::SetOrientation(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkTanglegramItem_GetOrientation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOrientation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTanglegramItem *op = static_cast<vtkTanglegramItem *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetOrientation() :
      op->vtkTanglegramItem::GetOrientation());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTanglegramItem_GetMinimumVisibleFontSize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMinimumVisibleFontSize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTanglegramItem *op = static_cast<vtkTanglegramItem *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetMinimumVisibleFontSize() :
      op->vtkTanglegramItem::GetMinimumVisibleFontSize());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTanglegramItem_SetMinimumVisibleFontSize(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMinimumVisibleFontSize");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTanglegramItem *op = static_cast<vtkTanglegramItem *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetMinimumVisibleFontSize(temp0);
    }
    else
    {
      op->vtkTanglegramItem::SetMinimumVisibleFontSize(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkTanglegramItem_GetLabelSizeDifference(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLabelSizeDifference");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTanglegramItem *op = static_cast<vtkTanglegramItem *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetLabelSizeDifference() :
      op->vtkTanglegramItem::GetLabelSizeDifference());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTanglegramItem_SetLabelSizeDifference(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLabelSizeDifference");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTanglegramItem *op = static_cast<vtkTanglegramItem *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetLabelSizeDifference(temp0);
    }
    else
    {
      op->vtkTanglegramItem::SetLabelSizeDifference(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkTanglegramItem_GetCorrespondenceLineWidth(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetCorrespondenceLineWidth");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTanglegramItem *op = static_cast<vtkTanglegramItem *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    float tempr = (ap.IsBound() ?
      op->GetCorrespondenceLineWidth() :
      op->vtkTanglegramItem::GetCorrespondenceLineWidth());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTanglegramItem_SetCorrespondenceLineWidth(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetCorrespondenceLineWidth");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTanglegramItem *op = static_cast<vtkTanglegramItem *>(vp);

  float temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetCorrespondenceLineWidth(temp0);
    }
    else
    {
      op->vtkTanglegramItem::SetCorrespondenceLineWidth(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkTanglegramItem_GetTreeLineWidth(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetTreeLineWidth");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTanglegramItem *op = static_cast<vtkTanglegramItem *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    float tempr = (ap.IsBound() ?
      op->GetTreeLineWidth() :
      op->vtkTanglegramItem::GetTreeLineWidth());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkTanglegramItem_SetTreeLineWidth(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetTreeLineWidth");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTanglegramItem *op = static_cast<vtkTanglegramItem *>(vp);

  float temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetTreeLineWidth(temp0);
    }
    else
    {
      op->vtkTanglegramItem::SetTreeLineWidth(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkTanglegramItem_Hit(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Hit");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTanglegramItem *op = static_cast<vtkTanglegramItem *>(vp);

  vtkContextMouseEvent *temp0 = NULL;
  PyObject *pobj0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkContextMouseEvent"))
  {
    bool tempr = (ap.IsBound() ?
      op->Hit(*temp0) :
      op->vtkTanglegramItem::Hit(*temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  Py_XDECREF(pobj0);

  return result;
}


static PyObject *
PyvtkTanglegramItem_MouseDoubleClickEvent(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "MouseDoubleClickEvent");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkTanglegramItem *op = static_cast<vtkTanglegramItem *>(vp);

  vtkContextMouseEvent *temp0 = NULL;
  PyObject *pobj0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkContextMouseEvent"))
  {
    bool tempr = (ap.IsBound() ?
      op->MouseDoubleClickEvent(*temp0) :
      op->vtkTanglegramItem::MouseDoubleClickEvent(*temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyMethodDef PyvtkTanglegramItem_Methods[] = {
  {"GetClassName", PyvtkTanglegramItem_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkTanglegramItem_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkTanglegramItem_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkTanglegramItem\nC++: vtkTanglegramItem *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkTanglegramItem_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkTanglegramItem\nC++: vtkTanglegramItem *SafeDownCast(vtkObject* o)\n\n"},
  {"SetTree1", PyvtkTanglegramItem_SetTree1, METH_VARARGS,
   "V.SetTree1(vtkTree)\nC++: virtual void SetTree1(vtkTree *tree)\n\nSet the first tree\n"},
  {"SetTree2", PyvtkTanglegramItem_SetTree2, METH_VARARGS,
   "V.SetTree2(vtkTree)\nC++: virtual void SetTree2(vtkTree *tree)\n\nSet the second tree\n"},
  {"GetTable", PyvtkTanglegramItem_GetTable, METH_VARARGS,
   "V.GetTable() -> vtkTable\nC++: vtkTable *GetTable()\n\nGet/Set the table that describes the correspondences between the\ntwo trees.  The first column should contain the names of the leaf\nnodes from tree #1.  The columns of this table should be named\nafter the leaf nodes of tree #2.  A non-zero cell should be used\nto create a connection between the two trees.  Different numbers\nin the table will result in connections being drawn in different\ncolors.\n"},
  {"SetTable", PyvtkTanglegramItem_SetTable, METH_VARARGS,
   "V.SetTable(vtkTable)\nC++: void SetTable(vtkTable *table)\n\nGet/Set the table that describes the correspondences between the\ntwo trees.  The first column should contain the names of the leaf\nnodes from tree #1.  The columns of this table should be named\nafter the leaf nodes of tree #2.  A non-zero cell should be used\nto create a connection between the two trees.  Different numbers\nin the table will result in connections being drawn in different\ncolors.\n"},
  {"GetTree1Label", PyvtkTanglegramItem_GetTree1Label, METH_VARARGS,
   "V.GetTree1Label() -> string\nC++: char *GetTree1Label()\n\nGet/Set the label for tree #1.\n"},
  {"SetTree1Label", PyvtkTanglegramItem_SetTree1Label, METH_VARARGS,
   "V.SetTree1Label(string)\nC++: void SetTree1Label(char *)\n\nGet/Set the label for tree #1.\n"},
  {"GetTree2Label", PyvtkTanglegramItem_GetTree2Label, METH_VARARGS,
   "V.GetTree2Label() -> string\nC++: char *GetTree2Label()\n\nGet/Set the label for tree #2.\n"},
  {"SetTree2Label", PyvtkTanglegramItem_SetTree2Label, METH_VARARGS,
   "V.SetTree2Label(string)\nC++: void SetTree2Label(char *)\n\nGet/Set the label for tree #2.\n"},
  {"SetOrientation", PyvtkTanglegramItem_SetOrientation, METH_VARARGS,
   "V.SetOrientation(int)\nC++: void SetOrientation(int orientation)\n\nSet which way the tanglegram should face within the\nvisualization. The default is for tree #1 to be drawn left to\nright.\n"},
  {"GetOrientation", PyvtkTanglegramItem_GetOrientation, METH_VARARGS,
   "V.GetOrientation() -> int\nC++: int GetOrientation()\n\nGet the current orientation.\n"},
  {"GetMinimumVisibleFontSize", PyvtkTanglegramItem_GetMinimumVisibleFontSize, METH_VARARGS,
   "V.GetMinimumVisibleFontSize() -> int\nC++: int GetMinimumVisibleFontSize()\n\nGet/Set the smallest font size that is still considered legible.\nIf the current zoom level requires our vertex labels to be\nsmaller than this size the labels will not be drawn at all. \nDefault value is 8 pt.\n"},
  {"SetMinimumVisibleFontSize", PyvtkTanglegramItem_SetMinimumVisibleFontSize, METH_VARARGS,
   "V.SetMinimumVisibleFontSize(int)\nC++: void SetMinimumVisibleFontSize(int a)\n\nGet/Set the smallest font size that is still considered legible.\nIf the current zoom level requires our vertex labels to be\nsmaller than this size the labels will not be drawn at all. \nDefault value is 8 pt.\n"},
  {"GetLabelSizeDifference", PyvtkTanglegramItem_GetLabelSizeDifference, METH_VARARGS,
   "V.GetLabelSizeDifference() -> int\nC++: int GetLabelSizeDifference()\n\nGet/Set how much larger the dendrogram labels should be compared\nto the vertex labels.  Because the vertex labels automatically\nresize based on zoom levels, this is a relative (not absolute)\nsize.  Default value is 4 pts larger than the vertex labels.\n"},
  {"SetLabelSizeDifference", PyvtkTanglegramItem_SetLabelSizeDifference, METH_VARARGS,
   "V.SetLabelSizeDifference(int)\nC++: void SetLabelSizeDifference(int a)\n\nGet/Set how much larger the dendrogram labels should be compared\nto the vertex labels.  Because the vertex labels automatically\nresize based on zoom levels, this is a relative (not absolute)\nsize.  Default value is 4 pts larger than the vertex labels.\n"},
  {"GetCorrespondenceLineWidth", PyvtkTanglegramItem_GetCorrespondenceLineWidth, METH_VARARGS,
   "V.GetCorrespondenceLineWidth() -> float\nC++: float GetCorrespondenceLineWidth()\n\nGet/Set how wide the correspondence lines should be.  Default is\ntwo pixels.\n"},
  {"SetCorrespondenceLineWidth", PyvtkTanglegramItem_SetCorrespondenceLineWidth, METH_VARARGS,
   "V.SetCorrespondenceLineWidth(float)\nC++: void SetCorrespondenceLineWidth(float a)\n\nGet/Set how wide the correspondence lines should be.  Default is\ntwo pixels.\n"},
  {"GetTreeLineWidth", PyvtkTanglegramItem_GetTreeLineWidth, METH_VARARGS,
   "V.GetTreeLineWidth() -> float\nC++: float GetTreeLineWidth()\n\nGet/Set how wide the edges of the trees should be.  Default is\none pixel.\n"},
  {"SetTreeLineWidth", PyvtkTanglegramItem_SetTreeLineWidth, METH_VARARGS,
   "V.SetTreeLineWidth(float)\nC++: void SetTreeLineWidth(float width)\n\nGet/Set how wide the edges of the trees should be.  Default is\none pixel.\n"},
  {"Hit", PyvtkTanglegramItem_Hit, METH_VARARGS,
   "V.Hit(vtkContextMouseEvent) -> bool\nC++: virtual bool Hit(const vtkContextMouseEvent &mouse)\n\nReturns true if the transform is interactive, false otherwise.\n"},
  {"MouseDoubleClickEvent", PyvtkTanglegramItem_MouseDoubleClickEvent, METH_VARARGS,
   "V.MouseDoubleClickEvent(vtkContextMouseEvent) -> bool\nC++: virtual bool MouseDoubleClickEvent(\n    const vtkContextMouseEvent &event)\n\nPropagate any double click onto the dendrograms to check if any\nsubtrees should be collapsed or expanded.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkTanglegramItem_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkViewsInfovisPython.vtkTanglegramItem", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkTanglegramItem_StaticNew()
{
  return vtkTanglegramItem::New();
}

PyObject *PyvtkTanglegramItem_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkTanglegramItem_Type, PyvtkTanglegramItem_Methods,
    "vtkTanglegramItem",
    PyvtkTanglegramItem_Doc(), &PyvtkTanglegramItem_StaticNew);

  PyTypeObject *pytype = &PyvtkTanglegramItem_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkContextItem_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkTanglegramItem_Doc()
{
  static const char *docstring[] = {
    "vtkTanglegramItem - Display two related trees\n\n",
    "Superclass: vtkContextItem\n\n",
    "This item draws two trees with connections between their leaf nodes.\nUse SetTable() to specify what leaf nodes correspond to one another\nbetween the two trees.  See the documentation for this function for\nmore details on how this table should be formatted.\n\n.SEE ALSO vtkTree vtkTable vtkDendrogramItem vtkNewickTreeReader\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkTanglegramItem(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkTanglegramItem_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkTanglegramItem", o) != 0)
  {
    Py_DECREF(o);
  }

}

