// python wrapper for vtkVolumeOfRevolutionFilter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkVolumeOfRevolutionFilter.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkVolumeOfRevolutionFilter(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkVolumeOfRevolutionFilter_ClassNew(); }

#ifndef DECLARED_PyvtkUnstructuredGridAlgorithm_ClassNew
extern "C" { PyObject *PyvtkUnstructuredGridAlgorithm_ClassNew(); }
#define DECLARED_PyvtkUnstructuredGridAlgorithm_ClassNew
#endif

static const char **PyvtkVolumeOfRevolutionFilter_Doc();


static PyObject *
PyvtkVolumeOfRevolutionFilter_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeOfRevolutionFilter *op = static_cast<vtkVolumeOfRevolutionFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkVolumeOfRevolutionFilter::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeOfRevolutionFilter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeOfRevolutionFilter *op = static_cast<vtkVolumeOfRevolutionFilter *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkVolumeOfRevolutionFilter::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeOfRevolutionFilter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeOfRevolutionFilter *op = static_cast<vtkVolumeOfRevolutionFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkVolumeOfRevolutionFilter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkVolumeOfRevolutionFilter::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeOfRevolutionFilter_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkVolumeOfRevolutionFilter *tempr = vtkVolumeOfRevolutionFilter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeOfRevolutionFilter_SetResolution(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetResolution");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeOfRevolutionFilter *op = static_cast<vtkVolumeOfRevolutionFilter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetResolution(temp0);
    }
    else
    {
      op->vtkVolumeOfRevolutionFilter::SetResolution(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeOfRevolutionFilter_GetResolutionMinValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetResolutionMinValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeOfRevolutionFilter *op = static_cast<vtkVolumeOfRevolutionFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetResolutionMinValue() :
      op->vtkVolumeOfRevolutionFilter::GetResolutionMinValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeOfRevolutionFilter_GetResolutionMaxValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetResolutionMaxValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeOfRevolutionFilter *op = static_cast<vtkVolumeOfRevolutionFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetResolutionMaxValue() :
      op->vtkVolumeOfRevolutionFilter::GetResolutionMaxValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeOfRevolutionFilter_GetResolution(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetResolution");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeOfRevolutionFilter *op = static_cast<vtkVolumeOfRevolutionFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetResolution() :
      op->vtkVolumeOfRevolutionFilter::GetResolution());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeOfRevolutionFilter_SetSweepAngle(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetSweepAngle");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeOfRevolutionFilter *op = static_cast<vtkVolumeOfRevolutionFilter *>(vp);

  double temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetSweepAngle(temp0);
    }
    else
    {
      op->vtkVolumeOfRevolutionFilter::SetSweepAngle(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeOfRevolutionFilter_GetSweepAngleMinValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSweepAngleMinValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeOfRevolutionFilter *op = static_cast<vtkVolumeOfRevolutionFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetSweepAngleMinValue() :
      op->vtkVolumeOfRevolutionFilter::GetSweepAngleMinValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeOfRevolutionFilter_GetSweepAngleMaxValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSweepAngleMaxValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeOfRevolutionFilter *op = static_cast<vtkVolumeOfRevolutionFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetSweepAngleMaxValue() :
      op->vtkVolumeOfRevolutionFilter::GetSweepAngleMaxValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeOfRevolutionFilter_GetSweepAngle(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetSweepAngle");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeOfRevolutionFilter *op = static_cast<vtkVolumeOfRevolutionFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetSweepAngle() :
      op->vtkVolumeOfRevolutionFilter::GetSweepAngle());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeOfRevolutionFilter_SetAxisPosition_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAxisPosition");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeOfRevolutionFilter *op = static_cast<vtkVolumeOfRevolutionFilter *>(vp);

  double temp0;
  double temp1;
  double temp2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
  {
    if (ap.IsBound())
    {
      op->SetAxisPosition(temp0, temp1, temp2);
    }
    else
    {
      op->vtkVolumeOfRevolutionFilter::SetAxisPosition(temp0, temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkVolumeOfRevolutionFilter_SetAxisPosition_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAxisPosition");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeOfRevolutionFilter *op = static_cast<vtkVolumeOfRevolutionFilter *>(vp);

  const int size0 = 3;
  double temp0[3];
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    if (ap.IsBound())
    {
      op->SetAxisPosition(temp0);
    }
    else
    {
      op->vtkVolumeOfRevolutionFilter::SetAxisPosition(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkVolumeOfRevolutionFilter_SetAxisPosition(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 3:
      return PyvtkVolumeOfRevolutionFilter_SetAxisPosition_s1(self, args);
    case 1:
      return PyvtkVolumeOfRevolutionFilter_SetAxisPosition_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetAxisPosition");
  return NULL;
}



static PyObject *
PyvtkVolumeOfRevolutionFilter_GetAxisPosition(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAxisPosition");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeOfRevolutionFilter *op = static_cast<vtkVolumeOfRevolutionFilter *>(vp);

  int sizer = 3;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double *tempr = (ap.IsBound() ?
      op->GetAxisPosition() :
      op->vtkVolumeOfRevolutionFilter::GetAxisPosition());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildTuple(tempr, sizer);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeOfRevolutionFilter_SetAxisDirection_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAxisDirection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeOfRevolutionFilter *op = static_cast<vtkVolumeOfRevolutionFilter *>(vp);

  double temp0;
  double temp1;
  double temp2;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(3) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1) &&
      ap.GetValue(temp2))
  {
    if (ap.IsBound())
    {
      op->SetAxisDirection(temp0, temp1, temp2);
    }
    else
    {
      op->vtkVolumeOfRevolutionFilter::SetAxisDirection(temp0, temp1, temp2);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkVolumeOfRevolutionFilter_SetAxisDirection_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetAxisDirection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeOfRevolutionFilter *op = static_cast<vtkVolumeOfRevolutionFilter *>(vp);

  const int size0 = 3;
  double temp0[3];
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    if (ap.IsBound())
    {
      op->SetAxisDirection(temp0);
    }
    else
    {
      op->vtkVolumeOfRevolutionFilter::SetAxisDirection(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkVolumeOfRevolutionFilter_SetAxisDirection(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 3:
      return PyvtkVolumeOfRevolutionFilter_SetAxisDirection_s1(self, args);
    case 1:
      return PyvtkVolumeOfRevolutionFilter_SetAxisDirection_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetAxisDirection");
  return NULL;
}



static PyObject *
PyvtkVolumeOfRevolutionFilter_GetAxisDirection(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetAxisDirection");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeOfRevolutionFilter *op = static_cast<vtkVolumeOfRevolutionFilter *>(vp);

  int sizer = 3;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    double *tempr = (ap.IsBound() ?
      op->GetAxisDirection() :
      op->vtkVolumeOfRevolutionFilter::GetAxisDirection());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildTuple(tempr, sizer);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeOfRevolutionFilter_SetOutputPointsPrecision(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetOutputPointsPrecision");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeOfRevolutionFilter *op = static_cast<vtkVolumeOfRevolutionFilter *>(vp);

  int temp0;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetOutputPointsPrecision(temp0);
    }
    else
    {
      op->vtkVolumeOfRevolutionFilter::SetOutputPointsPrecision(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeOfRevolutionFilter_GetOutputPointsPrecisionMinValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOutputPointsPrecisionMinValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeOfRevolutionFilter *op = static_cast<vtkVolumeOfRevolutionFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetOutputPointsPrecisionMinValue() :
      op->vtkVolumeOfRevolutionFilter::GetOutputPointsPrecisionMinValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeOfRevolutionFilter_GetOutputPointsPrecisionMaxValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOutputPointsPrecisionMaxValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeOfRevolutionFilter *op = static_cast<vtkVolumeOfRevolutionFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetOutputPointsPrecisionMaxValue() :
      op->vtkVolumeOfRevolutionFilter::GetOutputPointsPrecisionMaxValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkVolumeOfRevolutionFilter_GetOutputPointsPrecision(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOutputPointsPrecision");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkVolumeOfRevolutionFilter *op = static_cast<vtkVolumeOfRevolutionFilter *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetOutputPointsPrecision() :
      op->vtkVolumeOfRevolutionFilter::GetOutputPointsPrecision());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkVolumeOfRevolutionFilter_Methods[] = {
  {"GetClassName", PyvtkVolumeOfRevolutionFilter_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkVolumeOfRevolutionFilter_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkVolumeOfRevolutionFilter_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkVolumeOfRevolutionFilter\nC++: vtkVolumeOfRevolutionFilter *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkVolumeOfRevolutionFilter_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkVolumeOfRevolutionFilter\nC++: vtkVolumeOfRevolutionFilter *SafeDownCast(vtkObject* o)\n\n"},
  {"SetResolution", PyvtkVolumeOfRevolutionFilter_SetResolution, METH_VARARGS,
   "V.SetResolution(int)\nC++: void SetResolution(int)\n\nSet/Get resolution of sweep operation. Resolution controls the\nnumber of intermediate node points.\n"},
  {"GetResolutionMinValue", PyvtkVolumeOfRevolutionFilter_GetResolutionMinValue, METH_VARARGS,
   "V.GetResolutionMinValue() -> int\nC++: int GetResolutionMinValue()\n\nSet/Get resolution of sweep operation. Resolution controls the\nnumber of intermediate node points.\n"},
  {"GetResolutionMaxValue", PyvtkVolumeOfRevolutionFilter_GetResolutionMaxValue, METH_VARARGS,
   "V.GetResolutionMaxValue() -> int\nC++: int GetResolutionMaxValue()\n\nSet/Get resolution of sweep operation. Resolution controls the\nnumber of intermediate node points.\n"},
  {"GetResolution", PyvtkVolumeOfRevolutionFilter_GetResolution, METH_VARARGS,
   "V.GetResolution() -> int\nC++: int GetResolution()\n\nSet/Get resolution of sweep operation. Resolution controls the\nnumber of intermediate node points.\n"},
  {"SetSweepAngle", PyvtkVolumeOfRevolutionFilter_SetSweepAngle, METH_VARARGS,
   "V.SetSweepAngle(float)\nC++: void SetSweepAngle(double)\n\nSet/Get angle of rotation in degrees.\n"},
  {"GetSweepAngleMinValue", PyvtkVolumeOfRevolutionFilter_GetSweepAngleMinValue, METH_VARARGS,
   "V.GetSweepAngleMinValue() -> float\nC++: double GetSweepAngleMinValue()\n\nSet/Get angle of rotation in degrees.\n"},
  {"GetSweepAngleMaxValue", PyvtkVolumeOfRevolutionFilter_GetSweepAngleMaxValue, METH_VARARGS,
   "V.GetSweepAngleMaxValue() -> float\nC++: double GetSweepAngleMaxValue()\n\nSet/Get angle of rotation in degrees.\n"},
  {"GetSweepAngle", PyvtkVolumeOfRevolutionFilter_GetSweepAngle, METH_VARARGS,
   "V.GetSweepAngle() -> float\nC++: double GetSweepAngle()\n\nSet/Get angle of rotation in degrees.\n"},
  {"SetAxisPosition", PyvtkVolumeOfRevolutionFilter_SetAxisPosition, METH_VARARGS,
   "V.SetAxisPosition(float, float, float)\nC++: void SetAxisPosition(double, double, double)\nV.SetAxisPosition((float, float, float))\nC++: void SetAxisPosition(double a[3])\n\n"},
  {"GetAxisPosition", PyvtkVolumeOfRevolutionFilter_GetAxisPosition, METH_VARARGS,
   "V.GetAxisPosition() -> (float, float, float)\nC++: double *GetAxisPosition()\n\n"},
  {"SetAxisDirection", PyvtkVolumeOfRevolutionFilter_SetAxisDirection, METH_VARARGS,
   "V.SetAxisDirection(float, float, float)\nC++: void SetAxisDirection(double, double, double)\nV.SetAxisDirection((float, float, float))\nC++: void SetAxisDirection(double a[3])\n\n"},
  {"GetAxisDirection", PyvtkVolumeOfRevolutionFilter_GetAxisDirection, METH_VARARGS,
   "V.GetAxisDirection() -> (float, float, float)\nC++: double *GetAxisDirection()\n\n"},
  {"SetOutputPointsPrecision", PyvtkVolumeOfRevolutionFilter_SetOutputPointsPrecision, METH_VARARGS,
   "V.SetOutputPointsPrecision(int)\nC++: void SetOutputPointsPrecision(int)\n\nSet/get the desired precision for the output types. See the\ndocumentation for the vtkAlgorithm::DesiredOutputPrecision enum\nfor an explanation of the available precision settings.\n"},
  {"GetOutputPointsPrecisionMinValue", PyvtkVolumeOfRevolutionFilter_GetOutputPointsPrecisionMinValue, METH_VARARGS,
   "V.GetOutputPointsPrecisionMinValue() -> int\nC++: int GetOutputPointsPrecisionMinValue()\n\nSet/get the desired precision for the output types. See the\ndocumentation for the vtkAlgorithm::DesiredOutputPrecision enum\nfor an explanation of the available precision settings.\n"},
  {"GetOutputPointsPrecisionMaxValue", PyvtkVolumeOfRevolutionFilter_GetOutputPointsPrecisionMaxValue, METH_VARARGS,
   "V.GetOutputPointsPrecisionMaxValue() -> int\nC++: int GetOutputPointsPrecisionMaxValue()\n\nSet/get the desired precision for the output types. See the\ndocumentation for the vtkAlgorithm::DesiredOutputPrecision enum\nfor an explanation of the available precision settings.\n"},
  {"GetOutputPointsPrecision", PyvtkVolumeOfRevolutionFilter_GetOutputPointsPrecision, METH_VARARGS,
   "V.GetOutputPointsPrecision() -> int\nC++: int GetOutputPointsPrecision()\n\nSet/get the desired precision for the output types. See the\ndocumentation for the vtkAlgorithm::DesiredOutputPrecision enum\nfor an explanation of the available precision settings.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkVolumeOfRevolutionFilter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkFiltersModelingPython.vtkVolumeOfRevolutionFilter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkVolumeOfRevolutionFilter_StaticNew()
{
  return vtkVolumeOfRevolutionFilter::New();
}

PyObject *PyvtkVolumeOfRevolutionFilter_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkVolumeOfRevolutionFilter_Type, PyvtkVolumeOfRevolutionFilter_Methods,
    "vtkVolumeOfRevolutionFilter",
    PyvtkVolumeOfRevolutionFilter_Doc(), &PyvtkVolumeOfRevolutionFilter_StaticNew);

  PyTypeObject *pytype = &PyvtkVolumeOfRevolutionFilter_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkUnstructuredGridAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkVolumeOfRevolutionFilter_Doc()
{
  static const char *docstring[] = {
    "vtkVolumeOfRevolutionFilter - sweep data about a line to create a\nvolume\n\n",
    "Superclass: vtkUnstructuredGridAlgorithm\n\n",
    "vtkVolumeOfRevolutionFilter is a modeling filter. It takes a\n2-dimensional dataset as input and generates an unstructured grid on\noutput. The input dataset is swept around the axis of rotation to\ncreate dimension-elevated primitives. For example, sweeping a vertex\ncreates a series of lines; sweeping a line creates a series of quads,\netc.\n\n@warning\nThe user must take care to ensure that the axis of",
    " revolution does\nnot cross through the geometry, otherwise there will be intersecting\ncells in the output.\n\n@sa\nvtkRotationalExtrusionFilter\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkVolumeOfRevolutionFilter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkVolumeOfRevolutionFilter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkVolumeOfRevolutionFilter", o) != 0)
  {
    Py_DECREF(o);
  }

}

