// python wrapper for vtkXMLFileReadTester
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkXMLFileReadTester.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkXMLFileReadTester(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkXMLFileReadTester_ClassNew(); }

#ifndef DECLARED_PyvtkXMLParser_ClassNew
extern "C" { PyObject *PyvtkXMLParser_ClassNew(); }
#define DECLARED_PyvtkXMLParser_ClassNew
#endif

static const char **PyvtkXMLFileReadTester_Doc();


static PyObject *
PyvtkXMLFileReadTester_GetClassName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetClassName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkXMLFileReadTester *op = static_cast<vtkXMLFileReadTester *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    const char *tempr = (ap.IsBound() ?
      op->GetClassName() :
      op->vtkXMLFileReadTester::GetClassName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkXMLFileReadTester_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkXMLFileReadTester *op = static_cast<vtkXMLFileReadTester *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkXMLFileReadTester::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkXMLFileReadTester_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkXMLFileReadTester *op = static_cast<vtkXMLFileReadTester *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    vtkXMLFileReadTester *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkXMLFileReadTester::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkXMLFileReadTester_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObject *temp0 = NULL;
  PyObject *result = NULL;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObject"))
  {
    vtkXMLFileReadTester *tempr = vtkXMLFileReadTester::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkXMLFileReadTester_TestReadFile(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "TestReadFile");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkXMLFileReadTester *op = static_cast<vtkXMLFileReadTester *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->TestReadFile() :
      op->vtkXMLFileReadTester::TestReadFile());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkXMLFileReadTester_SetFileName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFileName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkXMLFileReadTester *op = static_cast<vtkXMLFileReadTester *>(vp);

  char *temp0 = NULL;
  PyObject *result = NULL;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetFileName(temp0);
    }
    else
    {
      op->vtkXMLFileReadTester::SetFileName(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkXMLFileReadTester_GetFileName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFileName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkXMLFileReadTester *op = static_cast<vtkXMLFileReadTester *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetFileName() :
      op->vtkXMLFileReadTester::GetFileName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkXMLFileReadTester_GetFileDataType(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFileDataType");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkXMLFileReadTester *op = static_cast<vtkXMLFileReadTester *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetFileDataType() :
      op->vtkXMLFileReadTester::GetFileDataType());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkXMLFileReadTester_GetFileVersion(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFileVersion");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkXMLFileReadTester *op = static_cast<vtkXMLFileReadTester *>(vp);

  PyObject *result = NULL;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetFileVersion() :
      op->vtkXMLFileReadTester::GetFileVersion());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkXMLFileReadTester_Methods[] = {
  {"GetClassName", PyvtkXMLFileReadTester_GetClassName, METH_VARARGS,
   "V.GetClassName() -> string\nC++: const char *GetClassName()\n\n"},
  {"IsA", PyvtkXMLFileReadTester_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: int IsA(const char *name)\n\n"},
  {"NewInstance", PyvtkXMLFileReadTester_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkXMLFileReadTester\nC++: vtkXMLFileReadTester *NewInstance()\n\n"},
  {"SafeDownCast", PyvtkXMLFileReadTester_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObject) -> vtkXMLFileReadTester\nC++: vtkXMLFileReadTester *SafeDownCast(vtkObject* o)\n\n"},
  {"TestReadFile", PyvtkXMLFileReadTester_TestReadFile, METH_VARARGS,
   "V.TestReadFile() -> int\nC++: int TestReadFile()\n\nTry to read the file given by FileName.  Returns 1 if the file is\na VTK XML file, and 0 otherwise.\n"},
  {"SetFileName", PyvtkXMLFileReadTester_SetFileName, METH_VARARGS,
   "V.SetFileName(string)\nC++: void SetFileName(char *)\n\nGet/Set the name of the file tested by TestReadFile().\n"},
  {"GetFileName", PyvtkXMLFileReadTester_GetFileName, METH_VARARGS,
   "V.GetFileName() -> string\nC++: char *GetFileName()\n\nGet/Set the name of the file tested by TestReadFile().\n"},
  {"GetFileDataType", PyvtkXMLFileReadTester_GetFileDataType, METH_VARARGS,
   "V.GetFileDataType() -> string\nC++: char *GetFileDataType()\n\nGet the data type of the XML file tested.  If the file could not\nbe read, returns NULL.\n"},
  {"GetFileVersion", PyvtkXMLFileReadTester_GetFileVersion, METH_VARARGS,
   "V.GetFileVersion() -> string\nC++: char *GetFileVersion()\n\nGet the file version of the XML file tested.  If the file could\nnot be read, returns NULL.\n"},
  {NULL, NULL, 0, NULL}
};

static PyTypeObject PyvtkXMLFileReadTester_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkIOXMLPython.vtkXMLFileReadTester", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_print
  0, // tp_getattr
  0, // tp_setattr
  0, // tp_compare
  PyVTKObject_Repr, // tp_repr
  0, // tp_as_number
  0, // tp_as_sequence
  0, // tp_as_mapping
  0, // tp_hash
  0, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  0, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  0, // tp_clear
  0, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  0, // tp_iter
  0, // tp_iternext
  0, // tp_methods
  0, // tp_members
  PyVTKObject_GetSet, // tp_getset
  0, // tp_base
  0, // tp_dict
  0, // tp_descr_get
  0, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  0, // tp_init
  0, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  0, // tp_is_gc
  0, // tp_bases
  0, // tp_mro
  0, // tp_cache
  0, // tp_subclasses
  0, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkXMLFileReadTester_StaticNew()
{
  return vtkXMLFileReadTester::New();
}

PyObject *PyvtkXMLFileReadTester_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkXMLFileReadTester_Type, PyvtkXMLFileReadTester_Methods,
    "vtkXMLFileReadTester",
    PyvtkXMLFileReadTester_Doc(), &PyvtkXMLFileReadTester_StaticNew);

  PyTypeObject *pytype = &PyvtkXMLFileReadTester_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkXMLParser_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

const char **PyvtkXMLFileReadTester_Doc()
{
  static const char *docstring[] = {
    "vtkXMLFileReadTester - Utility class for vtkXMLReader and subclasses.\n\n",
    "Superclass: vtkXMLParser\n\n",
    "vtkXMLFileReadTester reads the smallest part of a file necessary to\ndetermine whether it is a VTK XML file.  If so, it extracts the file\ntype and version number.\n\n",
    NULL
  };

  return docstring;
}

void PyVTKAddFile_vtkXMLFileReadTester(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkXMLFileReadTester_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkXMLFileReadTester", o) != 0)
  {
    Py_DECREF(o);
  }

}

